# File changed

code = '\n# distutils: language=c++\n# distutils: include_dirs=/opt/ac-library\n# cython: cdivision=True\nfrom libcpp cimport bool\nfrom libcpp.vector cimport vector\ncdef extern from "<atcoder/lazysegtree>" namespace "atcoder" nogil:\n    cdef cppclass lazy_segtree[S, OP, E, F, mapping, composition, id]:\n        lazy_segtree(vector[S] v)\n        void set(int p, S x)\n        S get(int p)\n        S prod(int l, int r)\n        S all_prod()\n        void apply(int p, F f)\n        void apply(int l, int r, F f)\n        int max_right[G](int l)\n        int min_left[G](int r)\ncdef struct s_t:\n    long v, s\nctypedef long f_t\ncdef extern from *:\n    ctypedef int op_t "myop"\n    ctypedef int e_t "mye"\n    ctypedef int m_t "mymapping"\n    ctypedef int c_t "mycomposition"\n    ctypedef int i_t "myid"\n    ctypedef int g_t "myg"\n    cdef s_t myop(s_t a, s_t b) nogil\n    cdef s_t mye() nogil\n    cdef s_t mymapping(f_t f, s_t x) nogil\n    cdef f_t mycomposition(f_t f, f_t g) nogil\n    cdef f_t myid() nogil\n    cdef bool myg(s_t k) nogil\ncdef s_t myop(s_t a, s_t b) nogil:\n    cdef s_t c\n    c.v = (a.v * b.s + b.v) % 998244353\n    c.s = (a.s * b.s) % 998244353\n    return c\ncdef s_t mye() nogil:\n    cdef s_t e\n    e.v = 0\n    e.s = 1\n    return e\ncdef f_t myid() nogil:\n    return -1\ncdef s_t mymapping(f_t f, s_t x) nogil:\n    if f == myid(): return x\n    cdef s_t y\n    y.v = (x.s - 1) * 443664157 * f % 998244353\n    y.s = x.s\n    return y\ncdef f_t mycomposition(f_t f, f_t g) nogil:\n    if f == myid(): return g\n    return f\nfrom libc.stdio cimport getchar, printf\ncdef inline long read() nogil:\n    cdef long b, c = 0\n    while 1:\n        b = getchar() - 48\n        if b < 0: return c\n        c = c * 10 + b\ncdef main():\n    cdef long n = read(), i, l, r, d\n    cdef s_t a\n    a.v = 1\n    a.s = 10\n    cdef lazy_segtree[s_t, op_t, e_t, f_t, m_t, c_t, i_t] *seg = new lazy_segtree[s_t, op_t, e_t, f_t, m_t, c_t, i_t](vector[s_t](n, a))\n    for i in range(read()):\n        l, r, d = read(), read(), read()\n        seg.apply(l - 1, r, d)\n        printf(\'%ld\\n\', seg.all_prod().v)\nmain()\n'
import os, sys
if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    open('solve.pyx', 'w').write(code)
    os.system('cythonize -i -3 -b solve.pyx')
import solve
