# File changed

import networkx as nx
(n, m) = map(int, input().split())
s = []
for _ in range(n):
    s.append(input())
g = nx.DiGraph()
(S, T) = ((n * m), ((n * m) + 1))
(pot, cnt) = (0, 0)
for i in range(n):
    for j in range(m):
        if (s[i][j] == '#'):
            continue
        g.add_edge(((i * m) + j), T, capacity=1, weight=(((n + m) - i) - j))
        if (s[i][j] == 'o'):
            g.add_edge(S, ((i * m) + j), capacity=1, weight=0)
            pot += (((n + m) - i) - j)
            cnt += 1
        if ((i < (n - 1)) and (s[(i + 1)][j] != '#')):
            g.add_edge(((i * m) + j), (((i + 1) * m) + j), capacity=100, weight=0)
        if ((j < (m - 1)) and (s[i][(j + 1)] != '#')):
            g.add_edge(((i * m) + j), (((i * m) + j) + 1), capacity=100, weight=0)
g.add_node(S, demand=(- cnt))
g.add_node(T, demand=cnt)
(ans, _) = nx.algorithms.flow.network_simplex(g)
print((pot - ans))


