package p
251
import numba
from numba import njit, b1, i4, i8, f8
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
MOD = 998244353

@njit((i8, i8), cache=True)
def mpow(a, n):
    p = 1
    while n:
        if (n & 1):
            p = ((p * a) % MOD)
        a = ((a * a) % MOD)
        n >>= 1
    return p

@njit((i8 []],), cache=True)
def build(raw_data):
    bit = raw_data.copy()
    for i in range(len(bit)):
        j = (i + (i & (- i)))
        if (j < len(bit)):
            bit[j] += bit[i]
            bit[j] %= MOD
    return bit

@njit((i8 asc], i8), cache=True)
def get_sum(bit, i):
    s = 0
    while i:
        s += bit[i]
        i -= (i & (- i))
    return (s % MOD)

@njit((i8 asc], i8, i8), cache=True)
def add(bit, i, x):
    while (i < len(bit)):
        bit[i] += x
        bit[i] %= MOD
        i += (i & (- i))

@njit((i8, i8 []]), cache=True)
def main(K, A):
    N = len(A)
    p = ((1 - mpow(K, (MOD - 2))) % MOD)
    p_inv = mpow(p, (MOD - 2))
    bit_active = np.zeros((N + 1), np.int64)
    bit_cnt = np.zeros((N + 1), np.int64)
    half = ((MOD + 1) // 2)
    ans = 0
    ans += (((((