import pytest

def plural(source: str) -> str:
    if source[-1] == 's':
        return source + 'es'

    return source + 's'


@pytest.mark.parametrize('source, expected', [
    ('', 's'),
    ('s', 'ses'),
    ('word', 'words'),
])
def test_plural(source, expected):
    assert plural(source) == expected


def main():
    source = input()
    print(plural(source))


if __name__ == '__main__':
    main()

