'
# File changed

import math

def comb(n, r, mod):
    'Calculates the number of combinations of n items taken r at a time

    Args:
        n (int): The number of items.
        r (int): The number of items taken at a time.
        mod (int): The modulo to perform on the result.

    Returns:
        int: The number of combinations.
    '
    return ((math.factorial(((n + r) - 1)) // (math.factorial((n - 1)) * math.factorial(r))) % mod)
s = int(input())
mod = ((10 ** 9) + 7)
ans = 1
if (s < 3):
    ans = 0
for i in range(2, 700):
    if (s < (3 * i)):
        break
    r = (s - (i * 3))
    ans = ((ans + comb(i, r, mod)) % mod)
print(ans)


