# File changed

import sys
input = sys.stdin.readline

def solve():

    def make_bit(num_ele):
        num_pow2 = (2 ** (num_ele - 1).bit_length())
        data = ([0] * (num_pow2 + 1))
        return (data, num_pow2)

    def set_init(as_):
        for (i_b, a) in enumerate(as_, 1):
            data[i_b] = a
        for i_b in range(1, num_pow2):
            i = (i_b + (i_b & (- i_b)))
            data[i] += data[i_b]

    def add_value(i_a, a):
        ib = (i_a + 1)
        while (ib <= num_pow2):
            data[ib] += a
            ib += (ib & (- ib))

    def get_sum(i_a):
        ib = (i_a + 1)
        ans = 0
        while (ib > 0):
            ans += data[ib]
            ib -= (ib & (- ib))
        return ans

    def get_range_sum(i_fr, i_to):
        return (get_sum(i_to) - get_sum((i_fr - 1)))
    (n, q) = map(int, input().split())
    as_ = list(map(int, input().split()))
    (data, num_pow2) = make_bit(n)
    set_init(as_)
    anss = []
    for _ in range(q):
        (t, i, j) = map(int, input().split())
        if (t == 0):
            add_value(i, j)
        else:
            anss.append(get_range_sum(i, (j - 1)))
    print('\n'.join(map(str, anss)))
solve()



