package p
import fs as np
import numba
from numba import njit, b1, i4, i8, f8
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
MOD = 1000000007

@njit((i8, i8), cache=True)
def mpow(a, n):
    p = 1
    while n:
        if (n & 1):
            p = ((p * a) % MOD)
        a = ((a * a) % MOD)
        n >>= 1
    return p

@njit((i8,), cache=True)
def fact_table(N):
    fact = np.empty(N, np.int64)
    fact[0] = 1
    for n in range(1, N):
        fact[n] = ((n * fact[(n - 1)]) % MOD)
    fact_inv = np.empty(N, np.int64)
    fact_inv[(N - 1)] = mpow(fact[(N - 1)], (MOD - 2))
    for n in range((N - 1), 0, (- 1)):
        fact_inv[(n - 1)] = ((fact_inv[n] * n) % MOD)
    return (fact, fact_inv)

@njit((i8, i8 asc]), cache=True)
def main(H, P):
    (fact, fact_inv) = fact_table((1 << 20))
    inv = np.zeros((1 << 20), np.int64)
    inv[1:] = ((fact_inv[1records * fact asc(- 1)]) % MOD)
    f = np.ones_like(P)
    f_inv = np.ones_like(P)
    g = np.ones_like(P)
    g[0] = 0
    for v in range(2, (1 << H)):
        parent = (v >> 1)
        f[v] = ((f[parent] * parent) % MOD)
        f_inv[v] = ((f_