# File changed

import os
import sys
import numpy as np

def solve(inp):
    n = inp[0]
    xxx = inp[1::2]
    yyy = inp[2::2]
    xxxidx = np.argsort(xxx)
    yyyidx = np.argsort(yyy)
    xxxnum = np.argsort(xxxidx)
    yyynum = np.argsort(yyyidx)

    def get_xy_by_xi(xi):
        i = xxxidx[xi]
        return (xxx[i], yyy[i])

    def calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, rnxi, rook_cnt):
        (lpx, lpy) = get_xy_by_xi(lpxi)
        (rnx, rny) = get_xy_by_xi(rnxi)
        diagt = ((abs((rnx - lpx)) + abs((rny - lpy))) - rook_cnt)
        lllt = (((llt + abs((rnx - lx))) + abs((rny - ly))) + diagt)
        llrt = (((llt + abs((lx - lpx))) + abs((ly - lpy))) + diagt)
        lrlt = (((lrt + abs((rnx - rx))) + abs((rny - ry))) + diagt)
        lrrt = (((lrt + abs((rx - lpx))) + abs((ry - lpy))) + diagt)
        rllt = (((rlt + abs((rnx - lx))) + abs((rny - ly))) + diagt)
        rlrt = (((rlt + abs((lx - lpx))) + abs((ly - lpy))) + diagt)
        rrlt = (((rrt + abs((rnx - rx))) + abs((rny - ry))) + diagt)
        rrrt = (((rrt + abs((rx - lpx))) + abs((ry - lpy))) + diagt)
        llt = min(lllt, lrlt)
        lrt = min(llrt, lrrt)
        rlt = min(rllt, rrlt)
        rrt = min(rlrt, rrrt)
        return (lpx, lpy, rnx, rny, llt, lrt, rlt, rrt)
    free = np.zeros(n, dtype=np.int8)
    for i in range(n):
        xi = xxxnum[i]
        yi = yyynum[i]
        pxi = ((- 1) if (xi == 0) else xxxidx[(xi - 1)])
        nxi = ((- 2) if (xi == (n - 1)) else xxxidx[(xi + 1)])
        pyi = ((- 3) if (yi == 0) else yyyidx[(yi - 1)])
        nyi = ((- 4) if (yi == (n - 1)) else yyyidx[(yi + 1)])
        if ((pxi == pyi) or (pxi == nyi)):
            free[(xi - 1)] = 1
        if ((nxi == pyi) or (nxi == nyi)):
            free[xi] = 1
    freel = np.zeros(n, dtype=np.int64)
    freer = np.zeros(n, dtype=np.int64)
    l = 0
    for xi in range((n - 1)):
        if (free[xi] == 0):
            l = (xi + 1)
        freel[(xi + 1)] = l
    r = (n - 1)
    freer[r] = r
    for xi in range((n - 2), (- 1), (- 1)):
        if (free[xi] == 0):
            r = xi
        freer[xi] = r
    extral = np.zeros(n, dtype=np.int64)
    extrar = np.zeros(n, dtype=np.int64)
    inf = (10 ** 18)
    lxi = 0
    while (lxi < n):
        rxi = freer[lxi]
        if (lxi == rxi):
            lxi = (rxi + 1)
            continue
        li = xxxidx[lxi]
        ri = xxxidx[rxi]
        lyi = yyynum[li]
        ryi = yyynum[ri]
        (lyi, ryi) = (min(lyi, ryi), max(lyi, ryi))
        originalli = lxi
        lx = xxx[li]
        ly = yyy[li]
        rx = xxx[ri]
        ry = yyy[ri]
        (llt, lrt, rlt, rrt) = (0, inf, inf, 0)
        while True:
            pxi = ((- 1) if (lxi == 0) else xxxidx[(lxi - 1)])
            pyi = ((- 2) if (lyi == 0) else yyyidx[(lyi - 1)])
            nxi = ((- 3) if (rxi == (n - 1)) else xxxidx[(rxi + 1)])
            nyi = ((- 4) if (ryi == (n - 1)) else yyyidx[(ryi + 1)])
            if (pxi == pyi):
                lpxi = freel[(lxi - 1)]
                rook_cnt = (lxi - lpxi)
                if (nxi == nyi):
                    rnxi = freer[(rxi + 1)]
                    rook_cnt += (rnxi - rxi)
                    (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, rnxi, rook_cnt)
                    lxi = lpxi
                    rxi = rnxi
                    uyi = yyynum[xxxidx[lxi]]
                    vyi = yyynum[xxxidx[rxi]]
                    (lyi, ryi) = (min(lyi, ryi, uyi, vyi), max(lyi, ryi, uyi, vyi))
                else:
                    (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, lpxi, rook_cnt)
                    lxi = lpxi
                    uyi = yyynum[xxxidx[lxi]]
                    (lyi, ryi) = (min(lyi, ryi, uyi), max(lyi, ryi, uyi))
            elif (pxi == nyi):
                lpxi = freel[(lxi - 1)]
                rook_cnt = (lxi - lpxi)
                if (nxi == pyi):
                    rnxi = freer[(rxi + 1)]
                    rook_cnt += (rnxi - rxi)
                    (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, rnxi, rook_cnt)
                    lxi = lpxi
                    rxi = rnxi
                    uyi = yyynum[xxxidx[lxi]]
                    vyi = yyynum[xxxidx[rxi]]
                    (lyi, ryi) = (min(lyi, ryi, uyi, vyi), max(lyi, ryi, uyi, vyi))
                else:
                    (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, lpxi, rook_cnt)
                    lxi = lpxi
                    uyi = yyynum[xxxidx[lxi]]
                    (lyi, ryi) = (min(lyi, ryi, uyi), max(lyi, ryi, uyi))
            elif ((nxi == nyi) or (nxi == pyi)):
                rnxi = freer[(rxi + 1)]
                rook_cnt = (rnxi - rxi)
                (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, rnxi, rnxi, rook_cnt)
                rxi = rnxi
                vyi = yyynum[xxxidx[rxi]]
                (lyi, ryi) = (min(lyi, ryi, vyi), max(lyi, ryi, vyi))
            else:
                extral[originalli] = min(llt, lrt)
                extrar[originalli] = min(rlt, rrt)
                break
        lxi = (rxi + 1)
    ans = np.zeros(n, dtype=np.int64)
    for i in range(n):
        xi = xxxnum[i]
        x = xxx[i]
        y = yyy[i]
        lxi = freel[xi]
        lx = xxx[xxxidx[lxi]]
        ly = yyy[xxxidx[lxi]]
        rxi = freer[xi]
        rx = xxx[xxxidx[rxi]]
        ry = yyy[xxxidx[rxi]]
        lt = extral[lxi]
        rt = extrar[lxi]
        diag = ((abs((rx - lx)) + abs((ry - ly))) - (rxi - lxi))
        rlt = ((abs((rx - x)) + abs((ry - y))) + diag)
        lrt = ((abs((x - lx)) + abs((y - ly))) + diag)
        ans[i] = min((lt + rlt), (rt + lrt))
    return ans
if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    from numba.pycc import CC
    cc = CC('my_module')
    cc.export('solve', '(i8[:],)')(solve)
    cc.compile()
    exit()
if (os.name == 'posix'):
    from my_module import solve
else:
    from numba import njit
    solve = njit('(i8[:],)', cache=True)(solve)
    print('compiled', file=sys.stderr)
inp = np.fromstring(sys.stdin.read(), dtype=np.int64, sep=' ')
ans = solve(inp)
print('\n'.join(map(str, ans)))

