' Calculate the number of ways to express a number as the sum of three cubes
'
# File changed

N = int(input())
from collections import defaultdict
ansd = defaultdict(int)

def calc(x, y, z):
    'Calculates the sum of three cubes

    Args:
        x (int): The first number.
        y (int): The second number.
        z (int): The third number.

    Returns:
        int: The sum of the three cubes.
    '
    return ((((((x ** 2) + (y ** 2)) + (z ** 2)) + (x * z)) + (y * z)) + (y * x))
for x in range(1, 100):
    for y in range(1, 100):
        for z in range(1, 100):
            ansd[calc(x, y, z)] += 1
for k in range(1, (N + 1)):
    print(ansd[k])


