import sys
import numpy as np
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
mod = 998244353

@numba.njit
def main(A, B, C, D):
    d = np.zeros(((C + 1), (D + 1)), np.int64)
    d[(A, B)] = 1
    for i in range((A + 1), (C + 1)):
        d[(i, B)] = ((B * d[((i - 1), B)]) % mod)
    for j in range((B + 1), (D + 1)):
        d[(A, j)] = ((A * d[(A, (j - 1))]) % mod)
    for i in range((A + 1), (C + 1)):
        for j in range((B + 1), (D + 1)):
            d[(i, j)] = (((((j * d[((i - 1), j)]) % mod) + ((i * d[(i, (j - 1))]) % mod)) % mod) - ((((i - 1) * (((j - 1) * d[((i - 1), (j - 1))]) % mod)) % mod) % mod))
    return (d[(C, D)] % mod)

if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    import numba
    from numba.pycc import CC
    i8 = numba.from_dtype(np.int64)
    signature = (i8, i8, i8, i8)
    cc = CC('my_module')
    cc.export('main', signature)(main)
    cc.compile()
from my_module import main
(A, B, C, D) = map(int, read().split())
print(main(A, B, C, D))

'''
