from itertools import groupby
import numpy as np

def solve(s, k):
    sgrp = []
    for (c, itr) in groupby(s):
        sgrp.append(len(list(itr)))
    if (len(sgrp) == 1):
        return 1
    one_bucket = []
    MOD = 998244353
    if (s[0] == '1'):
        one_bucket.append(sgrp[0])
        sgrp = sgrp[1:]
    else:
        one_bucket.append(0)
    cur = 0
    for l in sgrp:
        if (cur == 0):
            one_bucket.extend(([0] * (l - 1)))
        else:
            one_bucket.append(l)
        cur ^= 1
    k = min(k, sum(one_bucket))
    dp = np.zeros(((k + 1), (k + 1)), dtype=np.int64)
    dp[(0, 0)] = 1
    for (i, c) in enumerate(one_bucket):
        ndp = np.add.accumulate(dp, axis=0)
        if (c > 0):
            for j in range(1, (c + 1)):
                ndp[:, j:] += dp[:, :(- j)]
            ndp = np.tril(ndp)
        dp = (ndp % MOD)
    return (np.diag(dp).sum() % MOD)
(s, k) = input().split()
k = int(k)
print(solve(s, k))

