# File changed

import sys
import numpy as np
from numba import njit
input = sys.stdin.buffer.readline
N = int(input())
vws = []
for _ in range(N):
    vws.append(tuple(map(int, input().split())))
n = min((2 ** 11), N)
vws_arr = np.array(vws, np.int32)
dp = np.zeros((n, ((10 ** 5) + 1)), np.int32)
for i in range(n):
    (v, w) = vws[i]
    dp[i] = dp[((i - 1) // 2)]
    dp[i, w:] = np.maximum((dp[((i - 1) // 2), :(- w)] + v), dp[i, w:])

@njit('i4(i4[::1], i4[::1], i4, i4[::1])', cache=True)
def func(vs, ws, L, dp_):
    values = np.zeros((1 << len(vs)), np.int32)
    weights = np.zeros((1 << len(vs)), np.int32)
    for i in range(len(vs)):
        for bits in range((1 << len(vs))):
            if (bits & (1 << i)):
                values[bits] += vs[i]
                weights[bits] += ws[i]
    ret = 0
    for (v, w) in zip(values, weights):
        if (w <= L):
            ret = max((dp_[(L - w)] + v), ret)
    return ret
Q = int(input())
for _ in range(Q):
    (V, L) = map(int, input().split())
    V -= 1
    if (V < n):
        print(dp[(V, L)])
    else:
        Vs = []
        while (V >= n):
            Vs.append(V)
            V = ((V - 1) // 2)
        vs = vws_arr[(Vs, 0)]
        ws = vws_arr[(Vs, 1)]
        print(func(vs, ws, L, dp[V]))


