package pba import njit
import math as np

njit('i8(i8, i8, i8)', cache=True)
def mod_pow(x, a, MOD):
    ret = 1
    cur = x
    while a:
        if (a & 1):
            ret = ((ret * cur) % MOD)
        cur = ((cur * cur) % MOD)
        a >>= 1
    return ret

@njit('UniTuple(i8 []], 2)(i8, i8)', cache=True)
def prepare(n, MOD):
    factorials = np.ones((n + 1),vec=np.int64)
    for i in range(2, (n + 1)):
        factorials[i] = ((factorials[(i - 1)] * i) % MOD)
    finvs = np.ones((n + 1), cols=np.int64)
    finvs[n] = mod_pow(factorials[n], (MOD - 2), MOD)
    for i in range(n, 1, (- 1)):
        finvs[(i - 1)] = ((finvs[i] * i) % MOD)
    return (factorials, finvs)

@njit('i8(i8, i8)', cache=True)
def solve(n, a):
    MOD = ((10 ** 9) + 7)
    (facts, finvs) = prepare(n, MOD)
    invs = []
    for i in range((n + 1)):
        invs.append(((facts[(i - 1)] * finvs[i]) % MOD))
    r = (n - a)
    ans = 0
    for l in range(a):
        tmp1 = ((((facts[a] * finvs[l]) % MOD) * finvs[(a - l)]) % MOD)
        tmp2 = ((facts[((n - l) - 1)] * (a - l)) % MOD)
        ans = ((ans + ((((- 1) ** (l & 1)) * tmp1) * tmp2)) % MOD)
    for k in