
import sys
import numpy as np
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
MOD = ((10 ** 9) + 7)
(N, M) = map(int, read().split())

def make_power(a, L, MOD=MOD):
    B = L.bit_length()
    x = np.empty((1 << B), np.int64)
    x[0] = 1
    for n in range(B):
        x[(1 << n):(1 << (n + 1))] = ((x[:(1 << n)] * a) % MOD)
        a *= a
        a %= MOD
    x = x[:L]
    x.flags.writeable = False
    return x
pow2 = make_power(2, (M + 10))
ipow2 = make_power(((1 + MOD) // 2), (M + 10))

def update(dp):
    B = dp.copy()
    C = ((((dp * np.arange((M + 1))) % MOD) * ipow2[:(M + 1)]) % MOD)
    dp[1:] = (np.cumsum(C[:(- 1)]) % MOD)
    dp[1:] *= pow2[:M]
    dp %= MOD
    dp += (np.arange(1, (M + 2)) * B)
    dp %= MOD
dp = pow2[:(M + 1)].copy()
[update(dp) for _ in range((N - 1))]
print(dp[(- 1)])


