# File changed

import sys
import numpy as np
from numba import njit
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit('(i8,i4[::1])', cache=True)
def solve(dep, T):
  if dep == 0:
    return np.array([0], np.int32)
  a = np.empty((3**dep), np.int32)
  for d in range(3):
    tt = np.empty_like(T)
    p = 0
    x = d
    for t in T:
      if t == 0:
        x = (3-x) if x else 0
        if p > 0 and tt[(p-1)] == 0:
          p -= 1
        else:
          tt[p] = 0
          p += 1
      else:
        x = (x+1)
        if x == 3:
          x = 0
          tt[p] = 1
          p += 1
    tt = tt[:p]
    a[d::3] = (3*solve((dep-1), tt) + x)
  return a

n = int(readline())
T = np.frombuffer(read().rstrip(), 'S1')
T = (T == b'R').astype(np.int32)
ans = solve(n, T)
print(' '.join(ans.astype(str)))

