# File changed

import sys
import random
import string
debug = False
secretstr = 'Atcod3rIsGreat'
count = 0

def local_str(query: str) -> int:
    import Levenshtein
    return Levenshtein.distance(query, secretstr)

def query_str(query: str) -> int:
    global count
    count += 1
    if debug:
        ans = local_str(query)
        return ans
    else:
        print(('? ' + query))
        ans = int(input())
        if (ans == 0):
            print(('! ' + query))
            sys.exit(0)
        return ans

def guess_length() -> int:
    c = 'a'
    a = query_str(c)
    if (a == 128):
        return 128
    al = query_str((c * a))
    al2 = query_str((c * (a + 1)))
    if (al >= al2):
        return (a + 1)
    else:
        return a

def merge(S: str, T: str) -> str:
    t = 0
    lent = len(T)
    d = query_str(T)
    for (s, c) in enumerate(S):
        while (t < lent):
            l = T[:(t + s)]
            r = T[(s + t):]
            d2 = query_str(((l + c) + r))
            if (d2 < d):
                T = ((l + c) + r)
                d = d2
                break
            t += 1
        if (t == lent):
            T = (T + c)
    return T

def guessing():
    passwordlen = guess_length()
    chars = []
    for c in (string.ascii_letters + string.digits):
        unmatchwordnum = query_str((c * passwordlen))
        if ((passwordlen - unmatchwordnum) > 0):
            chars.append((c * (passwordlen - unmatchwordnum)))
    while (len(chars) > 1):
        chars.sort(key=(lambda x: len(x)))
        m = merge(chars[0], chars[1])
        chars[1] = m
        chars = chars[1:]
    query_str(chars[0])
    return chars[0]
guessing()

def randomname(n):
    randlst = [random.choice((string.ascii_letters + string.digits)) for i in range(n)]
    return ''.join(randlst)

