# B

@pytest.mark.parametrize('K, S, expected', [
    (1, 'a', 'a'),
    (2, 'ab', 'ab'),
    (3, 'abc', 'abc'),
    (4, 'abcd', 'abcd'),
    (5, 'abcde', 'abcde'),
    (6, 'abcdef', 'abcdef'),
    (7, 'abcdefg', 'abcdefg'),
    (8, 'abcdefgh', 'abcdefgh'),
    (9, 'abcdefghi', 'abcdefghi'),
    (10, 'abcdefghij', 'abcdefghij'),
    (11, 'abcdefghijk', 'abcdefghijk'),
    (12, 'abcdefghijkl', 'abcdefghijkl'),
    (13, 'abcdefghijklm', 'abcdefghijklm'),
    (14, 'abcdefghijklmn', 'abcdefghijklmn'),
    (15, 'abcdefghijklmno', 'abcdefghijklmno'),
    (16, 'abcdefghijklmnop', 'abcdefghijklmnop'),
    (17, 'abcdefghijklmnopq', 'abcdefghijklmnopq'),
    (18, 'abcdefghijklmnopqr', 'abcdefghijklmnopqr'),
    (19, 'abcdefghijklmnopqrs', 'abcdefghijklmnopqrs'),
    (20, 'abcdefghijklmnopqrst', 'abcdefghijklmnopqrst'),
    (21, 'abcdefghijklmnopqrstu', 'abcdefghijklmnopqrstu'),
    (22, 'abcdefghijklmnopqrstuv', 'abcdefghijklmnopqrstuv'),
    (23, 'abcdefghijklmnopqrstuvw', 'abcdefghijklmnopqrstuvw'),
    (24, 'abcdefghijklmnopqrstuvwx', 'abcdefghijklmnopqrstuvwx'),
    (25, 'abcdefghijklmnopqrstuvwxy', 'abcdefghijklmnopqrstuvwxy'),
    (26, 'abcdefghijklmnopqrstuvwxyz', 'abcdefghijklmnopqrstuvwxyz'),
    (27, 'abcdefghijklmnopqrstuvwxyzab', 'abcdefghijklmnopqrstuvwxyzab'),
    (28, 'abcdefghijklmnopqrstuvwxyzabc', 'abcdefghijklmnopqrstuvwxyzabc'),
    (29, 'abcdefghijklmnopqrstuvwxyzabcd', 'abcdefghijklmnopqrstuvwxyzabcd'),
    (30, 'abcdefghijklmnopqrstuvwxyzabcde', 'abcdefghijklmnopqrstuvwxyzabcde'),
    (31, 'abcdefghijklmnopqrstuvwxyzabcdef', 'abcdefghijklmnopqrstuvwxyzabcdef'),
    (32, 'abcdefghijklmnopqrstuvwxyzabcdefg', 'abcdefghijklmnopqrstuvwxyzabcdefg'),
    (33, 'abcdefghijklmnopqrstuvwxyzabcdefgh', 'abcdefghijklmnopqrstuvwxyzabcdefgh'),
    (34, 'abcdefghijklmnopqrstuvwxyzabcdefghi', 'abcdefghijklmnopqrstuvwxyzabcdefghi'),
    (35, 'abcdefghijklmnopqrstuvwxyzabcdefghij', 'abcdefghijklmnopqrstuvwxyzabcdefghij'),
    (36, 'abcdefghijklmnopqrstuvwxyzabcdefghijk', 'abcdefghijklmnopqrstuvwxyzabcdefghijk'),
    (37, 'abcdefghijklmnopqrstuvwxyzabcdefghijkl', 'abcdefghijklmnopqrstuvwxyzabcdefghijkl'),
    (38, 'abcdefghijklmnopqrstuvwxyzabcdefghijklm', 'abcdefghijklmnopqrstuvwxyzabcdefghijklm'),
    (39, 'abcdefghijklmnopqrstuvwxyzabcdefghijklmn', 'abcdefghijklmnopqrstuvwxyzabcdefghijklmn'),
    (40, 'abcdefghijklmnopqrstuvwxyzabcdefghijklmno', 'abcdefghijklmnopqrstuvwxyzabcdefghijklmno'),
    (41, 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnop', 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnop'),
    (42, 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopq', 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopq'),
    (43, 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqr', 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqr'),
    (44, 'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrs', 'abcdefgh