from bisect import bisect_left, bisect_right

N, M = map(int, input().split())
A, B, C = [list(map(int, input().split())) for _ in range(N)]
D, E, F = [list(map(int, input().split())) for _ in range(M)]
xs = sorted(set(C))
ys = sorted(set(D))
xguard = [[False] * (len(ys) + 1) for _ in range(len(xs) + 1)]
yguard = [[False] * (len(ys) + 1) for _ in range(len(xs) + 1)]
for a, b, c in zip(A, B, C):
  c = bisect_right(xs, c)
  a = bisect_left(ys, a) + 1
  b = bisect_right(ys, b)
  for y in range(a, b):
    xguard[c][y] = True
for d, e, f in zip(D, E, F):
  d = bisect_right(ys, d)
  e = bisect_left(xs, e) + 1
  f = bisect_right(xs, f)
  for x in range(e, f):
    yguard[x][d] = True
cow = (bisect_right(xs, 0), bisect_right(ys, 0))

def bfs(shape):
  queue = deque()
  queue.append(cow)
  area = 0
  while queue:
    xi, yi = queue.popleft()
    if 0 < xi < len(xs) and 0 < yi < len(ys):
      area += (xs[xi] - xs[xi - 1]) * (ys[yi] - ys[yi - 1])
      if not xguard[xi][yi]:
        queue.append((xi - 1, yi))
      if not xguard[xi + 1][yi]:
        queue.append((xi + 1, yi))
      if not yguard[xi][yi]:
        queue.append((xi, yi - 1))
      if not yguard[xi][yi + 1]:
        queue.append((xi, yi + 1))
    else:
      area = 'INF'
      break
  return area

print(bfs(shape=(len(xs) + 1, len(ys) + 1)))

