import numpy as np

n, m = map(int, input().split())

# 接続道が存在するかを確認するための配列
# 数値が0なら、接続道が無い
no_path = np.zeros(n)

# 道がある場合、標高を格納する配列
path = [[] for i in range(n)]

# 標高
higher = list(map(int, input().split()))

ans = 0

for _ in range(m):
    a, b = map(int, input().split())
    no_path[a - 1] = 1
    no_path[b - 1] = 1

    path[a - 1].append(higher[b - 1])
    path[b - 1].append(higher[a - 1])

ans = ans + n - np.count_nonzero(no_path)

for idx, _path in enumerate(path):
    if len(_path) > 0 and higher[idx] > max(_path):
        ans += 1

print(ans)

