' Calculates the combination of n and m
'
# File changed


def combination(n, a, mod):
    'Calculates the combination of n and a

    Args:
        n (int): The number of items.
        a (int): The number of items to choose from n.
        mod (int): The modulo to perform the calculation with.

    Returns:
        int: The combination of n and a.
    '
    x = 1
    y = 1
    for i in range(a):
        x = ((x * (n - i)) % mod)
        y = ((y * (a - i)) % mod)
    return ((x * pow(y, (mod - 2), mod)) % mod)
(n, m) = map(int, input().split())
ans = (combination(n, 2, (pow(10, 9) + 7)) + combination(m, 2, (pow(10, 9) + 7)))
print(ans)


