import pytest

@pytest.mark.parametrize("n, expected", [
    (1, "a"),
    (2, "ab"),
    (3, "abc"),
    (4, "abcd"),
    (5, "abcde"),
    (6, "abcdef"),
    (7, "abcdefg"),
    (8, "abcdefgh"),
    (9, "abcdefghi"),
    (10, "abcdefghij"),
    (11, "abcdefghijk"),
    (12, "abcdefghijkl"),
    (13, "abcdefghijklm"),
    (14, "abcdefghijklmn"),
    (15, "abcdefghijklmno"),
    (16, "abcdefghijklmnop"),
    (17, "abcdefghijklmnopq"),
    (18, "abcdefghijklmnopqr"),
    (19, "abcdefghijklmnopqrs"),
    (20, "abcdefghijklmnopqrst"),
    (21, "abcdefghijklmnopqrstu"),
    (22, "abcdefghijklmnopqrstuv"),
    (23, "abcdefghijklmnopqrstuvw"),
    (24, "abcdefghijklmnopqrstuvwx"),
    (25, "abcdefghijklmnopqrstuvwxy"),
    (26, "abcdefghijklmnopqrstuvwxyz"),
])
def test_dfs(n, expected):
    dfs(n, expected)

def dfs(s, mx):
    if len(s) == n:
        print(s)
        return
    
    for c in range(ord("a"), mx+2):
        t = s
        t += chr(c)
        dfs(t, max(mx, c))

