def solve(A,B,C,D, level):
    E = 3**level
    if level == -1:
        return int(abs(A-C) + abs(B-D))
    a,b,c,d = A//E, B//E, C//E, D//E
    if a != c and b != d:
        return int(abs(A-C) + abs(B-D))

    if a == c and b==d:
        return solve(A,B,C,D,level-1)

    if a != c and b==d:
        A,B,C,D = B,A,D,C
        a,b,c,d = b,a,d,c

    if b != d and a == c:
        if a%3 != 1:
            return solve(A,B,C,D,level-1)
        if abs(b-d) == 1:
            return solve(A,B,C,D,level-1)

        if B > D:
            A, B, C, D = C, D, A, B
            a, b, c, d = c, d, a, b

        x = E * a -1
        y1 = E * (b+1) -1
        y2 = E * d
        d = abs(x-A) + abs(y1-B) + abs(y1-y2) + abs(x-C) + abs(y2-D)
        x = E *(a+1)
        d2 = abs(x-A) + abs(y1-B) + abs(y1-y2) + abs(x-C) + abs(y2-D)
        return min(d,d2)

@pytest.mark.parametrize('A,B,C,D,level,expected', [
    (1, 1, 1, 1, -1, 0),
    (1, 1, 1, 1, 0, 0),
    (1, 1, 1, 1, 1, 0),
    (1, 1, 1, 1, 2, 0),
    (1, 1, 1, 1, 3, 0),
    (1, 1, 1, 1, 4, 0),
    (1, 1, 1, 1, 5, 0),
    (1, 1, 1, 1, 6, 0),
    (1, 1, 1, 1, 7, 0),
    (1, 1, 1, 1, 8, 0),
    (1, 1, 1, 1, 9, 0),
    (1, 1, 1, 1, 10, 0),
    (1, 1, 1, 1, 11, 0),
    (1, 1, 1, 1, 12, 0),
    (1, 1, 1, 1, 13, 0),
    (1, 1, 1, 1, 14, 0),
    (1, 1, 1, 1, 15, 0),
    (1, 1, 1, 1, 16, 0),
    (1, 1, 1, 1, 17, 0),
    (1, 1, 1, 1, 18, 0),
    (1, 1, 1, 1, 19, 0),
    (1, 1, 1, 1, 20, 0),
    (1, 1, 1, 1, 21, 0),
    (1, 1, 1, 1, 22, 0),
    (1, 1, 1, 1, 23, 0),
    (1, 1, 1, 1, 24, 0),
    (1, 1, 1, 1, 25, 0),
    (1, 1, 1, 1, 26, 0),
    (1, 1, 1, 1, 27, 0),
    (1, 1, 1, 1, 28, 0),
    (1, 1, 1, 1, 29, 0),
    (1, 1, 1, 1, 30, 0),
    (1, 1, 1, 1, 31, 0),
    (1, 1, 1, 1, 32, 0),
    (1, 1, 1, 1, 33, 0),
    (1, 1, 1, 1, 34, 0),
    (1, 1, 1, 1, 35, 0),
    (1, 1, 1, 1, 36, 0),
    (1, 1, 1, 1, 37, 0),
    (1, 1, 1, 1, 38, 0),
    (1, 1, 1, 1, 39, 0),
    (1, 1, 1, 1, 40, 0),
    (1, 1, 1, 1, 41, 0),
    (1, 1, 1, 1, 42, 0),
    (1, 1, 1, 1, 43, 0),
    (1, 1, 1, 1, 44, 0),
    (1, 1, 1, 1, 45, 0),
    (1, 1, 1, 1, 46, 0),
    (1, 1, 1, 1, 47, 0),
    (1, 1, 1, 1, 48, 