import pytest

def test_that_input_is_a_string():
    with pytest.raises(TypeError):
        len(set(list(1)))

def test_that_input_is_not_empty():
    with pytest.raises(TypeError):
        len(set(list('')))

def test_that_input_is_a_string_of_length_one():
    assert len(set(list('a'))) == 1

def test_that_input_is_a_string_of_length_two():
    assert len(set(list('ab'))) == 2

def test_that_input_is_a_string_of_length_three():
    assert len(set(list('abc'))) == 3

def test_that_input_is_a_string_of_length_four():
    assert len(set(list('abcd'))) == 4

def test_that_input_is_a_string_of_length_five():
    assert len(set(list('abcde'))) == 5

def test_that_input_is_a_string_of_length_six():
    assert len(set(list('abcdef'))) == 6

def test_that_input_is_a_string_of_length_seven():
    assert len(set(list('abcdefg'))) == 7

def test_that_input_is_a_string_of_length_eight():
    assert len(set(list('abcdefgh'))) == 8

def test_that_input_is_a_string_of_length_nine():
    assert len(set(list('abcdefghi'))) == 9

def test_that_input_is_a_string_of_length_ten():
    assert len(set(list('abcdefghij'))) == 10

def test_that_input_is_a_string_of_length_eleven():
    assert len(set(list('abcdefghijk'))) == 11

def test_that_input_is_a_string_of_length_twelve():
    assert len(set(list('abcdefghijkl'))) == 12

