import pytest

@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def s():
    return [input() for _ in range(n)]

def test_that_the_most_frequent_strings_are_printed(n, s):
    d = {}
    m = 0
    for x in s:
        if x in d:
            d[x] += 1
            m = max(m, d[x])
        else:
            d[x] = 0
    for x in sorted({k:v for k, v in d.items() if v == m}.keys()):
        print(x)

