# File changed

import sys
sysread = sys.stdin.readline
read = sys.stdin.read
sys.setrecursionlimit((10 ** 7))
import bisect

def run():
    n, m = map(int, sysread().split())
    ab = []
    for _ in range(n):
        ab.append(list(map(int, sysread().split())))
    ab = sorted(ab, key=(lambda x: x[0]))
    A = [a for (a, _) in ab]
    B = (([0] + [b for (_, b) in ab]) + [0])
    intb = [abs((B[idx] - B[(idx - 1)])) for idx in range(1, (n + 2))]
    to = [[] for _ in range((n + 1))]
    for i in range(m):
        l, r = map(int, sysread().split())
        l = bisect.bisect_left(A, l)
        r = bisect.bisect_right(A, r)
        if (l == r):
            continue
        to[l].append((i, r))
        to[r].append((i, l))
    seen = ([False] * (n + 1))

    def dfs(node, to, stack):
        seen[node] = True
        stack.append(node)
        for (_, n_node) in to[node]:
            if (not seen[n_node]):
                dfs(n_node, to, stack)
    trees = []
    for k in range((n + 1)):
        tmpstack = []
        if (not seen[k]):
            dfs(k, to, tmpstack)
            trees.append(tmpstack)
            ret = 0
            for v in tmpstack:
                ret += intb[v]
            if ((ret % 2) != 0):
                print((- 1))
                return None
    seen2 = ([False] * (n + 1))
    codeids = []
    for tree in trees:
        while tree:
            cur = tree.pop()
            seen2[cur] = True
            for id, next in to[cur]:
                if (not seen2[next]):
                    if (intb[cur] == 1):
                        codeids.append(id)
                        intb[cur] = 0
                        intb[next] = abs((intb[next] - 1))
                    break
    print(len(codeids))
    print(' '.join(list(map(str, sorted([(h + 1) for h in codeids])))))
if (__name__ == '__main__'):
    run()

