# File changed

import sys
sysread = sys.stdin.readline
read = sys.stdin.read
sys.setrecursionlimit((10 ** 7))
import bisect

def run():
    (N, M) = map(int, sysread().split())
    AB = []
    for _ in range(N):
        AB.append(list(map(int, sysread().split())))
    AB = sorted(AB, key=(lambda x: x[0]))
    A = [a for (a, _) in AB]
    B = (([0] + [b for (_, b) in AB]) + [0])
    intB = [abs((B[idx] - B[(idx - 1)])) for idx in range(1, (N + 2))]
    to = [[] for _ in range((N + 1))]
    for i in range(M):
        (l, r) = map(int, sysread().split())
        l = bisect.bisect_left(A, l)
        r = bisect.bisect_right(A, r)
        if (l == r):
            continue
        to[l].append((i, r))
        to[r].append((i, l))
    seen = ([False] * (N + 1))

    def dfs(node, to, stack):
        seen[node] = True
        stack.append(node)
        for (_, n_node) in to[node]:
            if (not seen[n_node]):
                dfs(n_node, to, stack)
    trees = []
    for k in range((N + 1)):
        tmp_stack = []
        if (not seen[k]):
            dfs(k, to, tmp_stack)
            trees.append(tmp_stack)
            ret = 0
            for v in tmp_stack:
                ret += intB[v]
            if ((ret % 2) != 0):
                print((- 1))
                return None
    seen2 = ([False] * (N + 1))
    code_ids = []
    for tree in trees:
        while tree:
            cur = tree.pop()
            seen2[cur] = True
            for (id, next) in to[cur]:
                if (not seen2[next]):
                    if (intB[cur] == 1):
                        code_ids.append(id)
                        intB[cur] = 0
                        intB[next] = abs((intB[next] - 1))
                    break
    print(len(code_ids))
    print(' '.join(list(map(str, sorted([(h + 1) for h in code_ids])))))
if (__name__ == '__main__'):
    run()
