' File changed

import sys
read = sys.stdin.read

def main():
    'Main function

    Args:
        h (int): The height of the wall.
        n (int): The number of bricks.
        m (list): A list of tuples containing the width and height of each brick.

    Returns:
        int: The minimum number of bricks needed to cover the wall.
    '
    (h, n) = map(int, input().split())
    m = map(int, read().split())
    mm = zip(m, m)
    large_num = (10 ** 9)
    dp = ([large_num] * ((h + (10 ** 4)) + 1))
    dp[0] = 0
    for (a, b) in mm:
        for i1 in range((h + 1)):
            if (dp[(i1 + a)] > (dp[i1] + b)):
                dp[(i1 + a)] = (dp[i1] + b)
    r = min(dp[h:])
    print(r)
if (__name__ == '__main__'):
    main()


