import functools
import fractions
import pytest
N = int(input())
A = [int(i) for i in input().split()]
S = set(A)


mod = 10**9 + 7


def multiple(a, b):
    return a*b // fractions.gcd(a, b)


def lcm(nums):
    return functools.reduce(multiple, nums)


lcm = lcm(S)

ans = 0
for a in A:
    ans += lcm//a
    # ans %= mod
print(ans % mod)


@pytest.mark.parametrize('N', [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
def test_multiple(N):
    assert (multiple(N, N) == N)


@pytest.mark.parametrize('N', [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
def test_lcm(N):
    assert (lcm(N) == N)


@pytest.mark.parametrize('N', [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
def test_ans(N):
    assert (ans == 0)


@pytest.mark.parametrize('N', [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
def test_mod(N):
   