# File changed


def tentousu(a):
    'Calculates the number of inversions in the given array

    Args:
        a (list): The array to check for inversions.

    Returns:
        int: The number of inversions.
    '
    ans = 0
    for i in range(len(a)):
        for j in range((i + 1), len(a)):
            if (a[i] > a[j]):
                ans += 1
    return ans


n = int(input())
'The number of elements in the array
'
a = list(map(int, input().split()))
'The first array of numbers
'
b = list(map(int, input().split()))
'The second array of numbers
'
for i in range(1, n, 2):
    (a[i], b[i]) = (b[i], a[i])
'Swaps the elements of the arrays
'
ans = inf = float('inf')
'The answer and the maximum value
'
for i in range((2 ** n)):
    s = bin(i)[2:].zfill(n)
    'The binary representation of the current number
'
    if (s.count('0') != (n // 2)):
        continue
    'If the number of 0s is not equal to half the number of elements, continue
'
    if ((s.count('1') != (n // 2)) and (s.count('1') != ((n // 2) + 1))):
        continue
    'If the number of 1s is not equal to half the number of elements or half the number of elements + 1, continue
'
    ac = []
    bc = []
    for j in range(n):
        if (s[j] == '1'):
            ac.append((a[j], j))
        else:
            bc.append((b[j], j))
    'Creates two arrays, one with the elements of a and one with the elements of b
'
    ac.sort()
    bc.sort()
    'Sorts the arrays
'
    x = []
    for j in range(n):
        if (j % 2):
            x.append(bc[(j // 2)])
        else:
            x.append(ac[(j // 2)])
    'Creates a new array with the elements of a and b in the correct order
'
    f = False
    for j in range(1, n):
        if (x[(j - 1)][0] > x[j][0]):
            f = True
    'Checks if the array is sorted
'
    if f:
        continue
    'If the array is not sorted, continue
'
    m = []
    for j in range(n):
        m.append(x[j][1])
    'Creates a new array with the indices of the elements of the original array
'
    ans = min(ans, tentousu(m))
    'Calculates the number of inversions in the new array
'
if (ans == inf):
    ans = (- 1)
'If the answer is still the maximum value, set it to -1
'
print(ans)