# File changed

import os
import sys
if os.getenv('LOCAL'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit((10 ** 9))
inf = float('inf')
iinf = (10 ** 18)
mod = ((10 ** 9) + 7)

def argsort(li, key=None, reverse=False):
    return [i for (_, i) in sorted([(a, i) for (i, a) in enumerate(li)], key=((lambda t: key(t[0])) if key else None), reverse=reverse)]
(n, m) = list(map(int, sys.stdin.buffer.readline().split()))
D = list(map(int, sys.stdin.buffer.readline().split()))
vu = [list(map(int, sys.stdin.buffer.readline().split())) for _ in range(m)]
graph = [[] for _ in range(n)]
for (i, (v, u)) in enumerate(vu):
    v -= 1
    u -= 1
    graph[v].append(u)
    graph[u].append(v)
edges = {}
colors = ([None] * n)
for v in argsort(D):
    d = D[v]
    if (colors[v] is not None):
        continue
    for u in graph[v]:
        if (colors[u] is not None):
            edges[(v, u)] = d
            colors[v] = (not colors[u])
            break
        if (D[u] == d):
            edges[(v, u)] = d
            colors[v] = True
            colors[u] = False
            break
    if (colors[u] is None):
        print((- 1))
        exit()
s = ''
for c in colors:
    s += ('B' if c else 'W')
ans = []
for (v, u) in vu:
    v -= 1
    u -= 1
    if ((v, u) in edges):
        ans.append(edges[(v, u)])
    elif ((u, v) in edges):
        ans.append(edges[(u, v)])
    else:
        ans.append((10 ** 9))
print(s)
print(*ans, sep='\n')

