def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def lcm(a, b):
    return a * b // gcd(a, b)

def exp2(k):
    p = 0
    while k % 2 == 0:
        k //= 2
        p += 1
    return p


@pytest.mark.parametrize('N, M, A, expected', [
    (1, 1, [1], 1),
    (2, 2, [1, 1], 1),
    (2, 2, [1, 2], 0),
    (2, 2, [2, 2], 0),
    (2, 2, [2, 3], 0),
    (2, 2, [3, 3], 0),
    (2, 2, [3, 4], 0),
    (2, 2, [4, 4], 0),
    (2, 2, [4, 5], 0),
    (2, 2, [5, 5], 0),
    (2, 2, [5, 6], 0),
    (2, 2, [6, 6], 0),
    (2, 2, [6, 7], 0),
    (2, 2, [7, 7], 0),
    (2, 2, [7, 8], 0),
    (2, 2, [8, 8], 0),
    (2, 2, [8, 9], 0),
    (2, 2, [9, 9], 0),
    (2, 2, [9, 10], 0),
    (2, 2, [10, 10], 0),
    (2, 2, [10, 11], 0),
    (2, 2, [11, 11], 0),
    (2, 2, [11, 12], 0),
    (2, 2, [12, 12], 0),
    (2, 2, [12, 13], 0),
    (2, 2, [13, 13], 0),
    (2, 2, [13, 14], 0),
    (2, 2, [14, 14], 0),
    (2, 2,