' File changed


def gcd(a, b):
    ' Calculates the greatest common divisor of a and b

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The greatest common divisor of a and b.
    '
    while (b != 0):
        (a, b) = (b, (a % b))
    return a

def lcm(a, b):
    ' Calculates the least common multiple of a and b

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The least common multiple of a and b.
    '
    return ((a * b) // gcd(a, b))

def exp2(k):
    ' Calculates the power of 2 of k

    Args:
        k (int): The number to calculate the power of 2 of.

    Returns:
        int: The power of 2 of k.
    '
    p = 0
    while ((k % 2) == 0):
        k //= 2
        p += 1
    return p
(N, M) = map(int, input().split())
A = [(int(a) // 2) for a in input().split()]
l = 1
flg = 0
already = set()
for a in A:
    already.add(exp2(a))
    if (len(already) > 1):
        flg = 1
        break
    l = lcm(l, a)
if (flg == 1):
    ans = 0
else:
    ans = (((M // l) + 1) // 2)
print(ans)


