import sys
read = sys.stdin.read

def mod_pow(a, p, mod):
  if p == 0:
    return 1
  elif p % 2 == 1:
    return a * mod_pow(a, p - 1, mod)
  else:
    return (mod_pow(a, p // 2, mod) ** 2) % mod

(N, *C) = map(int, read().split())
mod = 10**9 + 7
C.sort(reverse=True)
n = mod_pow(4, N - 1, mod)
answer = 0
for i, c in enumerate(C, 2):
  answer += i * c
  if answer > mod:
    answer %= mod
answer *= n
answer %= mod
print(answer)



