import pytest

@pytest.mark.parametrize('n, expected', [
    (100, 93),
    (108, 100),
    (1000, 937),
    (1000000, 937514),
])
def test_that_it_works(n, expected):
    x = int(n / 1.08)
    if int(x * 1.08) == n:
        assert x == expected
    elif int((x+1) * 1.08) == n:
        assert x+1 == expected
    else:
        assert False

