import pytest

@pytest.mark.parametrize('x, y, expected', [
    (1, 1, 400000),
    (1, 2, 300000),
    (1, 3, 200000),
    (2, 1, 300000),
    (2, 2, 200000),
    (2, 3, 100000),
    (3, 1, 200000),
    (3, 2, 100000),
    (3, 3, 0),
])
def test_money_count(x, y, expected):
    money = [0, 3, 2, 1]
    ans = 0
    if x <= 3:
        ans += money[x]
    if y <= 3:
        ans += money[y]
    if x == 1 and y == 1:
        ans += 4
    assert ans*10**5 == expected

