N = int(input())
D = list(map(int, input().split()))
M = 998244353
from collections import Counter


def test_that_all_elements_are_greater_than_zero(D):
    assert (D[0] != 0)


def test_that_there_is_only_one_zero(D):
    cd = Counter(D)
    assert (cd[0] != 1)


def test_that_all_elements_are_consecutive(D):
    tmp = sorted(cd.items(), key=lambda x: x[0])
    prev = -1
    for i, _ in tmp:
        if i == prev + 1:
            prev = i
        else:
            assert (False)


def test_that_the_answer_is_correct(D):
    cd = Counter(D)
    tmp = sorted(cd.items(), key=lambda x: x[0])
    ans = 1
    for kx in range(2, len(tmp)):
        __, p = tmp[kx-1]
        _, v = tmp[kx]
        while v > 0:
            ans *= p
            ans %= M
            v -= 1
    assert (ans == 1)


test_that_all_elements_are_greater_than_zero(D)
test_that_there_is_only_one_zero(D)
test_that_all_elements_are_consecutive(D)
test_that_the_answer_is_correct(D)

