# File changed

import sys
from numpy import argmin
from scipy.sparse import csr_matrix
from scipy.sparse.csgraph import floyd_warshall
input = sys.stdin.buffer.readline
problemb = False
(v, e) = map(int, input().split())
vfrom = []
vto = []
cost = []
for _ in range(e):
  (u, v, d) = map(int, input().split())
  vfrom.append(u)
  vto.append(v)
  cost.append(d)
graph = csr_matrix((cost, (vfrom, vto)), [(v + 1), (v + 1)])
(dist, predecessors) = floyd_warshall(graph, directed=False, return_predecessors=True)
dist[(dist == 0)] = float('inf')
distmin = list(map(argmin, dist))
if problemb:
  input()
tmax = int(input())
time = 0
delivering = False
returning = False
lastreturntime = 0
distination = 1
vnext = 1
order = []
endorder = set()

def take_order():
  global order
  n = int(input())
  t = [int(input().split()[1]) for _ in range(n)]
  order.append(t)
  if problemb:
    input()
    [input() for _ in range(int(input()))]

def time_next():
  global time, order
  time += 1
  if (time < tmax):
    take_order()

def print_flush(value):
  print(value, flush=True)
  if problemb:
    input()
    [input() for _ in range(int(input()))]

take_order()
while (time < tmax):
  if delivering:
    print_flush(vnext)
    remainingnext -= 1
    if (remainingnext == 0):
      if (vnext == 1):
        lastreturntime = max(lastreturntime, (time - 205))
      endorder.add(vnext)
      nexttemp = predecessors[(distination, vnext)]
      if (nexttemp != (-9999)):
        remainingnext = dist[(vnext, nexttemp)]
        vnext = nexttemp
    remaininglast -= 1
    if (remaininglast == 0):
      if (distination == 1):
        returning = False
        delivering = False
      elif (not returning):
        idx = jdx = (-1)
        disttempminpossession = (10**18)
        disttempminnotpossession = (10**18)
        for (i, o) in enumerate(order):
          if (not o):
            continue
          if (i <= lastreturntime):
            for (j, dst) in enumerate(o):
              if (dst in endorder):
                o[j] = 0
              else:
                disttemp = dist[(vnext, dst)]
                if (disttemp < disttempminpossession):
                  disttempminpossession = disttemp
                  idx = i
                  jdx = j
          else:
            for dst in o:
              # 現在地から店 + 店から配達場所までの時間
              # Waiting time とかいうのがあるのでなんか重みを良い感じにする
              dist_temp = dist[v_next, 1] + dist[1, dst] + abs(time - i)**9
              if dist_temp < dist_temp_min_not_possession:
                dist_temp_min_not_possession = dist_temp
        endorder = set()
        if (disttempminpossession < disttempminnotpossession):
          distination = order[idx].pop(jdx)
          remaininglast = dist[(vnext, distination)]
          nexttemp = predecessors[(distination, vnext)]
          remainingnext = dist[(vnext, nexttemp)]
          vnext = nexttemp
        else:
          returning = True
          remaininglast = dist[(distination, 1)]
          vnext = predecessors[(1, distination)]
          remainingnext = dist[(distination, vnext)]
          distination = 1
    time_next()
  else:
    lastreturntime = time
    idx = jdx = (-1)
    remaininglast = 0
    disttempmin = (10**18)
    for (i, o) in enumerate(order):
      if (not o):
        continue
      for (j, dst) in enumerate(o):
        disttemp = (dist[(1, dst)] + (abs((time - i))**2))
        if (disttemp < disttempmin):
          disttempmin = disttemp
          idx = i
          jdx = j
    if (idx == (-1)):
      print_flush((-1))
      time_next()
      continue
    distination = order[idx].pop(jdx)
    remaininglast = dist[(1, distination)]
    vnext = predecessors[(distination, 1)]
    remainingnext = dist[(1, vnext)]
    delivering = True



