# File changed

from scipy.sparse.csgraph import floyd_warshall
import sys
input = sys.stdin.readline
(n, m, l) = map(int, input().split())
inf = float('inf')
graph = [[inf] * n for _ in range(n)]
for i in range(n):
    graph[i][i] = 0
for _ in range(m):
    (a, b, c) = map(int, input().split())
    (a, b) = (a - 1, b - 1)
    if c <= l:
        graph[a][b] = c
        graph[b][a] = c
distance = floyd_warshall(graph, directed=False)
graph = [[inf] * n for _ in range(n)]
for i in range(n):
    for j in range(n):
        if distance[i][j] <= l:
            graph[i][j] = 1
supply = floyd_warshall(graph, directed=False)
q = int(input())
for _ in range(q):
    (s, t) = map(int, input().split())
    if distance[(s - 1)][(t - 1)] == inf:
        print((-1))
    else:
        print((int(supply[(s - 1)][(t - 1)]) - 1))



