import numpy as np
from scipy.sparse import csr_matrix
from scipy.sparse.csgraph import floyd_warshall


@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def s():
    return list()

@pytest.fixture
def i():
    return range(n)

@pytest.fixture
def x():
    return list(input())

@pytest.fixture
def s(i, x):
    return [int(x) for x in x]

@pytest.fixture
def s(n, s):
    return np.array(s)

@pytest.fixture
def d(s):
    return floyd_warshall(csr_matrix(s))

@pytest.fixture
def c(d, n):
    return d[:, np.argmax(d) % n]

@pytest.fixture
def i():
    return range(n)

@pytest.fixture
def j():
    return range(i+1, n)

@pytest.fixture
def s(i, j):
    return s[i, j]

@pytest.fixture
def r(d):
    return int(np.amax(d)+1)

def test_that_graph_is_connected(n, s, c, r):
    for i in range(n):
        for j in range(i+1, n):
            if (s[i, j] == 1) and abs(c[i] - c[j]) != 1:
                assert r == -1

