# File changed


def make_divisors(n):
    'Returns a list of divisors for a given number

    Args:
        n (int): The number to find divisors for.

    Returns:
        list: A list of divisors.
    '
    divisors = []
    for i in range(1, (int((n ** 0.5)) + 1)):
        if ((n % i) == 0):
            divisors.append(i)
            if (i != (n // i)):
                divisors.append((n // i))
    divisors.sort()
    return divisors

def is_remainder(n):
    'Checks if a number is a remainder

    Args:
        n (int): The number to check.

    Returns:
        bool: True if the number is a remainder, False otherwise.
    '
    if (n == 1):
        return True
    for i in range(2, (int((n ** 0.5)) + 1)):
        if ((n % i) == 0):
            return False
    return True
(A, B) = [int(i) for i in input().split()]
import fractions
n = fractions.gcd(A, B)
divisors = make_divisors(n)
N = len(divisors)
count = 0
flag = ([0] * N)
for item in divisors:
    if is_remainder(item):
        count += 1
print(count)


