import pytest


@pytest.fixture
def n_m():
    return map(int, input().split(" "))


@pytest.fixture
def a_m():
    return [0] * m


@pytest.fixture
def b_m():
    return [0] * m


@pytest.fixture
def c():
    return list()


@pytest.fixture
def d():
    return list()


def to_int(c):
    a = [0, 1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048]
    result = 0
    for ci in c:
        result += a[ci]
    return result


@pytest.fixture
def state():
    return [-1] * 2 ** n


@pytest.fixture
def state_0():
    return 0


@pytest.mark.parametrize("i", range(m))
def test_to_int(c_i):
    assert to_int(c_i)


@pytest.mark.parametrize("j", range(0, 2 ** n))
def test_state(j, state_j, d_i):
    assert state[j] != -1 and (state[j | d[i]] == -1 or state[j | d[i]] > state[j] + a[i])


@pytest.mark.parametrize("i", range(m))
def test_state_2(i, a_i, b_i, c_i, d_i):
    assert state[j | d[i]] = state[j] + a[i]


@pytest.mark.parametrize("i", range(m))
def test_d(i, d_i):
    assert d_i


@pytest.mark.parametrize("i", range(m))
def test_state_3(i, state_2_n_minus_1):
    assert state[2 ** n - 1]


@pytest.mark.parametrize("i", range(m))
def test_print(i, state_2_n_minus_1):
    print(state[2 ** n - 1])


