# File changed


def make_prime_checker(n):
    isprime = ([False, True, False, False, False, True] * ((n // 6) + 1))
    del isprime[(n + 1):]
    isprime[1:4] = (False, True, True)
    for i in range(5, (int((n ** 0.5)) + 1)):
        if isprime[i]:
            isprime[(i * i)::i] = ([False] * (((n // i) - i) + 1))
    return isprime

def make_modinv_list(n, mod=((10 ** 9) + 7)):
    modinv = [0, 1]
    for i in range(2, (n + 1)):
        modinv.append((mod - (((mod // i) * modinv[(mod % i)]) % mod)))
    return modinv

def main():
    mod = 998244353
    maxa = (10 ** 6)
    N = int(input())
    A = list(map(int, input().split()))
    primes = [p for (p, is_prime) in enumerate(make_prime_checker(maxa)) if is_prime]
    g = ([0] * (maxa + 1))
    for a in A:
        g[a] += a
    for p in primes:
        for k in range((maxa // p), 0, (- 1)):
            g[k] += g[(k * p)]
    g = [((v * v) % mod) for v in g]
    for p in primes:
        for (k, g_kp) in enumerate(g[p::p], 1):
            g[k] -= g_kp
    modinvlist = make_modinv_list(maxa, mod)
    ans = sum((((gg * minv) % mod) for (gg, minv) in zip(g, modinvlist)))
    ans %= mod
    ans -= sum(A)
    ans *= modinvlist[2]
    ans %= mod
    print(ans)
main()

