import pytest

@pytest.mark.parametrize('N, A, expected', [
    (1, [1], 1),
    (2, [1, 2], 3),
    (3, [1, 2, 3], 6),
    (4, [1, 2, 3, 4], 10),
    (5, [1, 2, 3, 4, 5], 15),
    (6, [1, 2, 3, 4, 5, 6], 21),
    (7, [1, 2, 3, 4, 5, 6, 7], 28),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 36),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 45),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 55),
])
def test_min_sum(N, A, expected):
    assert sum(A) == expected

