# File changed


class Bit():

    def __init__(self, n):
        self.size = n
        self.tree = ([0] * (n + 1))

    def sum(self, i):
        s = 0
        while (i > 0):
            s += self.tree[i]
            i -= (i & (- i))
        return s

    def add(self, i, x):
        while (i <= self.size):
            self.tree[i] += x
            i += (i & (- i))
(N, k) = map(int, input().split())
a = list(map(int, input().split()))
mod = ((10 ** 9) + 7)

def inv(X):
    b = Bit((2000 + 1))
    inv = 0
    for i in range(len(X)):
        inv += (i - b.sum(X[i]))
        b.add(X[i], 1)
    return inv
ainv = (inv(a) % mod)
a2inv = (inv((a * 2)) % mod)
print((((k * ainv) + (((k * (k - 1)) // 2) * (a2inv - (2 * ainv)))) % mod))

