import sys
readline = sys.stdin.readline
readlines = sys.stdin.readlines
sys.setrecursionlimit(10**7)
(n, h, w) = map(int, readline().split())
rca = [tuple((int(x) for x in line.split())) for line in readlines()]
rca.sort(key=(lambda x: (- x[2])))
rca
root = list(range((h + w)))
size = ([0] * (h + w))
nocycle = ([True] * (h + w))

def find_root(x):
    y = root[x]
    if x == y:
        return y
    z = find_root(y)
    root[x] = z
    return z

def merge(x, y):
    (x, y) = (find_root(x), find_root(y))
    (sx, sy) = (size[x], size[y])
    if sx < sy:
        (sx, sy) = (sy, sx)
        (x, y) = (y, x)
    root[y] = x
    nocycle[x] = (nocycle[x] and nocycle[y])
answer = 0
for (R, C, A) in rca:
    (x, y) = ((R - 1), ((h + C) - 1))
    (rx, ry) = (find_root(x), find_root(y))
    if rx == ry:
        if not nocycle[rx]:
            continue
        nocycle[rx] = False
    else:
        if (not nocycle[rx]) and (not nocycle[ry]):
            continue
        merge(rx, ry)
    answer += A
print(answer)



