# File changed

import sys
input = sys.stdin.readline
sys.setrecursionlimit((10 ** 7))
'\n正則二部グラフの辺彩色\n'
import numpy as np
(n, m) = map(int, input().split())
grid = [[int(x) for x in input().split()] for _ in range(n)]
edge = []
for (i, row) in enumerate(grid):
    for (j, x) in enumerate(row):
        edge.append((((x - 1) // m), (n + i)))
graph = [dict() for _ in range((n + n))]
restcolor = [set(range(m)) for _ in range((n + n))]
for (u, v) in edge:
    common = (restcolor[u] & restcolor[v])
    if common:
        c = common.pop()
        graph[u][c] = v
        graph[v][c] = u
        restcolor[u].remove(c)
        restcolor[v].remove(c)
        continue
    c = restcolor[u].pop()
    d = restcolor[v].pop()
    cd = (c + d)
    V = [u, v]
    nextc = c
    while (nextc not in restcolor[v]):
        v = graph[v][nextc]
        V.append(v)
        nextc = (cd - nextc)
    restcolor[v].remove(nextc)
    restcolor[v].add((cd - nextc))
    for (i, (u, v)) in enumerate(zip(V, V[1:])):
        if ((i % 2) == 0):
            graph[u][c] = v
            graph[v][c] = u
        else:
            graph[u][d] = v
            graph[v][d] = u
after = [([None] * m) for _ in range(n)]
for (i, row) in enumerate(grid):
    modtox = [[] for _ in range(n)]
    for x in row:
        modtox[((x - 1) // m)].append(x)
    for color in range(m):
        after[i][color] = modtox[graph[(i + n)][color]].pop()
b = np.array(after)
C = b.copy()
C.sort(axis=0)
print('\n'.join((' '.join(row) for row in b.astype(str))))
print('\n'.join((' '.join(row) for row in C.astype(str))))

