import pytest

@pytest.mark.parametrize('n, k, s, expected', [
    (1, 1, 'a', 'a'),
    (2, 2, 'ab', 'ab'),
    (3, 3, 'abc', 'abc'),
    (4, 4, 'abcd', 'abcd'),
    (5, 5, 'abcde', 'abcde'),
    (6, 6, 'abcdef', 'abcdef'),
    (7, 7, 'abcdefg', 'abcdefg'),
    (8, 8, 'abcdefgh', 'abcdefgh'),
    (9, 9, 'abcdefghi', 'abcdefghi'),
    (10, 10, 'abcdefghij', 'abcdefghij'),
    (11, 11, 'abcdefghijk', 'abcdefghijk'),
    (12, 12, 'abcdefghijkl', 'abcdefghijkl'),
    (13, 13, 'abcdefghijklm', 'abcdefghijklm'),
    (14, 14, 'abcdefghijklmn', 'abcdefghijklmn'),
    (15, 15, 'abcdefghijklmno', 'abcdefghijklmno'),
    (16, 16, 'abcdefghijklmnop', 'abcdefghijklmnop'),
    (17, 17, 'abcdefghijklmnopq', 'abcdefghijklmnopq'),
    (18, 18, 'abcdefghijklmnopqr', 'abcdefghijklmnopqr'),
    (19, 19, 'abcdefghijklmnopqrs', 'abcdefghijklmnopqrs'),
    (20, 20, 'abcdefghijklmnopqrst', 'abcdefghijklmnopqrst'),
    (21, 21, 'abcdefghijklmnopqrstu', 'abcdefghijklmnopqrstu'),
    (22, 22, 'abcdefghijklmnopqrstuv', 'abcdefghijklmnopqrstuv'),
    (23, 23, 'abcdefghijklmnopqrstuvw', 'abcdefghijklmnopqrstuvw'),
    (24, 24, 'abcdefghijklmnopqrstuvwx', 'abcdefghijklmnopqrstuvwx'),
    (25, 25, 'abcdefghijklmnopqrstuvwxy', 'abcdefghijklmnopqrstuvwxy'),
    (26, 26, 'abcdefghijklmnopqrstuvwxyz', 'abcdefghijklmnopqrstuvwxyz'),
    (27, 27, 'abcdefghijklmnopqrstuvwxyz0', 'abcdefghijklmnopqrstuvwxyz0'),
    (28, 28, 'abcdefghijklmnopqrstuvwxyz01', 'abcdefghijklmnopqrstuvwxyz01'),
    (29, 29, 'abcdefghijklmnopqrstuvwxyz012', 'abcdefghijklmnopqrstuvwxyz012'),
    (30, 30, 'abcdefghijklmnopqrstuvwxyz0123', 'abcdefghijklmnopqrstuvwxyz0123'),
    (31, 31, 'abcdefghijklmnopqrstuv