import numpy as np

def make_divisors(n):
    divisors = []
    for i in range(1, int(n**0.5)+1):
        if n % i == 0:
            divisors.append(i)
            if i != n // i:
                divisors.append(n//i)
    # divisors.sort()
    return divisors

@pytest.mark.parametrize('n, k, a, ans', [
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),
    (5, 3, [1, 2, 3, 4, 5], 3),