' Calculates the least common multiple of two numbers
'
import fractions

def lcm(x, y):
    ' Calculates the least common multiple of two numbers

    Args:
        x (int): The first number.
        y (int): The second number.

    Returns:
        int: The least common multiple of the two numbers.
    '
    return ((x * y) // fractions.gcd(x, y))
(A, B, C, D) = map(int, input().split())
E = lcm(C, D)

def mulc(t):
    ' Calculates the number of multiples of a number in a range

    Args:
        t (int): The number to find the multiples of.

    Returns:
        int: The number of multiples of the number in the range.
    '
    return ((B // t) - ((A - 1) // t))
print((((((B - A) + 1) - mulc(C)) - mulc(D)) + mulc(E)))


