' File changed


def f(n, m):
    'Performs an RSI analysis on the historical data

    Args:
        n (int): The number of data points to consider for
            our RSI.
        m (int): The indicator line to check hot/cold
            against.

    Returns:
        pandas.DataFrame: A dataframe containing the indicators and hot/cold values.
    '
    s = list(input().split())
    t = list(input().split())
    dp = [([1] * (m + 1)) for _ in range((n + 1))]
    for (i, sk) in enumerate(s):
        dpi1 = dp[(i + 1)] = dp[i][:]
        cs = 0
        for (j, tk) in enumerate(t):
            if (sk == tk):
                cs = ((cs + dp[i][j]) % md)
            dpi1[(j + 1)] = ((dpi1[(j + 1)] + cs) % md)
    print(dp[(- 1)][(- 1)])
md = ((10 ** 9) + 7)
(n, m) = map(int, input().split())
f(n, m)


