def power(a, b):
  if b == 0:
    return 1
  elif b == 1:
    return a % 1000000007
  elif (b % 2) == 0:
    return (power(a, b // 2) ** 2) % 1000000007
  else:
    return ((power(a, b // 2) ** 2) * a) % 1000000007

def divide(a, b):
  return ((a * power(b, 1000000005)) % 1000000007)

faclim = 200000
fac = [None] * (faclim + 1)
fac[0] = 1
for i in range(faclim):
  fac[i + 1] = (fac[i] * (i + 1)) % 1000000007
facinv = [None] * (faclim + 1)
facinv[faclim] = power(fac[faclim], 1000000005)
for i in range(faclim, 0, -1):
  facinv[i - 1] = ((facinv[i] * i) % 1000000007)

def conv(a, b):
  return (((fac[a] * facinv[(a - b)]) * facinv[b]) % 1000000007)

mod = 1000000007
n, m, k = (int(i) for i in input().split())
midn = 0
midm = 0
if n > 1:
  for i in range(1, n):
    midn += ((i * (n - i)) * 2)
    midn %= mod
  midn = divide(midn, (n ** 2))
else:
  midn = 0
if m > 1:
  for i in range(1, m):
    midm += ((i * (m - i)) * 2)
    midm %= mod
  midm = divide(midm, (m ** 2))
else:
  midm = 0
kt = ((midn + midm) * (n * m))
kt = divide(kt, ((n * m) - 1))
pt = conv((n * m), k)
ans = ((kt * pt) % mod)
ans = (((ans * k) * (k - 1)) % mod)
ans = divide(ans, 2)
print((ans % mod))

