from collections import deque

@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def es(n):
    return [[] for _ in range(n)]

@pytest.fixture
def s():
    return 0

@pytest.fixture
def ans(n):
    return [None] * n

@pytest.fixture
def dq():
    return deque()

@pytest.mark.asyncio
async def test_that_api_returns_some_results(n, es, s, ans, dq):
    for _ in range(n - 1):
        u, v, w = map(int, input().split())
        u -= 1
        v -= 1
        es[u].append((v, w))
        es[v].append((u, w))

    ans[s] = 0
    dq.append(s)

    while dq:
        v = dq.popleft()
        for nv, w in es[v]:
            if ans[nv] is None:
                ans[nv] = (ans[v] + w) % 2
                dq.append(nv)
    print(*ans, sep='\n')

