import pytest

@pytest.mark.parametrize("b, expected", [
    ("T", "A"),
    ("A", "T"),
    ("C", "G"),
    ("G", "C"),
])
def test_that_complement_of_a_dna_string_is_correct(b, expected):
    assert (b"A" if b == b"T" else b"T" if b == b"A" else b"G" if b == b"C" else b"C") == expected

