import pytest

@pytest.mark.parametrize('a, b, k, expected', [
    (1, 1, 1, 1),
    (1, 2, 1, 1),
    (2, 1, 1, 1),
    (2, 2, 1, 2),
    (2, 2, 2, 1),
    (2, 3, 1, 1),
    (2, 3, 2, 2),
    (2, 3, 3, 3),
    (2, 3, 4, 1),
    (2, 4, 1, 1),
    (2, 4, 2, 2),
    (2, 4, 3, 4),
    (2, 4, 4, 1),
    (2, 5, 1, 1),
    (2, 5, 2, 2),
    (2, 5, 3, 4),
    (2, 5, 4, 5),
    (2, 5, 5, 1),
    (2, 6, 1, 1),
    (2, 6, 2, 2),
    (2, 6, 3, 4),
    (2, 6, 4, 5),
    (2, 6, 5, 6),
    (2, 6, 6, 1),
    (2, 7, 1, 1),
    (2, 7, 2, 2),
    (2, 7, 3, 4),
    (2, 7, 4, 5),
    (2, 7, 5, 6),
    (2, 7, 6, 7),
    (2, 7, 7, 1),
    (2, 8, 1, 1),
    (2, 8, 2, 2),
    (2, 8, 3, 4),
    (2, 8, 4, 5),
    (2, 8, 5, 6),
    (2, 8, 6, 7),
    (2, 8, 7, 8),
    (2, 8, 8, 1),
    (2, 9, 1, 1),
    (2, 9, 2, 2),
    (2, 9, 3, 4),
    (2, 9, 4, 5),
    (2, 9, 5, 6),
    (2, 9, 6, 7),
    (2, 9, 7, 8),
    (2, 9, 8, 9),
    (2, 9, 9, 1),
    (2, 10, 1, 1),
    (2, 10, 2, 2),
    (2, 10, 3, 4),
    (2, 10, 4, 5),
    (2, 10, 5, 6),
    (2, 10, 6, 7),
    (2, 10, 7, 8),
    (2, 10, 8, 9),
    (2, 10, 9, 10),
    (2, 10, 10, 1),
    (3, 1, 1, 1),
    (3, 2, 1, 1),
    (3, 2, 2, 2),
    (3, 3, 1, 1),
    (3, 3, 2, 3),
    (3, 3, 3, 1),
    (3, 4, 1, 1),
    (3, 4, 2, 2),
    (3, 4, 3, 3),
    (3, 4, 4, 