import pytest
N=int(input())
tmplist=list(map(int,input().split(" ")))
tmplist.sort()
tmplist.reverse()
def gcd(a,b):
    while b!=0:
        a,b=b,a%b
    return a
res=tmplist[0]
for a in range(1,N):
    res=gcd(tmplist[a],res)
print(res)

@pytest.mark.parametrize("N,tmplist,res", [
    (1, [1], 1),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 1),
    (4, [1, 2, 3, 4], 1),
    (5, [1, 2, 3, 4, 5], 1),
    (6, [1, 2, 3, 4, 5, 6], 1),
    (7, [1, 2, 3, 4, 5, 6, 7], 1),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 1),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 1),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 1),
])
def test_gcd(N, tmplist, res):
    assert gcd(tmplist[0], res) == res

