import pytest

@pytest.mark.parametrize("N, L, expected", [
    (1, [1], "Yes"),
    (2, [1, 2], "No"),
    (3, [1, 2, 3], "Yes"),
    (4, [1, 2, 3, 4], "No"),
    (5, [1, 2, 3, 4, 5], "Yes"),
    (6, [1, 2, 3, 4, 5, 6], "No"),
    (7, [1, 2, 3, 4, 5, 6, 7], "Yes"),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], "No"),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], "Yes"),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], "No"),
])
def test_that_max_is_less_than_sum_of_others(N, L, expected):
    l = max(L)
    L.remove(l)
    if l < sum(L):
        assert "Yes" == expected
    else:
        assert "No" == expected

