import pytest

@pytest.mark.parametrize('n, m, x, expected', [
    (1, 1, [1], 0),
    (2, 2, [1, 2], 1),
    (3, 3, [1, 2, 3], 2),
    (4, 4, [1, 2, 3, 4], 3),
    (5, 5, [1, 2, 3, 4, 5], 4),
    (6, 6, [1, 2, 3, 4, 5, 6], 5),
    (7, 7, [1, 2, 3, 4, 5, 6, 7], 6),
    (8, 8, [1, 2, 3, 4, 5, 6, 7, 8], 7),
    (9, 9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 8),
    (10, 10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 9),
])
def test_that_the_correct_answer_is_returned(n, m, x, expected):
    assert (sum(sorted(x)[n-1:]) == expected)

