# File changed

mod = 10**9+7

def mul(a, b):
  return [[(sum(((aij * bij) for (aij, bij) in zip(ai, bi))) % mod) for bi in zip(*b)] for ai in a]

def pow(b, k):
  r = [[(1 if (i == j) else 0) for i in range(len(b))] for j in range(len(b))]
  while k:
    if k&1:
      r = mul(r, b)
    k >>= 1
    b = mul(b, b)
  return r

def main():
  n, K = map(int, input().split())
  A = []
  for i in range(n):
    A.append(map(int, input().split()))
  A = [i for i in zip(*A)]
  v = [[1]*n]
  return (sum(mul(v, pow(A, K))[0]) % mod)

print(main())

