# File changed

import sys
from itertools import accumulate
import numpy as np
mod = 1000000007

def solve(N: int, s: str):
    dp = np.zeros((N, (N + 1)), dtype=np.int64)
    dp[0][1] = 1
    for i in range(1, N):
        acc = np.cumsum(dp[(i - 1)])
        if (s[(i - 1)] == '<'):
            dp[i][1:(i + 2)] = np.mod(acc[:(i + 1)], mod)
        else:
            dp[i][1:(i + 2)] = np.mod((acc[(i + 1)] - acc[:(i + 1)]), mod)
    print(np.mod(dp[(N - 1)].sum(), mod))
    return

def main():

    def iterate_tokens():
        for line in sys.stdin:
            for word in line.split():
                (yield word)
    tokens = iterate_tokens()
    N = int(next(tokens))
    s = next(tokens)
    solve(N, s)
if (__name__ == '__main__'):
    main()

