import sys
input = sys.stdin.readline

def solve(N, mod):
  g = [[] for _ in range(N+1)]
  for _ in range(N-1):
    x, y = map(int, input().split())
    g[x].append(y)
    g[y].append(x)
  g[0].append(1)
  g[1].append(0)
  dp1 = [0] * (N+1)
  parent = [-1] * (N+1)
  parent[1] = 0
  order = []
  order.append(1)
  stack = [1]
  while stack:
    x = stack.pop()
    order.append(x)
    for next_ in g[x]:
      if next_ == parent[x]:
        continue
      parent[next_] = x
      stack.append(next_)
  dp1[0] = 0
  dp1[1] = 0
  for v in order[::-1]:
    tmp = 1
    for next_ in g[v]:
      tmp *= (dp1[next_] + 1)
      tmp %= mod
    dp1[v] = tmp
  dp2 = [1] * (N+1)
  for x in order:
    n = len(g[x])
    lst1 = [1] * (n+1)
    lst2 = [1] * (n+1)
    for i in range(n):
      if g[x][i] == parent[x]:
        lst1[i+1] = (lst1[i] * dp2[x]) % mod
      else:
        lst1[i+1] = (lst1[i] * (dp1[g[x][i]] + 1)) % mod
      if g[x][(n-1)-i] == parent[x]:
        lst2[(n-i)-1] = (lst2[(n-i)] * dp2[x]) % mod
      else:
        lst2[(n-i)-1] = (lst2[(n-i)] * (dp1[g[x][(n-1)-i]] + 1)) % mod
    for i in range(n):
      if g[x][i] == parent[x]:
        continue
      tmp = (lst1[i] * lst2[i+1]) % mod
      tmp += 1
      dp2[g[x][i]] = tmp
  for i in range(1, N+1):
    print((dp1[i] * dp2[i]) % mod)

N, mod = map(int, input().split())
solve(N, mod)

