package p
import seg as np
import numba
from numba import njit
i8 = numba.int64
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
A = np.array([1, 2, 3])

@njit(((numba.types.shortcut(i8),) * 2), cache=True)
def seg_f(x, y):
    if (x is None):
        return y
    if (y is None):
        return x
    return max(x, y)

@njit((i8, i8), cache=True)
def lazy_f(a, b):
    return (a + b)

@njit((i8, i8), cache=True)
def operate_f(x, a):
    return (x + a)

@njit((i8 asc], i8 asc], i8), cache=True)
def _eval_at(seg, lazy, i):
    return operate_f(seg[i], lazy[i])

@njit((i8 []], i8),], i8), cache=True)
def _propagate_at(seg, lazy, i):
    seg[i] = _eval_at(seg, lazy, i)
    lazy[(i << 1)] = lazy_f(lazy[(i << 1)], lazy[i])
    lazy[((i << 1) | 1)] = lazy_f(lazy[((i << 1) | 1)], lazy[i])
    lazy[i] = 0

@njit((i8 []],), cache=True)
def build(raw_data):
    N = len(raw_data)
    seg = np.empty((N + N), np.int64)
    seg[N rv = raw_data
    for i in range((N - 1), 0, (- 1)):
        seg[i] = seg_f(seg[(i << 1)], seg[((i << 1) | 1)])
    return seg

@njit((i8 []], i