import sys
input = sys.stdin.readline
sys.setrecursionlimit((10 ** 7))
import numpy as np
mod = 10**9+7
(h, w, N) = map(int, input().split())
(R, C) = np.array((sys.stdin.read().split() + [h, w]), dtype=np.int64).reshape((N+1), 2).T
ind = np.argsort(((R<<32)+C))
R = R[ind]
C = C[ind]

def cumprod(arr):
  l = len(arr)
  lsq = int(((l**0.5)+1))
  arr = np.resize(arr, (lsq**2)).reshape(lsq, lsq)
  for n in range(1, lsq):
    arr[:, n] *= arr[:, (n-1)]
    arr[:, n] %= mod
  for n in range(1, lsq):
    arr[n] *= arr[((n-1), (-1))]
    arr[n] %= mod
  return arr.ravel()[:l]

u = 2*10**5+10
x = np.arange(u, dtype=np.int64)
x[0] = 1
fact = cumprod(x)
x = np.arange(u, 0, -1, dtype=np.int64)
x[0] = pow(int(fact[-1]), (mod-2), mod)
factinv = cumprod(x)[::-1]
dp = np.zeros((N+1), dtype=np.int64)
dp += ((((fact[((R+C)-2)] * factinv[(R-1)]) % mod) * factinv[(C-1)]) % mod)
for i, (r, c) in enumerate(zip(R, C)):
  j = np.where((((R<=r) & (C<=c)) & ((R+C)<(r+c))))
  dx, dy = r-R[j], c-C[j]
  dp[i] -= ((((((dp[j] * fact[(dx+dy)]) % mod) * factinv[dx]) % mod) * factinv[dy]) % mod).sum()
  dp[i] %= mod

answer = dp[-1]
print(answer)

