import pytest

@pytest.mark.parametrize("n, expected", [
    ("2222", 4),
    ("1111", 0),
    ("1234", 1),
    ("1112", 1),
    ("1222", 3),
    ("1234", 1),
    ("1122", 2),
    ("1234", 1),
    ("1111", 0),
    ("1234", 1),
])
def test_count_2s(n, expected):
    count = 0
    for i in range(4):
        if n[i] == "2":
            count += 1
    assert count == expected

