import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
sys.setrecursionlimit((10 ** 7))
import numpy as np

N, d = map(int, readline().split())
xy = np.array(list(map(int, read().split())))
a = np.zeros((d, d), np.int64)
X = xy[::2]
y = xy[1::2]
np.add.at(a, ((X % d), (y % d)), 1)
maxa = a.max()
n = int(((maxa - 1) ** 0.5))
aa = np.tile(a, (2, 2))
gr1 = (aa > (n * n)).cumsum(axis=0).cumsum(axis=1)
gr2 = (aa > (n * (n + 1))).cumsum(axis=0).cumsum(axis=1)

def test(x):
  gr1rd = (((gr1[(d:(d + d), d:(d + d))] + gr1[(x:(x + d), x:(x + d))]) - gr1[(x:(x + d), d:(d + d))]) - gr1[(d:(d + d), x:(x + d))])
  conditionrd = (gr1rd == 0)
  gr2ru = (((gr2[(x:(x + d), d:(d + d))] + gr2[(0:d, x:(x + d))]) - gr2[(x:(x + d), x:(x + d))]) - gr2[(0:d, d:(d + d))])
  gr2ld = (((gr2[(d:(d + d), x:(x + d))] + gr2[(x:(x + d), 0:d)]) - gr2[(x:(x + d), x:(x + d))]) - gr2[(d:(d + d), 0:d)])
  conditionru = (gr2ru == 0)
  conditionld = (gr2ld == 0)
  return ((conditionrd & conditionru) & conditionld).any()

left = 0
right = d
while ((left + 1) < right):
  mid = ((left + right) // 2)
  if test(mid):
    right = mid
  else:
    left = mid

answer = (((n * d) + right) - 1)
print(answer)

