import pytest

@pytest.mark.parametrize('n, T, ct, expected', [
    (1, 1, [[1, 1]], [1]),
    (2, 2, [[1, 1], [2, 2]], [1, 2]),
    (3, 3, [[1, 1], [2, 2], [3, 3]], [1, 2, 3]),
    (4, 4, [[1, 1], [2, 2], [3, 3], [4, 4]], [1, 2, 3, 4]),
    (5, 5, [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5]], [1, 2, 3, 4, 5]),
    (6, 6, [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6]], [1, 2, 3, 4, 5, 6]),
    (7, 7, [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7]], [1, 2, 3, 4, 5, 6, 7]),
    (8, 8, [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8]], [1, 2, 3, 4, 5, 6, 7, 8]),
    (9, 9, [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8], [9, 9]], [1, 2, 3, 4, 5, 6, 7, 8, 9]),
    (10, 10, [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8], [9, 9], [10, 10]], [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]),
])
def test_that_api_returns_some_results(n, T, ct, expected):
    ct = sorted(ct)
    for c, t in ct:
        if t<=T:
            assert c == expected[0]
            expected = expected[1:]
            if not expected:
                return
    assert False
    print('TLE')

