' Find the maximum number of divisors
'
import math

def find_max_divisors(n, m):
    'Find the maximum number of divisors

    Args:
        n (int): The number of divisors to find.
        m (int): The number to find the divisors of.

    Returns:
        int: The maximum number of divisors.
    '
    divisor = []
    n = int(math.sqrt(m))
    for i in range(1, (n + 1)):
        if ((m % i) == 0):
            tmp = (m // i)
            if (not (i in divisor)):
                divisor.append(i)
            if (not (tmp in divisor)):
                divisor.append(tmp)
    maximize = 0
    threshold = (m // n)
    for item in divisor:
        if ((item <= threshold) and (maximize < item)):
            maximize = item
    return maximize


(n, m) = map(int, input().split())
if (n == 1):
    print(m)
else:
    print(find_max_divisors(n, m))


