import math

def get_primes(n):
  primes = []
  checks = [True for _ in range((int(math.sqrt(n)) + 1))]
  checks[0] = checks[1] = False
  for i in range(2, len(checks)):
    if checks[i]:
      primes.append(i)
      tmp = 0
      while ((i + (tmp * i)) < len(checks)):
        checks[(i + (tmp * i))] = False
        tmp += 1
  return primes

def combination(a, b):
  i = 1
  for _i in range(((a - b) + 1), (a + 1)):
    i *= _i
  return (i // math.factorial(b))

(n, m) = map(int, input().split())
primes = get_primes(m)
elems = []
mcopy = m
divides = {}
for _p in primes:
  while ((mcopy % _p) == 0):
    mcopy = (mcopy // _p)
    if (str(_p) in divides.keys()):
      divides[str(_p)] += 1
    else:
      divides[str(_p)] = 1
if (mcopy > 1):
  divides[str(mcopy)] = 1
ans = 1
for i in divides.values():
  ans *= combination(((i + n) - 1), i)
print((ans % 1000000007))



