import pytest

@pytest.mark.parametrize('n, w, expected', [
    (1, ['a'], 'Yes'),
    (2, ['ab', 'ba'], 'Yes'),
    (2, ['ab', 'bc'], 'No'),
    (3, ['abc', 'bcd', 'cde'], 'Yes'),
    (3, ['abc', 'bcd', 'cde'], 'No'),
])
def test_that_words_can_be_rearranged(n, w, expected):
    if len(set(w)) != len(w):
        assert expected == 'No'
    else:
        for i in range(n-1):
            if w[i][-1] != w[i+1][0]:
                assert expected == 'No'
                break
        else:
            assert expected == 'Yes'

