' Finds the greatest common factor of a list of numbers
'
import fractions as math

def find_gcf(numbers):
    'Finds the greatest common factor of a list of numbers

    Args:
        numbers (list): A list of numbers to find the GCF of.

    Returns:
        int: The GCF of the list of numbers.
    '
    gcf = numbers[0]
    for d in numbers[1:]:
        gcf = math.gcd(gcf, d)
    return gcf

(N, X) = map(int, input().split())
x = list(map(int, input().split()))
x.append(X)
x.sort()
diff = [(x[i] - x[(i - 1)]) for i in range(1, len(x))]
print(find_gcf(diff))


