import pytest

@pytest.mark.parametrize('n,k,expected', [
    (1, 1, 1),
    (2, 2, 8),
    (3, 3, 27),
    (4, 4, 64),
    (5, 5, 125),
    (6, 6, 216),
    (7, 7, 343),
    (8, 8, 512),
    (9, 9, 729),
    (10, 10, 1000),
])
def test_that_api_returns_some_results(n, k, expected):
    m1 = n//k
    ans = m1**3
    if k%2 != 0:
        assert ans == expected
    else:
        m2 = (n//(int(k/2))) - m1
        ans += m2**3
        assert ans == expected

