import pytest

@pytest.mark.parametrize('n,k,expected', [
    (1, 1, 1),
    (2, 1, 2),
    (3, 1, 3),
    (4, 1, 4),
    (5, 1, 5),
    (6, 1, 6),
    (7, 1, 7),
    (8, 1, 8),
    (9, 1, 9),
    (10, 1, 10),
    (1, 2, 1),
    (2, 2, 2),
    (3, 2, 3),
    (4, 2, 4),
    (5, 2, 5),
    (6, 2, 6),
    (7, 2, 7),
    (8, 2, 8),
    (9, 2, 9),
    (10, 2, 10),
    (1, 3, 1),
    (2, 3, 2),
    (3, 3, 3),
    (4, 3, 4),
    (5, 3, 5),
    (6, 3, 6),
    (7, 3, 7),
    (8, 3, 8),
    (9, 3, 9),
    (10, 3, 10),
    (1, 4, 1),
    (2, 4, 2),
    (3, 4, 3),
    (4, 4, 4),
    (5, 4, 5),
    (6, 4, 6),
    (7, 4, 7),
    (8, 4, 8),
    (9, 4, 9),
    (10, 4, 10),
    (1, 5, 1),
    (2, 5, 2),
    (3, 5, 3),
    (4, 5, 4),
    (5, 5, 5),
    (6, 5, 6),
    (7, 5, 7),
    (8, 5, 8),
    (9, 5, 9),
    (10, 5, 10),
    (1, 6, 1),
    (2, 6, 2),
    (3, 6, 3),
    (4, 6, 4),
    (5, 6, 5),
    (6, 6, 6),
    (7, 6, 7),
    (8, 6, 8),
    (9, 6, 9),
    (10, 6, 10),
    (1, 7, 1),
    (2, 7, 2),
    (3, 7, 3),
    (4, 7, 4),
    (5, 7, 5),
    (6, 7, 6),
    (7, 7, 7),
    (8, 7, 8),
    (9, 7, 9),
    (10, 7, 10),
    (1, 8, 1),
    (2, 8, 2),
    (3, 8, 3),
    (4, 8, 4),
    (5, 8, 5),
    (6, 8, 6),
    (7, 8, 7),
    (8, 8, 8),
    (9, 8, 9),
    (10, 8, 10),
    (1, 9, 1),
    (2, 9, 2),
    (3, 9, 3),
    (4, 9, 4),
    (5, 9, 5),
    (6, 9, 6),
    (7, 9, 7),
    (8, 9, 8),
    (9, 9, 9),
    (10, 9, 10),
    (1, 10, 1),
    (2, 10, 2),
    (3, 10, 3),
    (4, 10, 4),
    (5, 10, 5),
    (6, 10, 6),
    (7, 10, 7),
    (8, 10, 8),
    (9, 10, 9),
    (10, 10, 10),
])
def test_that_api_returns_some_results(n, k, expected):
    ans = 0
    for a in range(1, n + 1):
        b = c = (k - a - 1) % k + 1
        if (b + c) % k:
            continue
        ans += ((n - b) // k + 1) ** 2
    assert ans == expected

