from itertools import accumulate


def search_ab(sss, cursor):
    # print('a', cursor)
    ai = aaa.index(cursor)
    tmp_cur = bbb[ai]
    max_cur = sss.index(0, cursor)
    repeat = 1
    while tmp_cur < max_cur:
        cur = s.find('a', tmp_cur, max_cur)
        if cur == -1:
            break
        ai = aaa.index(cur, ai)
        tmp_cur = bbb[ai]
        repeat += 1
    return repeat, max_cur + 1


def search_ba(sss, cursor):
    # print('b', cursor)
    first_bi = bbb.index(cursor)
    max_cursor = sss.index(0, cursor)
    last_bi = aaa.index(max_cursor)

    tmp_buf = [''] * (last_bi - first_bi + 1) * 2
    tmp_max = ''
    for i in range(last_bi, first_bi - 1, -1):
        tmp_buf[aaa[i] - cursor] = 'a'
        tmp_buf[bbb[i] - cursor] = 'b'
        tmp = ''.join(tmp_buf)
        if tmp > tmp_max:
            tmp_max = tmp
    return tmp_max, max_cursor + 1


def integrate(parts_b):
    tmp_max = ''
    for pb in reversed(parts_b):
        tmp = pb + tmp_max
        if tmp > tmp_max:
            tmp_max = tmp
    return tmp_max


@pytest.mark.parametrize('n, s, expected', [
    (1, 'a', 'a'),
    (2, 'ab', 'ab'),
    (3, 'aba', 'aba'),
    (4, 'abab', 'abab'),
    (5, 'ababa', 'ababa'),
    (6, 'ababab', 'ababab'),
    (7, 'abababa', 'abababa'),
    (8, 'abababab', 'abababab'),
    (9, 'ababababa', 'ababababa'),
    (10, 'ababababab', 'ababababab'),
    (11, 'abababababa', 'abababababa'),
    (12, 'abababababab', 'abababababab'),
    (13, 'ababababababa', 'ababababababa'),
    (14, 'ababababababab', 'ababababababab'),
    (15, 'abababababababa', 'abababababababa'),
    (16, 'abababababababab', 'abababababababab'),
    (17, 'ababababababababa', 'ababababababababa'),
    (18, 'ababababababababab', 'ababababababababab'),
    (19, 'abababababababababa', 'abababababababababa'),
    (20, 'abababababababababab', 'abababababababababab'),
    (21, 'ababababababababababa', 'ababababababababababa'),
    (22, 'ababababababababababab', 'ababababababababababab'),
    (23, 'abababababababababababa', 'abababababababababababa'),
    (24, 'abababababababababababab', 'abababababababababababab'),
    (25, 'ababababababababababababa', 'ababababababababababababa'),
    (26, 'ababababababababababababab', 'ababababababababababababab'),
    (27, 'abababababababababababababa', 'abababababababababababababa'),
    (28, 'abababababababababababababab', 'abababababababababababababab'),
    (29, 'ababababababababababababababa', 'abababab