import pytest

@pytest.mark.parametrize('n, a, expected', [
    (1, [1], 0),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 1),
    (4, [1, 2, 3, 4], 2),
    (5, [1, 2, 3, 4, 5], 2),
    (6, [1, 2, 3, 4, 5, 6], 3),
    (7, [1, 2, 3, 4, 5, 6, 7], 3),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 4),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 4),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 5),
])
def test_divide_by_two(n, a, expected):
    cnt = 0
    for i in range(len(a)):
        while a[i] % 2 == 0:
            a[i] = a[i] // 2
            cnt += 1
    assert cnt == expected

