# File changed

from sys import exit, setrecursionlimit, stderr
from functools import reduce
from itertools import *
from collections import defaultdict
from bisect import bisect

def read():
  return int(input())

def reads():
  return [int(x) for x in input().split()]

n = read()
L = []
R = []
for _ in range(n):
  l, r = reads()
  L.append(l)
  R.append(-r)

L.sort()
L.reverse()
R.sort()
R.reverse()

psuml = [0] * (n + 1)
psumr = [0] * (n + 1)

for i in range(n):
  psuml[i + 1] = psuml[i] + L[i]
  psumr[i + 1] = psumr[i] + R[i]

ans = 0

for i in range(n + 1):
  ans = max(ans, psuml[i] + psumr[i])

for i in range(n):
  ans = max(ans, psuml[i] + psumr[i + 1])
  ans = max(ans, psuml[i + 1] + psumr[i])

print(ans * 2)

