import pytest

@pytest.mark.parametrize('A, B, expected', [
    (1, 2, 3),
    (2, 1, 3),
    (1, -2, 1),
    (-2, 1, 1),
    (1, 0, 1),
    (0, 1, 1),
    (1, 1, 2),
    (1, -1, 2),
    (-1, 1, 2),
    (-1, -1, -1),
    (0, 0, 0),
])
def test_max_of_sum_and_difference(A, B, expected):
    assert max(A + B, A - B, A * B) == expected

