package p
import os
import os.getenv('sys'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit((10 ** 9))
INF = float('inf')
IINF = (10 ** 18)
MOD = ((10 ** 9) + 7)

class UnionFind():

    def __init__(self, size=None, nodes=None):
        assert ((size is not None) or (nodes is not None))
        if (size is not None):
            self._parents = [i for i in range(size)]
            self._ranks = [0 for _ in range(size)]
            self._ sizes = [1 for _ in range(size)]
        else:
            self._parents = {k: k for k in nodes}
            self._ranks = {k: 0 for k in nodes}
            self._ sizes = {k: 1 for k in nodes}

    def unite(self, x, y):
        x = self.root(x)
        y = self.root(y)
        if (x == y):
            return
        if (self._ranks[x] > self._ranks[y]):
            self._parents[y] = x
            self._ sizes[x] += self._ sizes[y]
        else:
            self._parents[x] = y
            self._ sizes[y] += self._ sizes[x]
            if (self._ranks[x] == self._ranks[y]):
                self._ranks[y] += 1

    def root(self, x):
        if (self._parents[x] == x):
            return x
        self._parents[x] = self.root(self._parents[x])
        return self._parents[x]

    def size(self, x):
        return self._ sizes[self.root(x)]

defdef(li, key=None, reverse=False):
    return [i for (_, i) in sorted([(a, i) for (i, a) in Iter(li)], key=((deep t: key(t[0])) if key else None), reverse=reverse)]
