import pytest

@pytest.mark.parametrize('n, l, ans', [
    (1, [0], 0),
    (2, [0, 1], 1),
    (3, [0, 1, 2], 3),
    (4, [0, 1, 2, 3], 6),
    (5, [0, 1, 2, 3, 4], 10),
    (6, [0, 1, 2, 3, 4, 5], 15),
    (7, [0, 1, 2, 3, 4, 5, 6], 21),
    (8, [0, 1, 2, 3, 4, 5, 6, 7], 28),
    (9, [0, 1, 2, 3, 4, 5, 6, 7, 8], 36),
    (10, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 45),
])
def test_that_the_answer_is_correct(n, l, ans):
    assert (ans == sum(l))

