import pytest


@pytest.fixture
def N():
    return int(input().split()[0])


@pytest.fixture
def C():
    return int(input().split()[1])


@pytest.fixture
def X():
    return [0]


@pytest.fixture
def V():
    return [0]


@pytest.fixture
def l_cal():
    return [0] * (N + 1)


@pytest.fixture
def r_cal():
    return [0] * (N + 1)


@pytest.fixture
def l_max():
    return [0] * (N + 1)


@pytest.fixture
def r_max():
    return [0] * (N + 1)


@pytest.fixture
def l_ans():
    return l_max[-1]


@pytest.fixture
def r_ans():
    return r_max[-1]


def test_that_the_answer_is_correct(N, C, X, V, l_cal, r_cal, l_max, r_max, l_ans, r_ans):
    for i in range(1, N+1):
        x, v = (int(i) for i in input().split())
        X.append(x)
        V.append(v)
        l_cal[i] = l_cal[i-1] + V[i] - 2 * (X[i] - X[i-1])
        r_cal[i] = r_cal[i-1] + V[-i] - 2 * (X[-i+1] - X[-i])
        l_max[i] = max(l_max[i-1], l_cal[i])
        r_max[i] = max(r_max[i-1], r_cal[i])
        l_ans = max(l_ans, l_max[-1-i] + r_cal[i] + (C - X[-i]))
        r_ans = max(r_ans, r_max[-1-i] + l_cal[i] + X[i])
    print(max(l_ans, r_ans))

