' Median of two sorted arrays
'
import sys
from bisect import *
sys.setrecursionlimit((10 ** 6))
input = sys.stdin.readline

def main():
    'Finds the median of two sorted arrays

    Args:
        n (int): The number of elements in the arrays.
        a (list): The first array.
        m (float): The median of the two arrays.
        i (int): The index of the median.
        d0 (float): The distance between the median and the first element.
        d1 (float): The distance between the median and the last element.

    Returns:
        None: Prints the median and the two elements closest to the median.
    '
    n = int(input())
    a = list(map(int, input().split()))
    a.sort()
    m = (a[(- 1)] / 2)
    i = bisect(a, m)
    d0 = (m - a[(i - 1)])
    d1 = (a[i] - m)
    if ((d0 < d1) or (i == (n - 1))):
        print(a[(- 1)], a[(i - 1)])
    else:
        print(a[(- 1)], a[i])
main()


