import pytest

@pytest.mark.parametrize('N, a, expected', [
    (3, [1, 2, 3], [3, 3, 3]),
    (4, [1, 2, 3, 4], [3, 3, 3, 3]),
    (5, [1, 2, 3, 4, 5], [3, 3, 3, 3, 3]),
])
def test_that_api_returns_some_results(N, a, expected):
    c = [0] * (N + 2)
    for i in range(N):
        c[i + 1] = abs(a[i] - a[i - 1])
    c[-1] = abs(a[-2])
    s = sum(c)
    for i in range(N):
        assert s - c[i + 1] - c[i + 2] + abs(a[i + 1] - a[i - 1]) == expected[i]

