import pytest

def main():
    N, M = map(int, input().split())

    if N > M:
        N, M = M, N

    if (N, M) == (1, 1):
        print(1)
        return

    if N == 1:
        print(M - 2)
        return

    print((N - 2) * (M - 2))


@pytest.mark.parametrize('N, M, expected', [
    (1, 1, 1),
    (1, 2, 1),
    (2, 1, 1),
    (2, 2, 2),
    (2, 3, 4),
    (3, 2, 4),
    (3, 3, 8),
    (3, 4, 12),
    (4, 3, 12),
    (4, 4, 16),
    (4, 5, 20),
    (5, 4, 20),
    (5, 5, 25),
    (5, 6, 30),
    (6, 5, 30),
    (6, 6, 36),
    (6, 7, 42),
    (7, 6, 42),
    (7, 7, 49),
    (7, 8, 56),
    (8, 7, 56),
    (8, 8, 64),
    (8, 9, 72),
    (9, 8, 72),
    (9, 9, 81),
    (9, 10, 80),
    (10, 9, 80),
    (10, 10, 80),
