import pytest

@pytest.mark.parametrize("N, A1, A2, expected", [
    (1, [1], [1], 2),
    (2, [1, 2], [1, 2], 4),
    (3, [1, 2, 3], [1, 2, 3], 6),
    (4, [1, 2, 3, 4], [1, 2, 3, 4], 8),
    (5, [1, 2, 3, 4, 5], [1, 2, 3, 4, 5], 10),
])
def test_maximum_sum(N, A1, A2, expected):
    total = sum(A2) + A1[0]
    maximum = total
    for i in range(N - 1):
        total += A1[i + 1]
        total -= A2[i]
        maximum = max(maximum, total)
    assert maximum == expected

