import pytest

@pytest.mark.parametrize("n, y, expected", [
    (1, 1, (1, 0, 0)),
    (2, 2, (1, 1, 0)),
    (3, 3, (1, 1, 1)),
    (4, 4, (2, 0, 2)),
    (5, 5, (1, 3, 1)),
    (6, 6, (2, 2, 2)),
    (7, 7, (3, 1, 3)),
    (8, 8, (2, 4, 2)),
    (9, 9, (3, 3, 3)),
    (10, 10, (4, 0, 6)),
])
def test_that_api_returns_some_results(n, y, expected):
    result = []
    for i in range(n + 1):
        for j in range(n - i + 1):
            if i * 10000 + j * 5000 + (n - i - j) * 1000 == y:
                result = [i, j, n - i - j]
                break
    assert result == expected

