import pytest

@pytest.mark.parametrize('a, b, c, d, expected', [
    (1, 2, 3, 4, 'Left'),
    (1, 2, 2, 3, 'Balanced'),
    (1, 2, 3, 5, 'Right'),
])
def test_balance(a, b, c, d, expected):
    e = a + b
    f = c + d
    if e > f:
        assert expected == 'Left'
    elif e == f:
        assert expected == 'Balanced'
    else:
        assert expected == 'Right'

