from bisect import bisect


@pytest.mark.parametrize('n, k, flowers, expected', [
    (1, 1, [(1, 1)], 1),
    (2, 1, [(1, 1), (2, 1)], 1),
    (2, 1, [(1, 1), (2, 1)], 1),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2, 1)], 2),
    (2, 2, [(1, 1), (2