import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
n = int(readline())
data = list(map(int, read().split()))
A = data[:((n + n) - 2):2]
B = data[1:((n + n) - 2):2]
inf = 10**18 + 100
S = [inf] + data[(-n):]
graph = [[] for _ in range(n+1)]
for a, b in zip(A, B):
    graph[a].append(b)
    graph[b].append(a)
root = S.index(min(S))
parent = [0] * (n+1)
order = []
stack = [root]
while stack:
    x = stack.pop()
    order.append(x)
    for y in graph[x]:
        if y == parent[x]:
            continue
        parent[y] = x
        stack.append(y)
subtreesize = [1] * (n+1)
for v in reversed(order):
    subtreesize[parent[v]] += subtreesize[v]
length = [0] * (n+1)
for v, p in zip(A, B):
    if parent[p] == v:
        v, p = p, v
    s = subtreesize[v]
    d = (n - s) - s
    length[v] = 0 if d == 0 else (S[v] - S[p]) // d
dist = [0] * (n+1)
for v in order[1:]:
    p = parent[v]
    dist[v] = dist[p] + length[v]
droot = sum(dist)
x = (S[root] - droot) * 2 // n
answer = []
for v, p in zip(A, B):
    if parent[p] == v:
        v, p = p, v
    if length[v] == 0:
        length[v] = x
    answer.append(length[v])
print('\n'.join(map(str, answer)))

