import sys
input = sys.stdin.readline
sys.setrecursionlimit(10 ** 7)

import numpy as np

N = int(input())
H,P = np.array([[int(x) for x in input().split()] for _ in range(N)],dtype=np.int64).T

i = (H+P).argsort()
H = H[i]; P = P[i]

# 人数 -> 最小高さ
INF = 10**18
dp = np.full(N+1,INF,dtype=np.int64)
dp[0] = 0
for h,p in zip(H,P):
    prev = dp
    dp = prev.copy()
    can_add = (prev[:-1] <= h)
    np.minimum(dp[1:], np.where(can_add, prev[:-1]+p, INF), out=dp[1:])

answer = np.where(dp < INF)[0][-1]
print(answer)