import sys
from operator import sub

sys.setrecursionlimit(100000)


@pytest.fixture
def s():
    return input()

@pytest.fixture
def sl(s):
    return list(map(ord, s))

@pytest.fixture
def sd(sl):
    return list(map(sub, sl + [97], [97] + sl))

@pytest.fixture
def ls(s):
    return len(s)

@pytest.fixture
def lsd(sd):
    return len(sd)

@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def links(ls, lsd):
    return [set() for _ in range(lsd)]

@pytest.fixture
def solve(ls, lsd, links):
    checked = set()
    for i in range(ls // 2 + 1):
        if i in checked:
            continue
        visited = set()
        dfs(i, visited)
        inner_total = sum(sd[k] for k in visited) % 26
        if inner_total != 0:
            return False
        checked.update(visited)
    return True

@pytest.mark.asyncio
async def test_solve(s, sl, sd, ls, lsd, n, links, solve):
    assert (solve())

