import pytest

def solve(k, n):
    if k & 1 == 0:
        return [k // 2] + [k] * (n - 1)
    ans = [k // 2 + 1] * n
    l = n
    for i in range((n - 2) // 2 + 1):
        if ans[-1] == 1:
            ans.pop()
            l -= 1
        else:
            ans[-1] -= 1
            if l < n:
                ans += [k] * (n - l)
                l = n
    return ans


@pytest.mark.parametrize('k, n, expected', [
    (1, 1, [1]),
    (2, 2, [2, 2]),
    (3, 3, [2, 2, 2]),
    (4, 4, [3, 3, 3, 3]),
    (5, 5, [3, 3, 3, 3, 3]),
    (6, 6, [4, 4, 4, 4, 4, 4]),
    (7, 7, [4, 4, 4, 4, 4, 4, 4]),
    (8, 8, [5, 5, 5, 5, 5, 5, 5, 5]),
    (9, 9, [5, 5, 5, 5, 5, 5, 5, 5, 5]),
    (10, 10, [6, 6, 6, 6, 6, 6, 6, 6, 6, 6]),
    (11, 11, [6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6]),
    (12, 12, [7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7]),
    (13, 13, [7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7]),
    (14, 14, [8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8]),
    (15, 15, [8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8]),
    (16, 16, [9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9]),
    (17, 17, [9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9]),
    (18, 18, [10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10]),
    (19, 19, [10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10]),
    (20, 20, [11, 11, 11, 11