# -*- coding: utf-8 -*-
import pytest

@pytest.mark.parametrize("s, rs, n, res", [
    ("", "", 0, 0),
    ("", "x", 1, 1),
    ("x", "", 1, 1),
    ("x", "x", 1, 0),
    ("x", "xx", 2, 1),
    ("xx", "x", 2, 1),
    ("xx", "xx", 2, 0),
    ("xx", "xxx", 3, 1),
    ("xxx", "xx", 3, 1),
    ("xxx", "xxx", 3, 0),
    ("xxx", "xxxx", 4, 1),
    ("xxxx", "xxx", 4, 1),
    ("xxxx", "xxxx", 4, 0),
    ("xxxx", "xxxxx", 5, 1),
    ("xxxxx", "xxxx", 5, 1),
    ("xxxxx", "xxxxx", 5, 0),
    ("xxxxx", "xxxxxx", 6, 1),
    ("xxxxxx", "xxxxx", 6, 1),
    ("xxxxxx", "xxxxxx", 6, 0),
    ("xxxxxx", "xxxxxxx", 7, 1),
    ("xxxxxxx", "xxxxxx", 7, 1),
    ("xxxxxxx", "xxxxxxx", 7, 0),
    ("xxxxxxx", "xxxxxxxx", 8, 1),
    ("xxxxxxxx", "xxxxxxx", 8, 1),
    ("xxxxxxxx", "xxxxxxxx", 8, 0),
    ("xxxxxxxx", "xxxxxxxxx", 9, 1),
    ("xxxxxxxxx", "xxxxxxxx", 9, 1),
    ("xxxxxxxxx", "xxxxxxxxx", 9, 0),
    ("xxxxxxxxx", "xxxxxxxxxx", 10, 1),
    ("xxxxxxxxxx", "xxxxxxxxx", 10, 1