import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
n = int(readline())
S = readline().rstrip().decode('utf-8')

def solve_partial(S):
  inf = 10**18
  S = S.replace('01', '2')
  a, b, c, d, e = 1, 1, inf, 0, inf
  for x in S[1:]:
    ace = min(a, c, e)
    if x == '1':
      a2 = ace + 1
      c2 = c
      d2 = ace if ace < d else d
      e2 = inf
    else:
      a2 = ace + 1
      c2 = a
      d2 = ace
      e2 = d + 1
    a, c, d, e = a2, c2, d2, e2
  return len(S) - min(a, c, e)

answer = 0
for x in S.split('00'):
  x = x.strip('0')
  if x:
    answer += solve_partial(x)
print(answer)

