import pytest

@pytest.mark.parametrize('n,a,b,expected', [
    (1, [1], [1], 2),
    (2, [1, 2], [1, 2], 3),
    (3, [1, 2, 3], [1, 2, 3], 4),
    (4, [1, 2, 3, 4], [1, 2, 3, 4], 5),
    (5, [1, 2, 3, 4, 5], [1, 2, 3, 4, 5], 6),
])
def test_max_plus_min(n, a, b, expected):
    assert (max(a)+min(b) == expected)

