import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
MOD = 998244353
(N, M) = map(int, readline().split())
(A, B, C, D) = [(np.array(list(readline().rstrip())) - 48) for _ in range(4)]

def cumprod(arr, MOD):
  l = len(arr)
  lsq = int(((l ** 0.5) + 1))
  arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
  for n in range(1, lsq):
    arr[:, n] *= arr[:, (n - 1)]
    arr[:, n] %= MOD
  for n in range(1, lsq):
    arr[n] *= arr[((n - 1), (- 1))]
    arr[n] %= MOD
  return arr.ravel()[:l]

def make_fact(U, MOD):
  x = np.arange(U, dtype=np.int64)
  x[0] = 1
  fact = cumprod(x, MOD)
  x = np.arange(U, 0, (- 1), dtype=np.int64)
  x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
  factinv = cumprod(x, MOD)[::(- 1)]
  return (fact, factinv)

U = (10 ** 6)
(fact, factinv) = make_fact(U, MOD)

def cnt_vertical(N, M, A, B, C, D):
  ab = (A + B)
  l = C.sum()
  lu = (A.cumsum() - A)
  ld = (B.cumsum() - B)
  nl = ((((fact[(((lu + ld) + l) - 1)] * factinv[(lu + ld)]) % MOD) * factinv[(l - 1)]) % MOD)
  r = D.sum()
  ru = (A[::(- 1)].cumsum() - A[::(- 1)])
  rd = (B[::(- 1)].cumsum() - B[::(- 1)])
  nr = ((((fact[(((ru + rd) + r) - 1)] * factinv[(ru + rd)]) % MOD) * factinv[(r - 1)]) % MOD)
  nr = nr[::(- 1)]
  x = np.ones(N, np.int64)
  x[(ab == 2)] = 2
  coef = cumprod(x, MOD)
  x = np.ones(N, np.int64)
  x[(ab == 2)] = ((MOD + 1) // 2)
  coefinv = cumprod(x, MOD)
  nl *= coefinv
  nr *= coef
  nl %= MOD
  nr %= MOD
  nl[(ab == 2)] *= 2
  nl[(ab == 0)] = 0
  nr[(ab == 0)] = 0
  nlcum = (nl.cumsum() % MOD)
  return (((nlcum * nr) % MOD).sum() % MOD)

def AB_only(N, A, B):
  x = np.ones(N, np.int64)
  x[((A + B) == 2)] = 2
  return cumprod(x, MOD)[(- 1)]

def ABC_only(N, M, A, B, C):
  ab = (A + B)
  (na, nb, nc) = [np.count_nonzero(x) for x in [A, B, C]]
  r = nc
  ru = (A[::(- 1)].cumsum() - A[::(- 1)])
  rd = (B[::(- 1)].cumsum() - B[::(- 1)])
  nr = ((((fact[(((ru + rd) + r) - 1)] * factinv[(ru + rd)]) % MOD) * factinv[(r - 1)]) % MOD)
  nr = nr[::(- 1)]
  nr[(ab == 0)] = 0
  x = np.ones(N, np.int64)
  x[(ab == 2)] = 2
  coef = cumprod(x, MOD)
  x = (((coef * nr) % MOD).sum() % MOD)
  y = ((((fact[(((na + nb) + nc) - 1)] * factinv[(nc - 1)]) % MOD) * factinv[(na + nb)]) % MOD)
  return ((x + y) % MOD)

def F(N, M, A, B, C, D):
  (na, nb, nc, nd) = [np.count_nonzero(x) for x in [A, B, C, D]]
  if all(((x != 0) for x in [na, nb, nc, nd])):
    return ((cnt_vertical(N, M, A, B, C, D) + cnt_vertical(M, N, C, D, A, B)) % MOD)
  if (na != 0):
    (na, nb) = (nb, na)
    (A, B) = (B, A)
    C = C[::(- 1)]
    D = D[::(- 1)]
  if (nc != 0):
    (nc, nd) = (nd, nc)
    (C, D) = (D, C)
    A = A[::(- 1)]
    B = B[::(- 1)]
  if (nb == 0):
    return AB_only(M, C, D)
  if (nd == 0):
    return AB_only(N, A, B)
  if ((na == 0) and (nc == 0)):
    return ((((fact[(nb + nd)] * factinv[nb]) % MOD) * factinv[nd]) % MOD)
  if (na == 0):
    return ABC_only(M, N, C, D, B)
  if (nc == 0):
    return ABC_only(N, M, A, B, D)

answer =