# File changed

import itertools
import numpy as np
from scipy.sparse import csr_matrix
from scipy.sparse.csgraph import floyd_warshall
(N, *Z) = [int(_) for _ in open(0).read().split()]
A = []
B = []
C = []
for z in range((N * N)):
    (x, y) = divmod(z, N)
    A += [x]
    B += [y]
    C += [Z[z]]
G = csr_matrix((C, (A, B)), (N, N))
F = np.array(floyd_warshall(G, directed=1), dtype=np.int64)
Z = np.array(Z).reshape(N, N)
if np.all((F == Z)):
    ans = np.sum(Z)
    for (i, j) in itertools.product(range(N), repeat=2):
        ans -= (Z[(i, j)] * (np.sum(((Z[i] + Z[j]) == Z[(i, j)])) > 2))
    ans //= 2
    print(ans)
else:
    print((- 1))


