import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
A = np.array(list(readline().rstrip()), np.int32) - ord('0')
B = np.array(list(readline().rstrip()), np.int32) - ord('0')
N = len(A)
if np.count_nonzero(B) == 0:
  if np.count_nonzero(A) == 0:
    print(0)
  else:
    print(-1)
  exit()

def F(A, B):
  shift = np.where(B)[0][0]
  A = np.roll(A, -shift)
  B = np.roll(B, -shift)
  b2 = np.tile(B, 2)
  x = np.arange(N) * B
  np.maximum.accumulate(x, out=x)
  left = x
  x = (N * (1 - B) + np.arange(N) * B)[::-1]
  np.minimum.accumulate(x, out=x)
  right = x[::-1]
  left = np.concatenate([left, left + N])
  right = np.concatenate([right, right + N])
  opt = 10**18
  for n in range(N+1):
    diff = A != b2[n:n+N]
    changecost = np.count_nonzero(diff)
    moveleft = np.maximum(0, np.arange(N) - np.maximum(left[:N], left[n:n+N]))
    moveleft[~diff] = 0
    moveright = np.maximum(0, np.minimum(right[:N], right[n:n+N]) - np.arange(n, n+N))
    moveright[~diff] = 0
    ind = moveleft > 0
    l = moveleft[ind]
    r = moveright[ind]
    i = np.lexsort((r, l))
    l = l[i]
    r = r[i]
    x = np.zeros(N, np.int32)
    x[l-1] = r
    x = x[::-1]
    np.maximum.accumulate(x, out=x)
    x = x[::-1]
    movecost = n + 2*(np.arange(N) + x).min()
    cost = movecost + changecost
    if opt > cost:
      opt = cost
  return opt

x = F(A, B)
A = A[::-1]
B = B[::-1]
y = F(A, B)
A = A[::-1]
B = B[::-1]
answer = min(x, y)
print(answer)

