from collections import deque
N = int(input())
graph = [[] for _ in range(N)]
ditstant = [float('inf')]*N
visited = [False]*N
tmp = {}
for _ in range(N-1):
    a, b, c = map(int, input().split())
    a -= 1
    b -= 1
    graph[a].append(b)
    graph[b].append(a)
    tmp[a, b] = c
    tmp[b, a] = c
Q, K = map(int, input().split())
K -= 1
ditstant[K] = 0  # Kの地点は0にする
visited[K] = True
q = deque([K])
while len(q):
    v = q.popleft()
    for e in graph[v]:
        if visited[e]:
            continue
        visited[e] = True
        ditstant[e] = min(ditstant[e], ditstant[v]+tmp[v, e])
        q.append(e)
for _ in range(Q):
    x, y = map(lambda x: int(x)-1, input().split())
    print(ditstant[x] + ditstant[y])

