import pytest

@pytest.mark.parametrize('n, m, expected', [
    (1, 1, 0),
    (2, 2, 3),
    (3, 3, 8),
])
def test_print_n_m(capsys, n, m, expected):
    input_str = f'{n} {m}'
    with pytest.raises(SystemExit) as pytest_wrapped_e:
        with mock.patch('sys.stdin', io.StringIO(input_str)):
            main()
    assert pytest_wrapped_e.type == SystemExit
    assert pytest_wrapped_e.value.code == 0
    captured = capsys.readouterr()
    assert captured.out == f'{expected}\n'

