' Scanner
'
# File changed


class Scanner(object):
    s = []
    idx = 0
    separater = ''

    def __init__(self, separater=' '):
        'Initializes the scanner

        Args:
            separater (str, optional): Defaults to ' '. The separater to split the input on.
        '
        self.separater = separater

    def next(self):
        'Gets the next input

        Returns:
            str: The next input
        '
        while (self.idx >= len(self.s)):
            st = input()
            while (st == ''):
                st = input()
            self.s = st.split(self.separater)
            self.idx = 0
        self.idx += 1
        return self.s[(self.idx - 1)]

    def next_int(self):
        'Gets the next integer input

        Returns:
            int: The next integer input
        '
        return int(self.next())

    def next_float(self):
        'Gets the next float input

        Returns:
            float: The next float input
        '
        return float(self.next())
sc = Scanner()
N = sc.next_int()
M = sc.next_int()
graph = []
for i in range(N):
    graph.append([])
for i in range(M):
    a = (sc.next_int() - 1)
    b = (sc.next_int() - 1)
    graph[a].append(b)
    graph[b].append(a)
successed = False
for neighbors in graph[(N - 1)]:
    for neighbor in graph[neighbors]:
        if (neighbor == 0):
            successed = True
if successed:
    print('POSSIBLE')
else:
    print('IMPOSSIBLE')


