' Finds the smallest ball that can be used to cover a range of numbers
'
# File changed

(n, k) = map(int, input().split())
A = sorted(map(int, input().split()))

def gcd(a, b):
    ' Calculates the greatest common divisor of two numbers

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The greatest common divisor of the two numbers.
    '
    if (b == 0):
        return a
    return gcd(b, (a % b))
smallest_ball = A[0]
for a in A[1:]:
    smallest_ball = gcd(smallest_ball, a)
print(('POSSIBLE' if ((((A[(- 1)] - k) % smallest_ball) == 0) and (k <= A[(- 1)])) else 'IMPOSSIBLE'))


