# File changed

import sys
readline = sys.stdin.readline
readlines = sys.stdin.readlines
sys.setrecursionlimit((10 ** 7))
N = int(readline())
ABC = (tuple((int(x) for x in line.split())) for line in readlines())
graph = []
for _ in range((N + 1)):
    graph.append([])
for (a, b, c) in ABC:
    a -= 1
    b -= 1
    graph[a].append((b, c))
    graph[b].append((a, c))
V = [0]
parent = [None]
visited = ([True] + ([False] * (N - 1)))
q = [0]
while q:
    x = q.pop()
    for (y, _) in graph[x]:
        if visited[y]:
            continue
        q.append(y)
        V.append(y)
        parent.append(x)
        visited[y] = True
size = []
for _ in range(N):
    size.append([])
centroid = []
for (v, p) in zip(V[::(- 1)], parent[::(- 1)]):
    size[v].append(((N - 1) - sum(size[v])))
    if all(((x <= (N // 2)) for x in size[v])):
        centroid.append(v)
    if (p is not None):
        size[p].append((N - size[v][(- 1)]))
v0 = centroid[0]
dist = ([None] * N)
dist[v0] = 0
q = [v0]
while q:
    x = q.pop()
    for (y, wt) in graph[x]:
        if (dist[y] is None):
            dist[y] = (dist[x] + wt)
            q.append(y)
if (len(centroid) == 1):
    dist.sort()
    answer = (((sum(dist) * 2) - dist[0]) - dist[1])
else:
    answer = (((sum(dist) * 2) - dist[centroid[0]]) - dist[centroid[1]])
print(answer)


