# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import itertools
import numpy as np
from functools import lru_cache
from operator import itemgetter
X = list(map(int, readline().split()))
Y = list(map(int, readline().split()))
for i in [1, 3, 5]:
    X[i] += 1
    Y[i] += 1
X1 = X[:2]
X2 = X[2:4]
X3 = X[4:]
Y1 = Y[:2]
Y2 = Y[2:4]
Y3 = Y[4:]

def cumprod(arr, MOD):
    l = len(arr)
    lsq = int(((l ** 0.5) + 1))
    arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
    for n in range(1, lsq):
        arr[(:, n)] *= arr[(:, (n - 1))]
        arr[(:, n)] %= MOD
    for n in range(1, lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:l]

def make_fact(U, MOD):
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    factinv = cumprod(x, MOD)[::(- 1)]
    return (fact, factinv)
U = ((2 * (10 ** 6)) + 10)
MOD = ((10 ** 9) + 7)
(fact, factinv) = make_fact(U, MOD)

@lru_cache(8)
def make_comb(n):
    return ((((fact[n] * factinv[:(n + 1)]) % MOD) * factinv[:(n + 1)][::(- 1)]) % MOD)
answer = 0
tasks = []
for p in itertools.product([0, 1], repeat=6):
    (x1, x2, x3, y1, y2, y3) = [A[i] for (A, i) in zip([X1, X2, X3, Y1, Y2, Y3], p)]
    sgn = ((- 1) ** sum(p))
    (a, b, c, d) = ((x2 - x1), (x3 - x2), (((x2 - x1) + y2) - y1), (((x3 - x2) + y3) - y2))
    c += 2
    d += 2
    sgn = (- sgn)
    tasks.append((a, b, c, d, sgn))
tasks.sort(key=itemgetter(2))
for (a, b, c, d, sgn) in tasks:
    D = ((a + b) + 2)
    l = max(0, (D - d))
    r = min(c, D)
    if (l > r):
        continue
    x = make_comb(c)[l:(r + 1)]
    (l, r) = ((D - r), (D - l))
    y = make_comb(d)[l:(r + 1)]
    x = ((x * y[::(- 1)]) % MOD)
    np.cumsum(x, out=x)
    x %= MOD
    np.cumsum(x, out=x)
    x %= MOD
    (l, r) = ((D - r), (D - l))
    if (0 <= (a - l) < len(x)):
        answer += (sgn * x[(a - l)])
answer %= MOD
print(answer)

