# File changed


class Tree():

    def __init__(self, n, edge, indexed=1):
        self.n = n
        self.tree = [[] for _ in range(n)]
        for e in edge:
            self.tree[(e[0] - indexed)].append((e[1] - indexed))
            self.tree[(e[1] - indexed)].append((e[0] - indexed))

    def setroot(self, root):
        self.root = root
        self.parent = [None for _ in range(self.n)]
        self.parent[root] = (- 1)
        self.order = []
        self.order.append(root)
        stack = [root]
        while stack:
            node = stack.pop()
            for adj in self.tree[node]:
                if (self.parent[adj] is None):
                    self.parent[adj] = node
                    self.order.append(adj)
                    stack.append(adj)
N = int(input())
edge = [tuple(map(int, input().split())) for _ in range((N - 1))]
tree = Tree(N, edge)
tree.setroot(0)
grundy = [0 for _ in range(N)]
for node in tree.order[::(- 1)]:
    for adj in tree.tree[node]:
        if (tree.parent[node] == adj):
            continue
        grundy[node] ^= (grundy[adj] + 1)
print(('Alice' if (grundy[0] != 0) else 'Bob'))
