import sys
from collections import Counter

# sys.stdin = open('e1.in')


def read_int_list():
    return list(map(int, input().split()))


def read_int():
    return int(input())


def read_str_list():
    return input().split()


def read_str():
    return input()


@pytest.mark.parametrize('n, h, a, b, c, d, expected', [
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [0, 0, 0],
        'YES'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [1, 0, 0],
        [0, 0, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [1, 0, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [0, 1, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [0, 0, 1],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [1, 1, 0],
        [0, 0, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 1, 0],
        [1, 0, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 1],
        [0, 1, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [1, 1, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [0, 1, 1],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 0, 0],
        [0, 0, 1],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [1, 0, 0],
        [0, 1, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 1, 0],
        [0, 0, 1],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [1, 0, 0],
        [0, 0, 1],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 1, 0],
        [0, 0, 1],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [1, 0, 0],
        [0, 1, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [0, 1, 0],
        [1, 0, 0],
        'NO'
    ),
    (
        3,
        1,
        [1, 2, 3],
        [2, 3, 4],
        [1