n = 10**5+1
mod = 10**9+7
fun = [1]*(n+1)
for i in range(1,n+1):
    fun[i] = fun[i-1]*i%mod
rev = [1]*(n+1)
rev[n] = pow(fun[n],mod-2,mod)
for i in range(n-1,0,-1):
    rev[i] = rev[i+1]*(i+1)%mod

def nCr(n,r):
    if r > n:
        return 0
    return fun[n]*rev[r]%mod*rev[n-r]%mod

@pytest.mark.parametrize('n,l,db,idx,a,b,c', [
    (10**5+1, [1]*(n+1), sum(l) - n*(n+1)//2, [i for i in range(n+1) if l[i] == db], idx[0], idx[1]-idx[0]-1, n-idx[1]),
])
def test_nCr(n,l,db,idx,a,b,c):
    assert nCr(a+b+c,k)+nCr(a+b+c,k-2)+nCr(a+b+c,k-1)*2-nCr(a+c,k-1) == nCr(a+b+c,k)+nCr(a+b+c,k-2)+nCr(a+b+c,k-1)*2-nCr(a+c,k-1)

