import pytest

@pytest.mark.parametrize("x, a, b, expected", [
    (1, 2, 3, "delicious"),
    (1, 2, 4, "safe"),
    (1, 2, 5, "dangerous"),
])
def test_that_api_returns_some_results(x, a, b, expected):
    if b <= a:
        assert "delicious" == expected
    elif a < b <= (a + x):
        assert "safe" == expected
    else:
        assert "dangerous" == expected

