import pytest

@pytest.mark.parametrize('N, M, a, b, expected', [
    (1, 1, 1, 1, [2]),
    (2, 1, 1, 2, [1, 1]),
    (2, 2, 1, 2, [2, 2]),
    (2, 2, 1, 1, [2, 2]),
    (2, 2, 2, 1, [2, 2]),
    (2, 2, 2, 2, [2, 2]),
])
def test_that_api_returns_some_results(N, M, a, b, expected):
    ANS = [0] * N
    for _ in range(M):
        ANS[a-1] += 1
        ANS[b-1] += 1
    assert ANS == expected

