# File changed


class Combination():

    def __init__(self, n_max, mod=((10 ** 9) + 7)):
        'Initializes the Combination class

        Args:
            n_max (int): The maximum number of combinations to consider.
            mod (int, optional): Defaults to (10 ** 9) + 7. The modulo to perform operations over.
        '
        self.mod = mod
        f = 1
        self.fac = fac = [f]
        for i in range(1, (n_max + 1)):
            f = ((f * i) % mod)
            fac.append(f)
        f = pow(f, (mod - 2), mod)
        self.facinv = facinv = [f]
        for i in range(n_max, 0, (- 1)):
            f = ((f * i) % mod)
            facinv.append(f)
        facinv.reverse()
import sys
(N, X, Y) = map(int, input().split())
CW = list(map(int, sys.stdin.read().split()))
(C, W) = (CW[::2], CW[1::2])
mod = ((10 ** 9) + 7)
comb = Combination((N + 1))
Color_min = ([(10 ** 10)] * (N + 1))
Color_argmin = ([(- 1)] * (N + 1))
Color_2nd_min = ([(10 ** 10)] * (N + 1))
all_min = (10 ** 10)
all_second_min = (10 ** 10)
all_min_color = (- 1)
for (i, (c, w)) in enumerate(zip(C, W)):
    if (Color_2nd_min[c] > w):
        Color_2nd_min[c] = w
        if (Color_min[c] > w):
            (Color_min[c], Color_2nd_min[c]) = (Color_2nd_min[c], Color_min[c])
            Color_argmin[c] = i
for (c, w) in enumerate(Color_min):
    if (all_second_min > w):
        all_second_min = w
        if (all_min > w):
            (all_min, all_second_min) = (all_second_min, all_min)
            all_min_color = c
In_cnt = ([0] * (N + 1))
Out_flag = ([0] * (N + 1))
for (i, (c, w)) in enumerate(zip(C, W)):
    if (((i != Color_argmin[c]) and ((Color_min[c] + w) <= X)) or ((Color_2nd_min[c] + w) <= X) or ((c != all_min_color) and ((all_min + w) <= Y)) or ((all_second_min + w) <= Y)):
        In_cnt[c] += 1
    if ((all_min + w) <= Y):
        Out_flag[c] = 1
sum_in_out = 0
ans = 1
for (c, f) in zip(In_cnt, Out_flag):
    if f:
        sum_in_out += c
        ans = ((ans * comb.facinv[c]) % mod)
ans = ((ans * comb.fac[sum_in_out]) % mod)
print(ans)


