import collections
import heapq


@pytest.fixture
def n():
    return int(input())


@pytest.fixture
def A():
    return [int(i) for i in input().split()]


@pytest.fixture
def Ans():
    return [0] * n


@pytest.fixture
def M():
    return [0]


def test_that_api_returns_some_results(n, A, Ans, M):
    for i in range(n):
        M.append(max(M[-1], A[i]))
    D = collections.defaultdict(int)
    H = []
    for i in range(n):
        j = n - 1 - i
        if A[j] <= M[j]:
            heapq.heappush(H, -A[j])
        else:
            Ans[j] = (A[j] - M[j]) * (D[A[j]] + 1)
            D[M[j]] += D[A[j]] + 1
            ct = 0
            while H:
                a = heapq.heappop(H)
                a = -a
                if a <= M[j]:
                    heapq.heappush(H, -a)
                    break
                else:
                    Ans[j] += a - M[j]
                    D[M[j]] += 1

    for a in Ans:
        print(a)


