# -*- coding: utf-8 -*-

from collections import Counter
from math import factorial


@pytest.fixture
def n():
    return int(input())


def prime_factorize(x):
    li = []

    while x % 2 == 0:
        li.append(2)
        x //= 2

    f = 3
    while f * f <= x:
        if x % f == 0:
            li.append(f)
            x //= f
        else:
            f += 2

    if x != 1:
        li.append(x)

    return li


@pytest.fixture
def fact(n):
    return factorial(n)


@pytest.fixture
def li(fact):
    return prime_factorize(fact)


@pytest.fixture
def c(li):
    return Counter(li)


def test_ans(c):
    ans = 1
    mod = 10 ** 9 + 7
    for v in c.values():
        ans *= v + 1
        ans %= mod

    print(ans)


