import pytest

@pytest.mark.parametrize('k,s,expected', [
    (1, 1, 2),
    (2, 2, 6),
    (3, 3, 14),
    (4, 4, 30),
    (5, 5, 56),
    (6, 6, 94),
    (7, 7, 154),
    (8, 8, 234),
    (9, 9, 346),
    (10, 10, 482),
])
def test_count_ways_to_climb_stairs(k, s, expected):
    ans = 0
    for i in range(k + 1):
        for j in range(k + 1):
            if 0 <= i + j <= s and s - i - j <= k:
                ans += 1
    assert ans == expected

