# File changed

import math as m
P = list(map((lambda x: (float(x) / 100)), input().split()))
Q = list(map((lambda x: (float(x) / 100)), input().split()))

def calc(x):
    prob = []
    for (p, q) in zip(P, Q):
        prob.append(max((p * x), (q * (1 - x))))
    return sum(prob)
phi = ((1 + m.sqrt(5)) / 2)
(l, r) = (0, 1)
(x1, x2) = ((((l * phi) + r) / (1 + phi)), ((l + (r * phi)) / (1 + phi)))
(f1, f2) = (calc(x1), calc(x2))
while True:
    if (f1 > f2):
        (l, x1) = (x1, x2)
        x2 = ((l + (r * phi)) / (1 + phi))
        (f1, f2) = (f2, calc(x2))
    else:
        (x2, r) = (x1, x2)
        x1 = (((l * phi) + r) / (1 + phi))
        (f1, f2) = (calc(x1), f1)
    if (abs((l - r)) < 1e-12):
        break
print(('%.12lf' % f1))
