import sys
readline = sys.stdin.readline
readlines = sys.stdin.readlines
import numpy as np
N = int(readline())
lr = [tuple((int(x) for x in line.split())) for line in readlines()]
lr.sort(key=lambda x: (-x[1]-x[0]))
inf = 10**18
dp0 = np.full(N+1, inf, np.int64)
dp1 = np.full(N+1, inf, np.int64)
if N&1:
  dp0[0] = 0
else:
  dp1[0] = 0
for n,(L,R) in enumerate(lr):
  length = R+L
  prev0 = dp0
  prev1 = dp1
  dp0 = np.full(N+1, inf, np.int64)
  dp1 = np.full(N+1, inf, np.int64)
  x = np.arange(n+1, dtype=np.int64)
  np.minimum(prev0[:n+1]+R+x*length, dp0[1:n+2], out=dp0[1:n+2])
  np.minimum(prev1[:n+1]+R+x*length, dp1[1:n+2], out=dp1[1:n+2])
  np.minimum(prev0[:n+1]+L+(n-x)*length, dp0[:n+1], out=dp0[:n+1])
  np.minimum(prev1[:n+1]+L+(n-x)*length, dp1[:n+1], out=dp1[:n+1])
  np.minimum(prev0[:n+1]+((N-1)//2)*length, dp1[:n+1], out=dp1[:n+1])
answer = dp1[(N//2)]
print(answer)

