import pytest

@pytest.mark.parametrize('x, p, expected', [
    (10, 10, 100),
    (10, 20, 50),
    (10, 30, 33),
    (10, 40, 25),
    (10, 50, 20),
    (10, 60, 16),
    (10, 70, 14),
    (10, 80, 12),
    (10, 90, 11),
    (10, 100, 10),
])
def test_that_formula_works(x, p, expected):
    p *= 0.01
    assert ((x+1)//2/p) == expected

