# File changed

(N, M) = map(int, input().split())
from collections import defaultdict
root = ([(- 1)] * (N + M))

def find(i):
    'Finds the root of the tree

    Args:
        i (int): The index of the tree to find the root of.

    Returns:
        int: The root of the tree.
    '
    global root
    if (root[i] >= 0):
        root[i] = find(root[i])
        return root[i]
    return i

def make(a, b):
    'Makes a union of two trees

    Args:
        a (int): The index of the first tree.
        b (int): The index of the second tree.
    '
    global root
    ra = find(a)
    rb = find(b)
    if (ra == rb):
        return
    elif (root[ra] <= root[rb]):
        root[ra] += root[rb]
        root[rb] = ra
    else:
        root[rb] += root[ra]
        root[ra] = rb
    return
for i in range(N):
    X = list(map(int, input().split()))
    for k in range(X[0]):
        make(i, ((N + X[(k + 1)]) - 1))
r0 = find(0)
flag = True
for i in range(1, N):
    if (find(i) != r0):
        flag = False
        break
if flag:
    print('YES')
else:
    print('NO')


