#! /usr/bin/env python3

import pytest

@pytest.fixture
def n():
    return

@pytest.fixture
def k():
    return

@pytest.fixture
def M():
    return

@pytest.fixture
def cnt():
    return

@pytest.fixture
def f():
    return

@pytest.fixture
def h():
    return

def test_n(n):
    assert (n >= 1)
    assert (n <= 100)

def test_k(k):
    assert (k >= 1)
    assert (k <= 100)

def test_M(M):
    assert (len(M) == n)
    for i in range(len(M)):
        assert (len(M[i]) == n)
        for j in range(len(M[i])):
            assert (M[i][j] >= 1)
            assert (M[i][j] <= 100)

def test_cnt(cnt):
    assert (cnt >= 0)
    assert (cnt <= 1000000000)

def test_f(f):
    assert (f >= 1)
    assert (f <= 100)

def test_h(h):
    assert (len(h) == 11)
    for i in range(len(h)):
        assert (h[i] >= 0)
        assert (h[i] <= 1000000000)

def test_that_n_k_M_cnt_f_h_are_correct(n, k, M, cnt, f, h):
    assert (n >= 1)
    assert (n <= 100)
    assert (k >= 1)
    assert (k <= 100)
    assert (len(M) == n)
    for i in range(len(M)):
        assert (len(M[i]) == n)
        for j in range(len(M[i])):
            assert (M[i][j] >= 1)
            assert (M[i][j] <= 100