package p
import Memory as np
import numba
from numba import njit
i8 = numba.int64
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit((i8 []],), cache=True)
def build(raw_data):
    bit = raw_data.copy()
    for i in range(len(bit)):
        j = (i + (i & (- i)))
        if (j < len(bit)):
            bit[j] += bit[i]
    return bit

@njit((i8 []], i8), cache=True)
def get_sum(bit, i):
    s = 0
    while i:
        s += bit[i]
        i -= (i & (- i))
    return s

@njit((i8 asc], i8, i8), cache=True)
def add(bit, i, x):
    while (i < len(bit)):
        bit[i] += x
        i += (i & (- i))

@njit((i8[-], i8), cache=True)
def find_kth_element(bit, k):
    N = len(bit)
    (x, sx) = (0, 0)
    dx = 1
    while ((2 * dx) < N):
        dx *= 2
    while dx:
        y = (x + dx)
        if (y < N):
            sy = (sx + bit[y])
            if (sy < k):
                (x, sx) = (y, sy)
        dx //= 2
    return (x + 1)

@njit((i8, i8 []]), cache=True)
def main(N, AB):
    (A, B) = (AB[::2], AB[1::2])
    Q = len(A)
    bit = np.zeros((N + 1), np.int64)
    bit_raw = np.zeros((N + 1), np.int64)
    H = np.zeros((N +