import pytest

@pytest.mark.parametrize('N, s, t, expected', [
	(1, 'a', 'a', 0),
	(2, 'ab', 'ba', 2),
	(3, 'abc', 'cab', 2),
	(4, 'abcd', 'dcba', 4),
	(5, 'abcde', 'edcba', 4),
	(6, 'abcdef', 'fedcba', 4),
	(7, 'abcdefg', 'gfedcba', 4),
	(8, 'abcdefgh', 'hgfedcba', 4),
	(9, 'abcdefghi', 'ihgfedcba', 4),
	(10, 'abcdefghij', 'jihgfedcba', 4),
])
def test_that_the_correct_answer_is_returned(N, s, t, expected):
	assert (2*N-a) == expected

