def merge_and_count_rec(A, W, l, r):
    if l+1 >= r:
        return 0
    m = (l+r)//2
    cnt  = merge_and_count_rec(A, W, l, m)
    cnt += merge_and_count_rec(A, W, m, r)
    i,j,k = l,m,l
    while i<m and j<r:
        if A[i]<=A[j]:
            W[k] = A[i]
            i+=1
        else:
            W[k] = A[j]
            j+=1
            cnt += m-i
        k+=1
    if i<m:
        W[k:r] = A[i:m]
    if j<r:
        W[k:r] = A[j:r]
    A[l:r] = W[l:r]
    return cnt

@pytest.mark.parametrize('N,A,O,ok,flip', [
    (1, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (2, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (3, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (4, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (5, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (6, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (7, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (8, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (9, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (10, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (11, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (12, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (13, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (14, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (15, ([1, 2, 3], [1, 2, 3], [1, 2, 3]), [], True, [0, 0]),
    (16, ([1, 2, 3], [1, 