
import sys
input = sys.stdin.readline
sys.setrecursionlimit((10 ** 7))
import numpy as np
'\nそれぞれの隣接2列ごとに、可能な摩擦の最小値を実現する → 小問題に分割。\n'
buffer = sys.stdin.buffer
(H, W) = map(int, buffer.readline().split())
C = np.frombuffer(buffer.read(), dtype='S1').reshape(H, (- 1))[:, :W].T
dp_1 = np.zeros(((W - 1), ((H + H) + 1), (H + 1)), dtype=np.int64)
for r in range(H):
    dp_1[:, (r + 2):((r + H) + 2), (r + 1)] = (C[:(- 1)] == C[1:, r][:, None])
INF = (10 ** 18)
dp = np.full(((W - 1), (H + 1)), INF, dtype=np.int64)
dp[:, 0] = 0
for n in range(1, ((H + H) + 1)):
    if (n >= 2):
        dp_1[:, n, 1:] += dp_1[:, (n - 2), :(- 1)]
    prev = dp
    dp = np.full(((W - 1), (H + 1)), INF, dtype=np.int64)
    dp[:, 1:] = np.minimum(dp[:, 1:], prev[:, :(- 1)])
    dp[:, :] = np.minimum(dp[:, :], prev[:, :])
    dp += dp_1[:, n, :]
answer = dp[:, H].sum()
print(answer)
