# File changed

import sys
import itertools
from scipy.sparse import csr_matrix, lil_matrix
from scipy.sparse.csgraph import maximum_flow
(h, w) = map(int, sys.stdin.buffer.readline().split())
s = b''.join(sys.stdin.buffer.read().split())
source = ((2 * h) * w)
sink = (source + 1)
inf = (source * 2)
graph = lil_matrix(((sink + 1), (sink + 1)), dtype=int)
for i in range((h * w)):
    (x, y) = divmod(i, w)
    if (s[i] == ord('.')):
        graph[((2 * i), ((2 * i) + 1))] = 1
    else:
        graph[(source, ((2 * i) + 1))] = inf
    for (dx, dy) in ((1, 0), ((- 1), 0), (0, 1), (0, (- 1))):
        (x1, y1) = ((x + dx), (y + dy))
        if ((0 <= x1 < h) and (0 <= y1 < w)):
            j = ((x1 * w) + y1)
            graph[(((2 * i) + 1), (2 * j))] = 1
        else:
            graph[(((2 * i) + 1), sink)] = inf
graph = graph.tocsr()
ans = maximum_flow(graph, source, sink).flow_value
ans = (ans if (ans < inf) else (- 1))
print(ans)



