# File changed

from collections import defaultdict
import sys

sys.setrecursionlimit(10**6)

def read_input():
    return [int(i) for i in input().split(' ')]

(R, C) = read_input()
n = int(input())
vector_set = set()
grid = defaultdict(list)
for i in range(n):
    (r, c, a) = read_input()
    grid[('R', r)].append((('C', c), a))
    grid[('C', c)].append((('R', r), a))
    vector_set.add(('R', r))
    vector_set.add(('C', c))

def iteration(vector):
    vector_set.discard(vector)
    for (v, a) in grid[vector]:
        temp = (a - vector_cover[vector])
        if (v in vector_cover):
            if (temp != vector_cover[v]):
                print('No')
                exit()
        else:
            vector_cover[v] = temp
            iteration(v)
while (len(vector_set) != 0):
    vector = vector_set.pop()
    vector_cover = dict()
    vector_cover[vector] = 0
    iteration(vector)
    min_r = min((a for (p, a) in vector_cover.items() if (p[0] == 'R')))
    min_c = min((a for (p, a) in vector_cover.items() if (p[0] == 'C')))
    if ((min_r + min_c) < 0):
        print('No')
        exit()
print('Yes')



