# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
(N, m, k) = map(int, read().split())
MOD = ((10 ** 9) + 7)

def cumprod(arr, MOD):
    L = len(arr)
    lsq = int(((L ** 0.5) + 1))
    arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
    for n in range(1, lsq):
        arr[(:, n)] *= arr[(:, (n - 1))]
        arr[(:, n)] %= MOD
    for n in range(1, lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:L]

def make_fact(U, MOD):
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    factinv = cumprod(x, MOD)[::(- 1)]
    return (fact, factinv)

def make_power(a, L, MOD):
    b = L.bit_length()
    x = np.empty((1 + (1 << b)), np.int64)
    x[0] = 1
    x[1] = a
    for n in range(b):
        x[(1 << n):(1 << (n + 1))] = ((x[:(1 << n)] * ((a * x[((1 << n) - 1)]) % MOD)) % MOD)
    return x[:L]
U = (10 ** 6)
power2 = make_power(2, U, MOD)
power2inv = make_power(pow(2, (MOD - 2), MOD), U, MOD)
power3 = make_power(3, U, MOD)
power3inv = make_power(pow(3, (MOD - 2), MOD), U, MOD)
(fact, factinv) = make_fact(U, MOD)
x = np.zeros((N + m), np.int64)
x[1:] = ((((- 1) * power2[:((N + m) - 1)]) * power3inv[(k + 1):((N + m) + k)]) % MOD)
x[1:] *= ((((fact[(k + 1):((N + m) + k)] * factinv[k]) % MOD) * factinv[1:(N + m)]) % MOD)
x %= MOD
x[0] = ((((3 * (1 - power3inv[(k + 1)])) % MOD) * power2inv[1]) % MOD)
np.cumsum(x, out=x)
x %= MOD
x *= ((power3[:(N + m)] * power2inv[:(N + m)]) % MOD)
x %= MOD
coef = ((((fact[(N - 1):(N + m)] * factinv[:(m + 1)]) % MOD) * factinv[(N - 1)]) % MOD)
coef *= power3[k:((k + m) + 1)][::(- 1)]
coef %= MOD
answer = (((coef * x[(N - 1):(N + m)]) % MOD).sum() % MOD)
print(answer)

