import pytest

@pytest.mark.parametrize('N, K, X, Y, expected', [
    (1, 1, 1, 1, 1),
    (1, 2, 1, 1, 1),
    (2, 1, 1, 1, 1),
    (2, 2, 1, 1, 2),
    (1, 1, 1, 2, 2),
    (1, 2, 1, 2, 2),
    (2, 1, 1, 2, 2),
    (2, 2, 1, 2, 4),
    (1, 1, 2, 1, 2),
    (1, 2, 2, 1, 2),
    (2, 1, 2, 1, 2),
    (2, 2, 2, 1, 4),
    (1, 1, 2, 2, 4),
    (1, 2, 2, 2, 4),
    (2, 1, 2, 2, 4),
    (2, 2, 2, 2, 8),
])
def test_min_max_sum(N, K, X, Y, expected):
    assert min(K,N)*X + max((N-K),0)*Y == expected

