import pytest

@pytest.mark.parametrize('N, A, x, y', [
    (1, [1], {1}, {1}),
    (2, [1, 2], {1}, {1, 2}),
    (3, [1, 2, 3], {1, 3}, {1, 2, 3}),
    (4, [1, 2, 3, 4], {1, 3}, {1, 2, 3, 4}),
    (5, [1, 2, 3, 4, 5], {1, 3, 5}, {1, 2, 3, 4, 5}),
    (6, [1, 2, 3, 4, 5, 6], {1, 3, 5}, {1, 2, 3, 4, 5, 6}),
    (7, [1, 2, 3, 4, 5, 6, 7], {1, 3, 5, 7}, {1, 2, 3, 4, 5, 6, 7}),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], {1, 3, 5, 7}, {1, 2, 3, 4, 5, 6, 7, 8}),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], {1, 3, 5, 7, 9}, {1, 2, 3, 4, 5, 6, 7, 8, 9}),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], {1, 3, 5, 7, 9}, {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}),
])
def test_that_api_returns_some_results(N, A, x, y):
    assert (len(x)-len(x&y)) == 1

