Primes = [p for (p, is_p) in enumerate(make_prime_checker(2200)) if is_p]

def decomp(n):
    res1 = res2 = 1
    for p in Primes:
        cnt = 0
        while ((n % p) == 0):
            n //= p
            cnt += 1
        cnt %= 3
        if (cnt == 1):
            res1 *= p
        elif (cnt == 2):
            res2 *= p
    if ((int((n ** 0.5)) ** 2) == n):
        res2 *= int((n ** 0.5))
    else:
        res1 *= n
    return (((res1 * res2) * res2), ((res1 * res1) * res2))

(N, *S) = map(int, sys.stdin.buffer.read().split())
T = [decomp(s)[0] for s in S]
counter_T = Counter(T)
ans = 0
for (t, t_cnt) in counter_T.items():
    if (t == 1):
        ans += 1
        continue
    t_inv = decomp(t)[1]
    t_inv_cnt = counter_T[t_inv]
    if ((t_cnt > t_inv_cnt) or ((t_cnt == t_inv_cnt) and (t > t_inv))):
        ans += t_cnt
print(ans)

'''
