import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np

h, w, K = map(int, readline().split())
s = np.frombuffer(read(), 'S1').reshape(h, -1)[:, :w] == '#'
MOD = 10**9+7
if K in [0, 1]:
    print(1)
    exit()
b = np.count_nonzero(s)
if h == 1 or w == 1:
    if b == h*w:
        answer = 1
    else:
        answer = pow(b, K-1, MOD)
    print(answer)
    exit()
concath = s[:, 0] & s[:, -1]
concatw = s[0] & s[-1]
blh = np.any(concath)
blw = np.any(concatw)
if blh and blw:
    print(1)
    exit()
if not blh and not blw:
    answer = pow(b, K-1, MOD)
    print(answer)
    exit()
if blw:
    h, w = w, h
    s = s.T
    concath, concatw = concatw, concath

def power_mat(A, n, MOD):
    k = A.shape[0]
    if n == 0:
        return np.eye(k, dtype=np.int64)
    b = power_mat(A, n//2, MOD)
    b = (np.dot(b, b) % MOD)
    return (np.dot(A, b) % MOD if n & 1 else b)

hedge = np.count_nonzero(s[:, : -1] & s[:, 1 :])
A = np.array([[b, -hedge], [0, np.count_nonzero(concath)]], np.int64)
answer = (power_mat(A, K-1, MOD)[0].sum() % MOD)
print(answer)
