# -*- coding: utf-8 -*-
import pytest

@pytest.mark.parametrize("a, b, expected", [
    (1, 2, "Positive"),
    (-1, 2, "Negative"),
    (1, -2, "Negative"),
    (-1, -2, "Positive"),
    (0, 0, "Zero"),
])
def test_sign(a, b, expected):
    if 0 < a:
        actual = "Positive"
    elif a * b <= 0:
        actual = "Zero"
    elif a < 0 and (b - a + 1) % 2 == 1:
        actual = "Negative"
    else:
        actual = "Positive"
    assert actual == expected

