import pytest

N, M = map(int, input().split())

b = [1] * N
b[0] = -1
for i in range(M):
    x, y = map(int, input().split())
    if b[x - 1] < 0:
        b[x - 1] += 1
        if b[y - 1] >= 0:
            b[y - 1] = -(b[y - 1] + 1)
        else:
            b[y - 1] -= 1
    else:
        b[x - 1] -= 1
        if b[y - 1] >= 0:
            b[y - 1] += 1
        else:
            b[y - 1] -= 1
print(len([x for x in b if x < 0]))

@pytest.mark.parametrize('N, M, expected', [
    (1, 1, 1),
    (2, 2, 2),
    (3, 3, 3),
    (4, 4, 4),
    (5, 5, 5),
    (6, 6, 6),
    (7, 7, 7),
    (8, 8, 8),
    (9, 9, 9),
    (10, 10, 10),
])
def test_that_api_returns_some_results(N, M, expected):
    assert (len([x for x in b if x < 0]) == expected)

