import pytest

@pytest.mark.parametrize('N, L, ans', [
    (1, [1], 1),
    (2, [1, 2], 3),
    (3, [1, 2, 3], 6),
    (4, [1, 2, 3, 4], 10),
    (5, [1, 2, 3, 4, 5], 15),
    (6, [1, 2, 3, 4, 5, 6], 21),
    (7, [1, 2, 3, 4, 5, 6, 7], 28),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 36),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 45),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 55),
])
def test_that_min_sum_is_correct(N, L, ans):
    L.sort()
    assert (sum(L[2*i] for i in range(N)) + sum(L[2*i+1] for i in range(N)) == ans)

