# File changed

from collections import deque

def reachable_points(root_v, cant_visit_v):
  visited = [0] * n
  visited[root_v] = visited[cant_visit_v] = 1
  q = deque([(root_v, 0)])
  ret = 0
  while q:
    v, dep = q.popleft()
    if dep == k // 2:
      break
    for to, _ in tr[v]:
      if visited[to]:
        continue
      ret += 1
      q.append((to, dep + 1))
      visited[to] = 1
  return ret

def reachable_edges(root_e):
  a, b = es[root_e]
  return reachable_points(a, b) + reachable_points(b, a)

n, k = map(int, input().split())
es = [tuple(map((lambda x: (int(x) - 1)), input().split())) for i in range(n - 1)]
tr = [[] for i in range(n)]
for i, (a, b) in enumerate(es):
  tr[a].append((b, i))
  tr[b].append((a, i))

if k % 2:
  ans = n
  for center_e in range(n - 1):
    ans = min(ans, (n - 2) - reachable_edges(center_e))
  print(ans)
else:
  ans = n
  for center_v in range(n):
    ans = min(ans, (n - 1) - reachable_points(center_v, center_v))
  print(ans)

