# File changed

import sys
import heapq, functools, collections
import math, random
from collections import Counter, defaultdict

def solve(grid, n):
    console('----- solving ------')
    grid = [((x - 1), (y - 1)) for (x, y) in grid]
    m = {}
    for (i, (x, y)) in enumerate(grid):
        m[x] = i
    grid = sorted(grid)
    console(grid)
    g = defaultdict(list)
    yheap = []
    heapq.heapify(yheap)
    for (x, y) in grid:
        if yheap:
            (ymin, xmin) = yheap[0]
            if (ymin < y):
                while (yheap and (yheap[0] < (y, x))):
                    (ycur, xcur) = heapq.heappop(yheap)
                    g[x].append(xcur)
                    g[xcur].append(x)
                heapq.heappush(yheap, (ymin, xmin))
        heapq.heappush(yheap, (y, x))
    console(g)
    res = [0 for _ in grid]
    visited1 = [0 for _ in grid]
    visited2 = [0 for _ in grid]
    for i in range(n):
        if res[i]:
            continue
        visited1[i] = 1
        stack = [i]
        cnt = 1
        while stack:
            cur = stack.pop()
            for nex in g[cur]:
                if (not visited1[nex]):
                    cnt += 1
                    visited1[nex] = 1
                    stack.append(nex)
        visited2[i] = 1
        stack = [i]
        while stack:
            cur = stack.pop()
            res[cur] = cnt
            for nex in g[cur]:
                if (not visited2[nex]):
                    visited2[nex] = 1
                    stack.append(nex)
    console(res)
    console(visited1)
    console(visited2)
    res2 = [0 for _ in grid]
    for (i, x) in m.items():
        res2[x] = res[i]
    return res2

def console(*args):
    return

inp = sys.stdin.readlines()
for case_num in [1]:
    nrows = int(inp[0])
    grid = []
    for n in range(nrows):
        grid.append(list(map(int, inp[(n + 1)].split())))
    res = solve(grid, nrows)
    res = '\n'.join((str(x) for x in res))
    print(res)



