# File changed

import sys
import numpy as np
import numba
from numba import i8
input = sys.stdin.buffer.readline
mod = 998244353

def i():
    return int(input())

def mi():
    return map(int, input().split())

@numba.njit((i8, i8[:]), cache=True)
def main(n, lr):
    (l, r) = (lr[::2], lr[1::2])
    k = len(l)
    dp = np.zeros((n + 1), np.int64)
    dpsum = np.zeros((n + 1), np.int64)
    dp[1] = 1
    dpsum[1] = 1
    for i in range(2, (n + 1)):
        for k in range(k):
            li = (i - r[k])
            ri = (i - l[k])
            if ri < 0:
                continue
            li = max(li, 1)
            dp[i] += (dpsum[ri] - dpsum[(li - 1)])
            dp[i] %= mod
        dpsum[i] = (dpsum[(i - 1)] + dp[i])
        dpsum[i] %= mod
    return dp[n]
(n, k) = mi()
lr = np.array(sys.stdin.buffer.read().split(), np.int64)
print(main(n, lr))



