' File changed

import sys
import numpy as np

def main():
    'Reads in the number of black tiles and the number of queries

    Args:
        N (int): The number of black tiles.
        Q (int): The number of queries.

    Returns:
        int: The number of black tiles.
    '
    (N, Q) = map(int, sys.stdin.readline().rstrip().split())
    H = np.array(([0] * (N - 1)))
    W = np.array(([0] * (N - 1)))
    black = ((N - 2) ** 2)
    Hmin = (N - 1)
    Wmin = (N - 1)
    for i in range(Q):
        'Reads in the number of black tiles and the number of queries

        Args:
            n (int): The number of black tiles.
            x (int): The number of queries.

        Returns:
            int: The number of black tiles.
        '
        (n, x) = map(int, sys.stdin.readline().rstrip().split())
        if (n == 1):
            if ((x - 1) <= Wmin):
                W[(x - 1):Wmin] = (Hmin - 1)
                Wmin = (x - 1)
            black -= W[(x - 1)]
        else:
            if ((x - 1) <= Hmin):
                H[(x - 1):Hmin] = (Wmin - 1)
                Hmin = (x - 1)
            black -= H[(x - 1)]
    print(black)
main()


