# File changed

import sys
input = sys.stdin.readline

def solve():

    def makeBIT(numEle):
        numpow2 = (2 ** (numEle - 1).bit_length())
        data = ([0] * (numpow2 + 1))
        return (data, numpow2)

    def setInit(As):
        for (iB, A) in enumerate(As, 1):
            data[iB] = A
        for iB in range(1, numpow2):
            i = (iB + (iB & (- iB)))
            data[i] += data[iB]

    def addValue(iA, A):
        ib = (iA + 1)
        while (ib <= numpow2):
            data[ib] += A
            ib += (ib & (- ib))

    def getSum(iA):
        ib = (iA + 1)
        ans = 0
        while (ib > 0):
            ans += data[ib]
            ib -= (ib & (- ib))
        return ans

    def getRangeSum(iFr, iTo):
        return (getSum(iTo) - getSum((iFr - 1)))
    (n, q) = map(int, input().split())
    As = list(map(int, input().split()))
    (data, numpow2) = makeBIT(n)
    setInit(As)
    anss = []
    for _ in range(q):
        (t, i, j) = map(int, input().split())
        if (t == 0):
            addValue(i, j)
        else:
            anss.append(getRangeSum(i, (j - 1)))
    print('\n'.join(map(str, anss)))
solve()

