# File changed

'\nとても雑な計測で\n\nimport 330ms\nノード・エッジリストの計算 400ms\nGraph オブジェクト生成 420ms\nマッチングの計算 510ms\n加工して出力 530ms\n'
import sys
import itertools
import numpy as np
import networkx as nx
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
(n, m) = map(int, readline().split())
s = np.frombuffer(read(), 'S1').reshape(n, (- 1))[(:, :m)].astype('U1')
A = []
B = []
e = []
for (i, j) in itertools.product(range(n), range(m)):
    if s[(i, j)] == '#':
        continue
    elif (i + j) & 1:
        A.append((i, j))
    else:
        B.append((i, j))
for (i, j) in A:
    for (dx, dy) in ((1, 0), ((- 1), 0), (0, 1), (0, (- 1))):
        (i1, j1) = ((i + dx), (j + dy))
        if (0 <= i1 < n) and (0 <= j1 < m) and (s[(i1, j1)] != '#'):
            e.append(((i, j), (i1, j1)))
g = nx.Graph()
g.add_nodes_from(A, bipartite=0)
g.add_nodes_from(B, bipartite=1)
g.add_edges_from(e)
m = nx.bipartite.maximum_matching(g, A)
for (key, item) in m.items():
    (i, j) = key
    (i1, j1) = item
    if i1 == (i + 1):
        (a, b) = ('v', '^')
    elif i1 == (i - 1):
        (a, b) = ('^', 'v')
    elif j1 == (j + 1):
        (a, b) = ('>', '<')
    else:
        (a, b) = ('<', '>')
    (s[(i, j)], s[(i1, j1)]) = (a, b)
print(len(m) // 2)
for row in s:
    print(''.join(row))



