
'\nとても雑な計測で\n\nimport 330ms\nノード・エッジリストの計算 400ms\nGraph オブジェクト生成 420ms\nマッチングの計算 510ms\n加工して出力 530ms\n'
import sys
import itertools
import numpy as np
import networkx as nx
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
(N, M) = map(int, readline().split())
S = np.frombuffer(read(), 'S1').reshape(N, (- 1))[:, :M].astype('U1')
A = [(i, j) for (i, j) in itertools.product(range(N), range(M)) if S[(i, j)] != '#' and (i + j) & 1]
B = [(i, j) for (i, j) in itertools.product(range(N), range(M)) if S[(i, j)] != '#' and not (i + j) & 1]
E = [(key, item) for (key, item) in itertools.product(A, B) if (key[0] + key[1]) & 1 == (item[0] + item[1]) & 1]
G = nx.Graph()
G.add_nodes_from(A, bipartite=0)
G.add_nodes_from(B, bipartite=1)
G.add_edges_from(E)
M = nx.bipartite.maximum_matching(G, A)
for (key, item) in M.items():
    (i, j) = key
    (i1, j1) = item
    if (i1 == (i + 1)):
        (a, b) = ('v', '^')
    elif (i1 == (i - 1)):
        (a, b) = ('^', 'v')
    elif (j1 == (j + 1)):
        (a, b) = ('>', '<')
    else:
        (a, b) = ('<', '>')
    (S[(i, j)], S[(i1, j1)]) = (a, b)
print((len(M) // 2))
for row in S:
    print(''.join(row))


Transformed code:

'\nとても雑な計測で\n\nimport 330ms\nノード・エッジリストの計算 400ms\nGraph オブジェクト生成 420ms\nマッチングの計算 510ms\n加工して出力 530ms\n'
import sys
import itertools
import numpy as np
import networkx as nx
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
(N, M) = map(int, readline().split())
S = np.frombuffer(read(), 'S1').reshape(N, (- 1))[:, :M].astype('U1')
A = [(i, j) for (i, j) in itertools.product(range(N), range(M)) if S[(i, j)] != '#' and (i + j) & 1]
B = [(i, j) for (i, j) in itertools.product(range(N), range(M)) if S[(i, j)] != '#' and not (i + j) & 1]
E = [(key, item) for (key, item) in itertools.product(A, B) if (key[0] + key[1]) & 1 == (item[0] + item[1]) & 1]
G = nx.Graph()
G.add_nodes_from(A, bipartite=0)
G.add_nodes_from(B