import sys
input = lambda: sys.stdin.readline().rstrip()
def scc(E):
    n = len(E)
    iE = [[] for _ in range(n)]
    for i, e in enumerate(E):
        for v in e:
            iE[v].append(i)
    T = []
    done = [0] * n # 0 -> 1 -> 2
    ct = 0
    for i0 in range(n):
        if done[i0]: continue
        Q = [~i0, i0]
        while Q:
            i = Q.pop()
            if i < 0:
                if done[~i] == 2: continue
                done[~i] = 2
                T.append(~i)
                ct += 1
                continue
            if i >= 0:
                if done[i]: continue
                done[i] = 1
            for j in E[i]:
                if done[j]: continue
                Q.append(~j)
                Q.append(j)
    
    done = [0] * n
    SCC = []
    for i0 in T[::-1]:
        if done[i0]: continue
        L = []
        Q = [~i0, i0]
        while Q:
            i = Q.pop()
            if i < 0:
                if done[~i] == 2: continue
                done[~i] = 2
                L.append(~i)
                continue
            if i >= 0:
                if done[i]: continue
                done[i] = 1
            for j in iE[i]:
                if done[j]: continue
                Q.append(~j)
                Q.append(j)
        SCC.append(L)
    return SCC

@pytest.mark.parametrize('N, M, X, S', [
    (1, 0, [], []),
    (2, 0, [[], []], []),
    (2, 1, [[], []], [[1], [0]]),
    (2, 2, [[], []], [[1], [0]]),
    (2, 3, [[], []], [[1], [0]]),
    (2, 4, [[], []], [[1], [0]]),
    (2, 5, [[], []], [[1], [0]]),
    (2, 6, [[], []], [[1], [0]]),
    (2, 7, [[], []], [[1], [0]]),
    (2, 8, [[], []], [[1], [0]]),
    (2, 9, [[], []], [[1], [0]]),
    (2, 10, [[], []], [[1], [0]]),
    (2, 11, [[], []], [[1], [0]]),
    (2, 12, [[], []], [[1], [0]]),
    (2, 13, [[], []], [[1], [0]]),
    (2, 14, [[], []], [[1], [0]]),
    (2, 15, [[], []], [[1], [0]]),
    (2, 16, [[], []], [[1], [0]]),
    (2, 17, [[], []], [[1], [0]]),
    (2, 18, [[], []], [[1], [0]]),
    (2, 19, [[], []], [[1], [0]]),
    (2, 20, [[], []], [[1], [0]]),
    (2, 21, [[], []], [[1], [0]]),
    (2, 22, [[], []], [[1], [0]]),
    (2, 23, [[], []], [[1], [0]]),
    (2, 24, [[], []], [[1], [0]]),
    (2, 25, [[], []], [[1], [0]]),
    (2, 26, [[], []], [[1], [0]]),
    (2, 27, [[], []], [[1], [0]]),
    (2, 28, [[], []], [[1], [0]]),
    (2, 29, [[], []], [[1], [0]]),
    (2, 30, [[], []], [[1], [0]]),
    (2, 31, [[], []], [[1], [0]]),
    (2, 32, [[], []], [[1], [0]]),
    (2, 33, [[], []], [[1], [0]]),
    (2, 34, [[], []], [[1], [0]]),
    (2,