# File changed

import sys
input = sys.stdin.readline
(N, q) = map(int, input().split())
a = list(map(int, input().split()))
seg_el = 1 << N.bit_length()
seg = [0] * (2 * seg_el)
for i in range(N):
    seg[(i + seg_el)] = a[i]
for i in range((seg_el - 1), 0, (- 1)):
    seg[i] = max(seg[(i * 2)], seg[((i * 2) + 1)])

def update(n, x, seg_el):
    i = (n + seg_el)
    seg[i] = x
    i >>= 1
    while (i != 0):
        seg[i] = max(seg[(i * 2)], seg[((i * 2) + 1)])
        i >>= 1

def getvalues(l, r):
    L = (l + seg_el)
    R = (r + seg_el)
    ans = 0
    while (L < R):
        if (L & 1):
            ans = max(ans, seg[L])
            L += 1
        if (R & 1):
            R -= 1
            ans = max(ans, seg[R])
        L >>= 1
        R >>= 1
    return ans

def bisect_on_SEG(l, x):
    L = (l + seg_el)
    R = ((seg_el * 2) - 1)
    while (L < R):
        if (seg[L] >= x):
            break
        if (L & 1):
            L += 1
        L >>= 1
        R >>= 1
    if (seg[L] < x):
        return N
    while (L < seg_el):
        if (seg[(L * 2)] >= x):
            L = (L * 2)
        else:
            L = ((L * 2) + 1)
    return (L - seg_el)
for queries in range(q):
    (t, X, v) = map(int, input().split())
    if (t == 1):
        update((X - 1), v, seg_el)
    elif (t == 2):
        print(getvalues((X - 1), v))
    else:
        print((1 + bisect_on_SEG((X - 1), v)))



