package p
import Memory as np
import numba
from numba import njit, b1, i4, i8, f8
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit(((numba.types.shortcut(i8 asc]),) * 2), cache=True)
def seg_f(x, y):
    if (x is None):
        return y
    if (y is None):
        return x
    (a0, a1, ainv) = x
    (b0, b1, binv) = y
    (c0, c1, cinv) = ((a0 + b0), (a1 + b1), ((ainv + binv) + (a1 * b0)))
    return np.array([c0, c1, cinv], np.int64)

@njit((b1, b1), cache=True)
def lazy_f(a, b):
    return (a ^ b)

@njit((i8 []], b1, xinv) = x
    (x0, x1, xinv) = (x1, x0, ((x0 * x1) - xinv))
    return np.array([x0, x1, xinv], np.int64)

@njit((i8 [], :], b1 []], i8), cache=True)
def _eval_at(seg, lazy, i):
    return operate_f(seg[i], lazy[i])

@njit((i8 [], :], b1 []], i8), cache=True)
def _propagate_at(seg, lazy, i):
    seg[i] = _eval_at(seg, lazy, i)
    lazy[(i << 1)] = lazy_f(lazy[(i << 1)], lazy[i])
    lazy[((i << 1) | 1)] = lazy_f