
from collections import deque


@pytest.fixture
def h():
    return 3

@pytest.fixture
def w():
    return 3

@pytest.fixture
def ch():
    return 1

@pytest.fixture
def cw():
    return 1

@pytest.fixture
def dh():
    return 2

@pytest.fixture
def dw():
    return 2

@pytest.fixture
def l(h, w):
    return [list(input().strip()) for i in range(h)]

@pytest.fixture
def ans(h, w):
    return [[-1]*w for i in range(h)]

@pytest.fixture
def base(h, w):
    base = ["#" * (w + 4)]
    base.append("#" * (w + 4))
    for n in range(h):
        base.append("##" + input() + "##")
    base.append("#" * (w + 4))
    base.append("#" * (w + 4))
    return base

@pytest.fixture
def ans(h, w, base):
    ans = [[-1] * (w + 4) for _ in range(h + 4)]
    for i in range(h + 4):
        for j in range(w + 4):
            if base[i][j] == "#":
                ans[i][j] = -2
    return ans

@pytest.fixture
def ch(ans):
    return 1

@pytest.fixture
def cw(ans):
    return 1

@pytest.fixture
def dh(ans):
    return 2

@pytest.fixture
def dw(ans):
    return 2

@pytest.fixture
def move1():
    return [[1, 0], [-1, 0], [0, 1], [0, -1]]

@pytest.fixture
def move2():
    return [
        [-2, -2], [-2, -1], [-2, 0], [-2, 1], [-2, 2], [-1, -2], [-1, -1],
        [-1, 1], [-1, 2], [0, -2], [0, 2], [1, -2], [1, -1], [1, 1],
        [1, 2], [2, -2], [2, -1], [2, 0], [2, 1], [2, 2]
    ]

@pytest.fixture
def q1():
    return deque([[ch, cw]])

@pytest.fixture
def q2():
    return deque([])

def test_main(h, w, ch, cw, dh, dw, l, ans, base, ans, move1, move2, q1, q2):
    ans[ch][cw] = 0
    q1 = deque([[ch, cw]])
    q2 = deque([])

    while q1:
        x1, y1 = q1.popleft()
        q2.append([x1, y1])
        for i, j in move1:
            nx, ny = x1 + i, y1 + j
            """
            if nx < 0 or h <= nx or ny < 0 or w <= ny:
                continue
            """
            if ans[nx][ny] == -1:
                ans[nx][ny] = ans[x1][y1]
                q1.append([nx, ny])
        if len(q1) == 0:
            while q2:
                x2, y2 = q2.popleft()
                for i, j in move2:
                    mx, my = x2 + i, y2 + j
                    """
                    if mx < 0 or h <= mx or my < 0 or w <= my:
                        continue
                    """
                    if ans[mx][my] == -1:
                        ans[mx][my] = ans[x2][y2] + 1
                        q1.append([mx, my])
    print(ans[dh][dw])

