# File changed

import sys
sys.setrecursionlimit((10 ** 9))
inf = (10 ** 12)
lim = 20
N = int(input())
d = dict()
for _ in range(N):
    (s, c) = input().split()
    if (s in d.keys()):
        d[s] = min(d[s], int(c))
    else:
        d[s] = int(c)

def check_kaibun(s):
    n = len(s)
    return all(((s[i] == s[((- i) - 1)]) for i in range((n // 2))))

def calc_cost(use):
    return sum(((d[s] * n) for (s, n) in use.items()))

def find_candidate(cost, use, s, is_left):
    if check_kaibun(s):
        return min(cost, calc_cost(use))
    if is_left:
        for t in d.keys():
            if (t[::(- 1)].find(s) == 0):
                use[t] += 1
                if (use[t] > lim):
                    return inf
                c = find_candidate(cost, use, t[:(- len(s))], False)
                cost = min(cost, c)
                use[t] -= 1
            elif (s.find(t[::(- 1)]) == 0):
                use[t] += 1
                c = find_candidate(cost, use, s[len(t):], True)
                cost = min(cost, c)
                use[t] -= 1
    else:
        for t in d.keys():
            if (s[::(- 1)].find(t) == 0):
                use[t] += 1
                c = find_candidate(cost, use, s[:(- len(t))], False)
                cost = min(cost, c)
                use[t] -= 1
            elif (t.find(s[::(- 1)]) == 0):
                use[t] += 1
                c = find_candidate(cost, use, t[len(s):], True)
                cost = min(cost, c)
                use[t] -= 1
    return min(cost, inf)

def solve():
    ans = inf
    for s in d.keys():
        use = {s: 0 for s in d.keys()}
        use[s] = 1
        ans = find_candidate(ans, use, s, True)
    return (ans if (ans < inf) else (- 1))
if (__name__ == '__main__'):
    print(solve())

