#!/usr/bin/python3
# Dmitry _kun_ Sayutin (2020)

from fractions import *

@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def mp(n):
    mp = dict()
    for i in range(n):
        var = Fraction(input().strip())
        nom = var.numerator
        denom = var.denominator

        i, j = 0, 0
        
        while denom % 2 == 0:
            i -= 1
            denom //= 2
        
        while denom % 5 == 0:
            j -= 1
            denom //= 5

        while nom % 2 == 0:
            i += 1
            nom //= 2

        while nom % 5 == 0:
            j += 1
            nom //= 5

        i = min(i, 10)
        j = min(j, 10)

        mp[(i, j)] = mp.get((i, j), 0) + 1

    return mp

@pytest.fixture
def ans(mp):
    ans = 0
    for (a, cnt1) in mp.items():
        for (b, cnt2) in mp.items():
            if a < b and a[0] + b[0] >= 0 and a[1] + b[1] >= 0:
                ans += cnt1 * cnt2

    for (a, cnt) in mp.items():
        if a[0] >= 0 and a[1] >= 0:
            ans += cnt * (cnt - 1) // 2
            
    return ans

def test_ans(ans):
    assert ans == 10

