# File changed

import sys
import numpy as np
import numba
from numba import njit, b1, i4, i8, f8
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit((i8[:],), cache=True)
def main(S):
    S = S.copy()
    lind = (np.where((S == (- 1)))[0][:(- 1)] + 1)
    rind = np.where((S == (- 1)))[0][1:]
    n = len(lind)
    for i in range(n):
        S[lind[i]:rind[i]] = S[lind[i]:rind[i]][::(- 1)]
    path = np.zeros_like(S)
    child = np.zeros((len(S), 26), np.int64)
    isend = np.zeros(len(S), np.bool_)
    nnode = 1
    for i in range(n):
        node = 0
        for j in range(lind[i], rind[i]):
            path[j] = node
            if (child[node][S[j]] == 0):
                child[node][S[j]] = nnode
                nnode += 1
            node = child[node][S[j]]
        isend[node] = True
    child = child[:nnode]
    isend = isend[:nnode]
    ans = 0
    for i in range(n):
        se = 0
        for j in range((rind[i] - 1), (lind[i] - 1), (- 1)):
            se |= (1 << S[j])
            node = path[j]
            for k in range(26):
                if (se & (1 << k)):
                    if isend[child[node][k]]:
                        ans += 1
    return (ans - n)
n = int(readline())
S = np.array(list(read().rstrip()), np.int64)
S[(S == ord('\n'))] = (- 1)
S[(S > 0)] -= ord('a')
S = np.insert(S, 0, (- 1))
S = np.append(S, (- 1))
print(main(S))

