import pytest

@pytest.mark.parametrize('N, A, expected', [
    (1, [1], 1),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 2),
    (4, [1, 2, 3, 4], 2),
    (5, [1, 2, 3, 4, 5], 3),
    (6, [1, 2, 3, 4, 5, 6], 3),
    (7, [1, 2, 3, 4, 5, 6, 7], 4),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 4),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 5),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 5),
])
def test_count_odd_numbers(N, A, expected):
    count = 0
    for i in range(len(A)):
        if A[i] % 2 == 1 and (i + 1) % 2 == 1:
            count += 1
    assert count == expected

