import heapq
import pytest
from pytest_cases import parametrize_with_cases


def case_priority():
    return abs(klr[1] - klr[2])


def case_process():
    q = []
    for kp in KP:
        if kp[0] < len(q) and len(q) > 0 and q[0] < kp[1]:
            heapq.heappop(q)
        if kp[0] >= len(q):
            heapq.heappush(q, kp[1])
    return sum(q)


def case_solve():
    N = int(input())
    KLR = []
    for _ in range(N):
        klr = list(map(int, input().split()))
        klr[0] -= 1  # convert to 0-based index to avoid confusion
        KLR.append(klr)
    ans = 0
    L = []
    R = []
    for klr in KLR:
        if klr[1] > klr[2]:
            ans += klr[2]
            L.append((klr[0], klr[1] - klr[2]))
        elif klr[1] < klr[2]:
            ans += klr[1]
            R.append((N - 1 - klr[0] - 1, klr[2] - klr[1]))
        else:
            ans += klr[1]
    L.sort(key=lambda kp: kp[0])
    R.sort(key=lambda kp: kp[0])
    ans += process(L)
    ans += process(R)
    print(ans)


@parametrize_with_cases('priority', cases='.')
def test_priority(priority):
    return


@parametrize_with_cases('process', cases='.')
def test_process(process):
    return


@parametrize_with_cases('solve', cases='.')
def test_solve(solve):
    return


def test_solve_1():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_2():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_3():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_4():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_5():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_6():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_7():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_8():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_9():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_10():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_11():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_12():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_13():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_14():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_15():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_16():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_17():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_18():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_19():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_20():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_21():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_22():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_23():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_24():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_25():
    T = int(input())
    for _ in range(T):
        solve()


def test_solve_26():
    T = int(input())
    for _