# File changed


def solve(ls, k, debug=0):
    modulo = ((10 ** 9) + 7)
    n = len(ls)
    nneg = 0
    for i in range(n):
        nneg += (ls[i] < 0)
    npos = (n - nneg)
    lsabs = [abs(x) for x in ls]
    lsabsargsort = sorted(list(range(n)), key=(lambda i: (- lsabs[i])))
    if (nneg >= k):
        positive = (((k % 2) == 0) or (npos > 0))
    else:
        positive = (((nneg % 2) == 0) or (n > k))
    if (not positive):
        p = 1
        for i in range(k):
            x = ls[lsabsargsort[((- 1) - i)]]
            p *= x
            p %= modulo
        return p
    s = 1
    for i in range(k):
        x = ls[lsabsargsort[i]]
        s *= ((- 1) if (x < 0) else 1)
    if (s > 0):
        p = 1
        for i in range(k):
            x = ls[lsabsargsort[i]]
            p *= x
            p %= modulo
        return p
    opt1 = None
    opt2 = None
    neg1 = pos1 = None
    pos2 = neg2 = None
    swappos = None
    for i in range(k, n):
        if (ls[lsabsargsort[i]] >= 0):
            swappos = i
            pos1 = ls[lsabsargsort[i]]
            break
    swapneg = None
    for i in range(k)[::(- 1)]:
        if (ls[lsabsargsort[i]] < 0):
            swapneg = i
            neg1 = ls[lsabsargsort[i]]
            break
    if ((swappos is not None) and (swapneg is not None)):
        p = 1
        p *= ls[lsabsargsort[swappos]]
        p %= modulo
        for i in range(k):
            if (i == swapneg):
                continue
            x = ls[lsabsargsort[i]]
            p *= x
            p %= modulo
        opt1 = p
    swappos = None
    for i in range(k)[::(- 1)]:
        if (ls[lsabsargsort[i]] >= 0):
            swappos = i
            pos2 = ls[lsabsargsort[i]]
            break
    swapneg = None
    for i in range(k, n):
        if (ls[lsabsargsort[i]] < 0):
            swapneg = i
            neg2 = ls[lsabsargsort[i]]
            break
    if ((swappos is not None) and (swapneg is not None)):
        p = 1
        p *= ls[lsabsargsort[swapneg]]
        p %= modulo
        for i in range(k):
            if (i == swappos):
                continue
            x = ls[lsabsargsort[i]]
            p *= x
            p %= modulo
            opt2 = p
    if (opt1 is None):
        return opt2
    if (opt2 is None):
        return opt1
    if ((pos1 * pos2) > (neg1 * neg2)):
        return opt1
    return opt2

def main(istr, ostr):
    (n, k) = list(map(int, istr.readline().strip().split()))
    ls = list(map(int, istr.readline().strip().split()))
    result = solve(ls, k)
    print(result, file=ostr)
if (__name__ == '__main__'):
    import sys
    main(sys.stdin, sys.stdout)



