# File changed

from itertools import groupby
import numpy as np

def solve(s, k):
  sgrp = [len(list(itr)) for (c, itr) in groupby(s)]
  if len(sgrp) == 1:
    return 1
  onebucket = []
  mod = 998244353
  if s[0] == '1':
    onebucket.append(sgrp[0])
    sgrp = sgrp[1:]
  else:
    onebucket.append(0)
  cur = 0
  for l in sgrp:
    if cur == 0:
      onebucket.extend(([0] * (l - 1)))
    else:
      onebucket.append(l)
    cur ^= 1
  k = min(k, sum(onebucket))
  dp = np.zeros(((k + 1), (k + 1)), dtype=np.int64)
  dp[(0, 0)] = 1
  for i, c in enumerate(onebucket):
    ndp = np.add.accumulate(dp, axis=0)
    if c > 0:
      for j in range(1, (c + 1)):
        ndp[(:, j:)] += dp[(:, :(- j))]
      ndp = np.tril(ndp)
    dp = (ndp % mod)
  return (np.diag(dp).sum() % mod)

s, k = input().split()
k = int(k)
print(solve(s, k))

