import sys

def find_permutation(aaa, use):
  maxa = -1
  mina = 1005
  maxfixed = -1
  for i in range(k):
    a = aaa[i]
    if (i+1 in use):
      mina = min(mina, a)
      maxa = max(maxa, a)
    else:
      maxfixed = max(maxfixed, a)
  if (max(maxa, maxfixed+1) > 2*mina):
    return None
  if (maxa < 2*mina):
    return sorted(use)
  front = []
  rear = []
  either = []
  for i in use:
    if (aaa[i-1] == maxa):
      front.append(i)
    elif (aaa[i-1] == mina):
      rear.append(i)
    else:
      either.append(i)
  maxfront = front[-1]
  for i in either:
    if (i < maxfront):
      front.append(i)
    else:
      rear.append(i)
  front.sort()
  rear.sort()
  front.extend(rear)
  return front

def solve(k, aaa):
  if (k == 1):
    return [1]*aaa[0]
  mina = min(aaa)
  maxa = max(aaa)
  if (mina*2 < maxa):
    return [-1]
  ans = []
  ans.extend(find_permutation(aaa, set(range(1, k+1))))
  for i in range(k):
    aaa[i] -= 1
  remaining = sum(aaa)
  while remaining:
    use = set(range(1, k+1))
    candidates = []
    for r in range(k):
      result = find_permutation(aaa, use)
      if (result is not None):
        candidates.append(result)
      use.remove(ans[-r-1])
    adopted = min(candidates)
    ans.extend(adopted)
    for i in adopted:
      aaa[i-1] -= 1
    remaining -= len(adopted)
  return ans

(k, *aaa) = map(int, sys.stdin.buffer.read().split())
print(*solve(k, aaa))

