' Finds the number of unique elements in a list
'
from collections import Counter

def main():
    ' Finds the number of unique elements in a list

    Args:
        N (int): The number of elements in the list.
        A (list): The list of elements.

    Returns:
        int: The number of unique elements in the list.
    '
    N = int(input())
    A = list(map(int, input().split(' ')))
    counter = Counter(A)
    searched = [0 for _ in range(((10 ** 6) + 1))]
    ans = 0
    for i in range(1, ((10 ** 6) + 1)):
        if (counter[i] == 0):
            continue
        if ((searched[i] == 0) and (counter[i] == 1)):
            ans += 1
        for j in range(1, (((10 ** 6) // i) + 1)):
            searched[(i * j)] = 1
    print(ans)
if (__name__ == '__main__'):
    main()


