# File changed

import sys
import numpy as np
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
MOD = ((10 ** 9) + 7)
(N, m) = map(int, read().split())

def make_power(a, L, MOD=MOD):
    b = L.bit_length()
    x = np.empty((1 << b), np.int64)
    x[0] = 1
    for n in range(b):
        x[(1 << n):(1 << (n + 1))] = ((x[:(1 << n)] * a) % MOD)
        a *= a
        a %= MOD
    x = x[:L]
    x.flags.writeable = False
    return x
pow2 = make_power(2, (m + 10))
ipow2 = make_power(((1 + MOD) // 2), (m + 10))

def update(dp):
    b = dp.copy()
    c = ((((dp * np.arange((m + 1))) % MOD) * ipow2[:(m + 1)]) % MOD)
    dp[1:] = (np.cumsum(c[:(- 1)]) % MOD)
    dp[1:] *= pow2[:m]
    dp %= MOD
    dp += (np.arange(1, (m + 2)) * b)
    dp %= MOD
dp = pow2[:(m + 1)].copy()
for _ in range((N - 1)):
    update(dp)
print(dp[(- 1)])

