import pytest

@pytest.mark.parametrize('s, t, expected', [
    ('', '', 'Yes'),
    ('', 'a', 'No'),
    ('a', 'a', 'Yes'),
    ('a', 'ab', 'No'),
    ('ab', 'abc', 'No'),
    ('abc', 'abcd', 'No'),
    ('abcd', 'abcde', 'No'),
    ('abcde', 'abcdef', 'No'),
    ('abcdef', 'abcdefg', 'No'),
    ('abcdefg', 'abcdefgh', 'No'),
    ('abcdefgh', 'abcdefghi', 'No'),
    ('abcdefghi', 'abcdefghij', 'No'),
    ('abcdefghij', 'abcdefghijk', 'No'),
    ('abcdefghijk', 'abcdefghijkl', 'No'),
    ('abcdefghijkl', 'abcdefghijklm', 'No'),
    ('abcdefghijklm', 'abcdefghijklmn', 'No'),
    ('abcdefghijklmn', 'abcdefghijklmno', 'No'),
    ('abcdefghijklmno', 'abcdefghijklmnop', 'No'),
    ('abcdefghijklmnop', 'abcdefghijklmnopq', 'No'),
    ('abcdefghijklmnopq', 'abcdefghijklmnopqr', 'No'),
    ('abcdefghijklmnopqr', 'abcdefghijklmnopqrs', 'No'),
    ('abcdefghijklmnopqrs', 'abcdefghijklmnopqrst', 'No'),
    ('abcdefghijklmnopqrst', 'abcdefghijklmnopqrstu', 'No'),
    ('abcdefghijklmnopqrstu', 'abcdefghijklmnopqrstuv', 'No'),
    ('abcdefghijklmnopqrstuv', 'abcdefghijklmnopqrstuvw', 'No'),
    ('abcdefghijkl