import pytest

def ipow(x,y):
    z = 1
    for i in range(y):
        z *= x
    return z

def make_bit(value,deg):
    bit = []
    for i in range(deg):
        bit.append(value%2)
        value = value >> 1
    return bit


@pytest.fixture
def ipow():
    return ipow

@pytest.fixture
def make_bit():
    return make_bit

@pytest.fixture
def n():
    return int(i)

@pytest.fixture
def m():
    return int(i)

@pytest.fixture
def x():
    return int(i)

@pytest.fixture
def data():
    return []

@pytest.fixture
def result():
    return [0] * (m+1)

@pytest.fixture
def ra():
    return ipow(2,n)

@pytest.fixture
def ans():
    return -1

@pytest.fixture
def i():
    return range(n)

@pytest.fixture
def j():
    return range(n)

@pytest.fixture
def flag():
    return True

@pytest.fixture
def bit():
    return make_bit(i,n)

@pytest.fixture
def result():
    return [x+y for(x,y) in zip(result,data[j])]

@pytest.fixture
def result():
    return [0 for i in range(m+1)]

@pytest.fixture
def flag():
    return True

@pytest.fixture
def ans():
    return result[0]

def test_ipow(ipow):
    assert (ipow(2,3) == 8)

def test_make_bit(make_bit):
    assert (make_bit(1,3) == [1,0,1])

def test_n(n):
    assert (n == 3)

def test_m(m):
    assert (m == 3)

def test_x(x):
    assert (x == 3)

def test_data(data):
    assert (data == [])

def test_result(result):
    assert (result == [0] * (m+1))

def test_ra(ra):
    assert (ra == 8)

def test_ans(ans):
    assert (ans == -1)

def test_i(i):
    assert (i == range(n))

def test_j(j):
    assert (j == range(n))

def test_flag(flag):
    assert (flag == True)

def test_bit(bit):
    assert (bit == make_bit(i,n))

def test_result(result):
    assert (result == [x+y for(x,y) in zip(result,data[j])])

def test_result(result):
    assert (result == [0 for i in range(m+1)])

def test_flag(flag):
    assert (flag == True)

def test_ans(ans):
    assert (ans == result[0])

