# File changed


def main():
  n = int(input())
  uplines = []
  downlines = []
  for i in range(n):
    s = input()
    height = 0
    bottom = 0
    for c in s:
      if c == '(':
        height += 1
      else:
        height -= 1
        bottom = min(bottom, height)
    if height > 0:
      uplines.append((bottom, height))
    else:
      downlines.append(((bottom - height), (- height)))
  uplines.sort(reverse=True, key=(lambda line: line[0]))
  downlines.sort(reverse=True, key=(lambda line: line[0]))
  left = 0
  for bottom, height in uplines:
    if left + bottom < 0:
      print('No')
      return
    left += height
  right = 0
  for bottom, height in downlines:
    if right + bottom < 0:
      print('No')
      return
    right += height
  if left == right:
    print('Yes')
  else:
    print('No')
if __name__ == '__main__':
  main()

