'
# File changed

import numpy as np

def main():
    'Finds the number of paths in a graph that are higher than the current node'
    (n, m) = map(int, input().split())
    no_path = np.zeros(n)
    path = [[] for i in range(n)]
    higher = list(map(int, input().split()))
    ans = 0
    for _ in range(m):
        (a, b) = map(int, input().split())
        no_path[(a - 1)] = 1
        no_path[(b - 1)] = 1
        path[(a - 1)].append(higher[(b - 1)])
        path[(b - 1)].append(higher[(a - 1)])
    ans = ((ans + n) - np.count_nonzero(no_path))
    for (idx, _path) in enumerate(path):
        if ((len(_path) > 0) and (higher[idx] > max(_path))):
            ans += 1
    print(ans)


if __name__ == '__main__':
    main()


