import sys
from collections import defaultdict

# 再帰制限を緩和するおまじない
sys.setrecursionlimit(10**6)

def sum(n):return n*(n+1)//2

# 部分木のサイズと、「色iを封鎖したときに到達できない頂点の個数」を持つ辞書を返す
def dfs(v,p):
    ret=defaultdict(int)
    size=1
    for vv in g[v]:
        if vv==p:
            continue
        ss,d=dfs(vv,v)
        size+=ss
        ans[c[v]]+=sum(ss-d[c[v]])
        
        # マージテク
        if len(ret)<len(d):
            ret,d=d,ret
        for vvv in d:
            ret[vvv]+=d[vvv]
    ret[c[v]]=size
    return size,ret

@pytest.mark.parametrize('n,c,g,ans', [
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 3],
            [3, 4],
            [4, 5],
            [5, 1],
        ],
        [1, 1, 1, 1, 1],
    ),
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 3],
            [3, 4],
            [4, 5],
            [5, 1],
        ],
        [1, 1, 1, 1, 1],
    ),
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 3],
            [3, 4],
            [4, 5],
            [5, 1],
        ],
        [1, 1, 1, 1, 1],
    ),
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 3],
            [3, 4],
            [4, 5],
            [5, 1],
        ],
        [1, 1, 1, 1, 1],
    ),
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 3],
            [3, 4],
            [4, 5],
            [5, 1],
        ],
        [1, 1, 1, 1, 1],
    ),
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 3],
            [3, 4],
            [4, 5],
            [5, 1],
        ],
        [1, 1, 1, 1, 1],
    ),
    (
        5,
        [1, 2, 3, 1, 2],
        [
            [1, 2],
            [2, 