import pytest

def combination(n, a, mod):
    x = 1
    y = 1
    for i in range(a):
        x = x * (n-i)%mod
        y = y * (a-i)%mod

        #x *= (n-i)
        #x %=mod
        #y *= (a-i)
        #y %=mod
    return x * pow(y, mod-2, mod)%mod

@pytest.mark.parametrize('n, m, expected', [
    (1, 1, 2),
    (2, 2, 6),
    (3, 3, 12),
    (4, 4, 20),
    (5, 5, 30),
    (6, 6, 42),
    (7, 7, 56),
    (8, 8, 72),
    (9, 9, 90),
    (10, 10, 110),
])
def test_combination(n, m, expected):
    assert combination(n, 2, pow(10,9)+7) + combination(m, 2, pow(10,9)+7) == expected

