def solve(A,B,C,D, level):
    E = 3**level
    if level == -1:
        return int(abs(A-C) + abs(B-D))
    a,b,c,d = A//E, B//E, C//E, D//E
    if a != c and b != d:
        return int(abs(A-C) + abs(B-D))

    if a == c and b==d:
        return solve(A,B,C,D,level-1)

    if a != c and b==d:
        A,B,C,D = B,A,D,C
        a,b,c,d = b,a,d,c

    if b != d and a == c:
        if a%3 != 1:
            return solve(A,B,C,D,level-1)
        if abs(b-d) == 1:
            return solve(A,B,C,D,level-1)

        if B > D:
            A, B, C, D = C, D, A, B
            a, b, c, d = c, d, a, b

        x = E * a -1
        y1 = E * (b+1) -1
        y2 = E * d
        d = abs(x-A) + abs(y1-B) + abs(y1-y2) + abs(x-C) + abs(y2-D)
        x = E *(a+1)
        d2 = abs(x-A) + abs(y1-B) + abs(y1-y2) + abs(x-C) + abs(y2-D)
        return min(d,d2)

@pytest.mark.parametrize('sg,d', [
    ([1, 1, 2, 2], 1),
    ([1, 1, 2, 3], 2),
    ([1, 1, 3, 2], 2),
    ([1, 1, 3, 3], 3),
    ([1, 2, 1, 2], 1),
    ([1, 2, 1, 3], 2),
    ([1, 2, 2, 1], 1),
    ([1, 2, 2, 2], 2),
    ([1, 2, 2, 3], 3),
    ([1, 2, 3, 1], 1),
    ([1, 2, 3, 2], 2),
    ([1, 2, 3, 3], 3),
    ([1, 3, 1, 2], 1),
    ([1, 3, 1, 3], 2),
    ([1, 3, 2, 1], 1),
    ([1, 3, 2, 2], 2),
    ([1, 3, 2, 3], 3),
    ([1, 3, 3, 1], 1),
    ([1, 3, 3, 2], 2),
    ([1, 3, 3, 3], 3),
    ([2, 1, 1, 2], 1),
    ([2, 1, 1, 3], 2),
    ([2, 1, 2, 1], 1),
    ([2, 1, 2, 2], 2),
    ([2, 1, 2, 3], 3),
    ([2, 1, 3, 1], 1),
    ([2, 1, 3, 2], 2),
    ([2, 1, 3, 3], 3),
    ([2, 2, 1, 1], 1),
    ([2, 2, 1, 2], 2),
    ([2, 2, 1, 3], 3),
    ([2, 2, 2, 1], 1),
    ([2, 2, 2, 2], 2),
    ([2, 2, 2, 3], 3),
    ([2, 2, 3, 1], 1),
    ([2, 2, 3, 2], 2),
    ([2, 2, 3, 3], 3),
    ([2, 3, 1, 1], 1),
    ([2, 3, 1, 2], 2),
    ([2, 3, 1, 3], 3),
    ([2, 3, 2, 1], 1),
    ([2, 3, 2, 2], 2),
    ([2, 3, 2, 3], 3),
    ([2, 3, 3, 1], 1),
    ([2, 3, 3, 2], 2),
    ([2, 3, 3, 3], 3),
    ([3, 1, 1, 2], 1),
    ([3, 1, 1, 3], 2),
    ([3, 1, 2, 1], 1),
    ([3, 1, 2, 2], 2),
    ([3, 1, 2, 3], 3),
    ([3, 1, 3, 1], 1),
    ([3, 1, 3, 2], 2),
    ([3, 1, 3, 3], 3),
    ([3, 2, 1, 1], 1),
    ([3, 2, 1, 2], 2),
    ([3, 2, 1, 3], 3),
    ([3, 2, 2, 1], 1),
    ([3, 2, 2, 2], 2),
    ([3, 2, 2, 3], 3),
    ([3, 2, 3, 1], 1),
    ([3, 2, 3, 2], 2),
    ([3, 2, 3, 3], 3),
    ([3, 3, 1, 1], 1),
    ([3, 3, 1, 2], 2),
    ([3, 3, 1, 3], 3),
    ([3, 3, 2, 1], 1),
    ([3, 3, 2