import sys

def test_that_input_is_correct(n, a):
    assert (n > 0)
    assert (len(a) == n)
    for i in a:
        assert (i > 0)

def test_that_output_is_correct(n, a, b):
    assert (len(b) == n)
    for i in b:
        assert (i % 2 == 0)
        if i % 3 == 0:
            assert (i % 5 == 0)

def test_that_program_output_is_correct(capsys, n, a, b):
    test_that_input_is_correct(n, a)
    test_that_output_is_correct(n, a, b)
    sys.stdin = io.StringIO(f'{n}\n{" ".join(map(str, a))}')
    main()
    captured = capsys.readouterr()
    assert (captured.out == 'APPROVED\n')

