import pytest

@pytest.mark.parametrize('N, P, expected', [
    (1, [1], 1),
    (2, [1, 2], 2),
    (3, [1, 2, 3], 3),
    (4, [1, 2, 3, 4], 4),
    (5, [1, 2, 3, 4, 5], 5),
    (6, [1, 2, 3, 4, 5, 6], 6),
    (7, [1, 2, 3, 4, 5, 6, 7], 7),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 8),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 9),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 10),
])
def test_that_the_number_of_smaller_numbers_is_correct(N, P, expected):
    now = 99999999
    sumc = 0
    for count in range(0,N):
        if P[count] < now:
            sumc += 1
            now = P[count]
    assert sumc == expected

