' Calculate the number of squares needed to cover a rectangular area
'
from math import ceil

def calculate_squares(height, width, number_of_squares):
    'Calculates the number of squares needed to cover a rectangular area

    Args:
        height (int): The height of the rectangular area.
        width (int): The width of the rectangular area.
        number_of_squares (int): The number of squares needed to cover the area.

    Returns:
        int: The number of squares needed to cover the area.
    '
    return ceil((number_of_squares / max(height, width)))

h = int(input())
w = int(input())
n = int(input())
print(calculate_squares(h, w, n))


