import pytest

@pytest.mark.parametrize('n, robots, expected', [
    (1, [(1, 1)], 1),
    (2, [(1, 1), (2, 2)], 2),
    (3, [(1, 1), (2, 2), (3, 3)], 3),
    (4, [(1, 1), (2, 2), (3, 3), (4, 4)], 4),
    (5, [(1, 1), (2, 2), (3, 3), (4, 4), (5, 5)], 5),
    (6, [(1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6)], 6),
    (7, [(1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7)], 7),
    (8, [(1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7), (8, 8)], 8),
    (9, [(1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7), (8, 8), (9, 9)], 9),
    (10, [(1, 1), (2, 2), (3, 3), (4, 4