import pytest

N, K, S = map(int, input().split())

n = 0
if S < 10**9:
    n = S + 1
else:
    n = 1

ans = [S] * K + [n] * (N - K)
print(" ".join(map(str, ans)))

@pytest.mark.parametrize("N, K, S, expected", [
    (10, 5, 100, "100 100 100 100 100 1 1 1 1 1"),
    (10, 5, 1000000000, "1000000000 1000000000 1000000000 1000000000 1000000000 1 1 1 1 1"),
])
def test_that_it_works(N, K, S, expected):
    assert (ans == expected)

