# File changed

import sys
from collections import defaultdict
from heapq import heappop, heappush
from itertools import permutations
from operator import itemgetter

def fill_remainings(ans, aaa, x, remainings):
    '\n    xを先頭にして残りを昇順に追加\n    ただしxの次の要素のみ、aaa[x]で禁止されていた場合はその次と入れ替える\n    remainingsにはxを含め3要素以上残っていることが前提\n    '
    ans.append(x)
    i = len(ans)
    while remainings:
        k = heappop(remainings)
        if (k != x):
            ans.append(k)
    if (aaa[x] == ans[i]):
        (ans[i], ans[(i + 1)]) = (ans[(i + 1)], ans[i])

def solve(n, aaa):
    if (n == 2):
        return [(- 1)]
    indegrees = defaultdict((lambda : 0))
    for (i, a) in enumerate(aaa, start=1):
        indegrees[a] += 1
    indegrees = dict(indegrees)
    currmax = max(indegrees.values())
    remainings = list(range(1, (n + 1)))
    aaa.insert(0, 0)
    ans = []
    banned = (- 1)
    for i in range((n - 3)):
        if (currmax == ((n - i) - 1)):
            (currx, currmax) = max(indegrees.items(), key=itemgetter(1))
            if (currmax == ((n - i) - 1)):
                fill_remainings(ans, aaa, currx, remainings)
                return ans
        top = heappop(remainings)
        if (top == banned):
            ans.append(heappop(remainings))
            heappush(remainings, top)
        else:
            ans.append(top)
        banned = aaa[ans[(- 1)]]
        if (banned in indegrees):
            if (indegrees[banned] == 1):
                del indegrees[banned]
            else:
                indegrees[banned] -= 1
        indegrees.pop(ans[(- 1)], 0)
    remainings.sort()
    for (i, j, k) in permutations(remainings):
        if ((i != banned) and (j != aaa[i]) and (k != aaa[j])):
            ans += [i, j, k]
            break
    return ans
(n, *aaa) = map(int, sys.stdin.buffer.read().split())
print(*solve(n, aaa))



