import sys
from collections import defaultdict
from heapq import heappop, heappush
from itertools import permutations
from operator import itemgetter


@pytest.fixture
def n():
    return 10

@pytest.fixture
def aaa():
    return [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]

def test_solve(n, aaa):
    assert solve(n, aaa) == [-1]

def test_solve_2(n, aaa):
    aaa.insert(0, 0)
    assert solve(n, aaa) == [1, 2, 3]

def test_solve_3(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    assert solve(n, aaa) == [1, 2, 3, 4]

def test_solve_4(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    assert solve(n, aaa) == [1, 2, 3, 4, 5]

def test_solve_5(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    aaa.insert(6, 6)
    assert solve(n, aaa) == [1, 2, 3, 4, 5, 6]

def test_solve_6(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    aaa.insert(6, 6)
    aaa.insert(7, 7)
    assert solve(n, aaa) == [1, 2, 3, 4, 5, 6, 7]

def test_solve_7(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    aaa.insert(6, 6)
    aaa.insert(7, 7)
    aaa.insert(8, 8)
    assert solve(n, aaa) == [1, 2, 3, 4, 5, 6, 7, 8]

def test_solve_8(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    aaa.insert(6, 6)
    aaa.insert(7, 7)
    aaa.insert(8, 8)
    aaa.insert(9, 9)
    assert solve(n, aaa) == [1, 2, 3, 4, 5, 6, 7, 8, 9]

def test_solve_9(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    aaa.insert(6, 6)
    aaa.insert(7, 7)
    aaa.insert(8, 8)
    aaa.insert(9, 9)
    aaa.insert(10, 10)
    assert solve(n, aaa) == [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]

def test_solve_10(n, aaa):
    aaa.insert(0, 0)
    aaa.insert(4, 4)
    aaa.insert(5, 5)
    aaa.insert(6, 6)
    aaa.insert(7, 7)
    aaa.insert(8, 8)
    aaa.insert(9, 9)
    aaa.insert(10, 10