import pytest

@pytest.mark.parametrize('n, k, expected', [
    (1, 1, 'Yes'),
    (1, 2, 'No'),
    (1, 500, 'Yes'),
    (1, 501, 'No'),
    (2, 1, 'Yes'),
    (2, 2, 'Yes'),
    (2, 500, 'Yes'),
    (2, 501, 'No'),
    (3, 1, 'Yes'),
    (3, 2, 'Yes'),
    (3, 500, 'Yes'),
    (3, 501, 'No'),
])
def test_that_500n_is_greater_than_or_equal_to_k(n, k, expected):
    if 500 * n >= k:
        assert expected == 'Yes'
    else:
        assert expected == 'No'

