import pytest

@pytest.mark.parametrize('n, s1, s2, expected', [
    (1, 'a', 'b', 'ab'),
    (2, 'ab', 'cd', 'abcd'),
    (3, 'abc', 'def', 'abcdef'),
])
def test_that_strings_are_interleaved(n, s1, s2, expected):
    s = ''
    for i in range(n):
        s += s1[i] + s2[i]
    assert s == expected

