import pytest

@pytest.mark.parametrize('m1, d1, m2, d2, expected', [
    (1, 1, 1, 1, '1'),
    (1, 1, 1, 2, '0'),
    (1, 1, 2, 1, '1'),
    (1, 1, 2, 2, '0'),
    (1, 2, 1, 1, '1'),
    (1, 2, 1, 2, '0'),
    (1, 2, 2, 1, '1'),
    (1, 2, 2, 2, '0'),
    (2, 1, 1, 1, '1'),
    (2, 1, 1, 2, '0'),
    (2, 1, 2, 1, '1'),
    (2, 1, 2, 2, '0'),
    (2, 2, 1, 1, '1'),
    (2, 2, 1, 2, '0'),
    (2, 2, 2, 1, '1'),
    (2, 2, 2, 2, '0'),
])
def test_that_the_program_output_is_correct(m1, d1, m2, d2, expected):
    assert (expected == '1' if d2 == 1 else '0')

