# File changed


def main():
    'Calculates the number of ways to arrange a set of objects

    Args:
        x (int): The number of objects of one type.
        y (int): The number of objects of another type.

    Returns:
        int: The number of ways to arrange the objects.
    '
    (x, y) = map(int, input().split())
    m = (((2 * x) - y) // 3)
    n = (((2 * y) - x) // 3)

    def cmb(n, r, mod):
        'Calculates the number of ways to arrange a set of objects

        Args:
            n (int): The number of objects.
            r (int): The number of objects to arrange.
            mod (int): The modulo to perform arithmetic on.

        Returns:
            int: The number of ways to arrange the objects.
        '
        if ((r < 0) or (r > n)):
            return 0
        r = min(r, (n - r))
        return (((fac[n] * finv[r]) * finv[(n - r)]) % mod)
    mod = ((10 ** 9) + 7)
    N = (m + n)
    fac = [1, 1]
    finv = [1, 1]
    finv_cal = [0, 1]
    for i in range(2, (N + 1)):
        fac.append(((fac[(- 1)] * i) % mod))
        finv_cal.append((((- finv_cal[(mod % i)]) * (mod // i)) % mod))
        finv.append(((finv[(- 1)] * finv_cal[(- 1)]) % mod))
    if (((x + y) % 3) != 0):
        print(0)
    elif ((m < 0) or (n < 0) or ((m + n) == 0)):
        print(0)
    else:
        ans = cmb((m + n), n, mod)
        print(ans)
if (__name__ == '__main__'):
    main()


