import numpy as np
def solve(n, t, a, b):
    dp = np.zeros(t, dtype=int)
    candidates = []
    for w, v in sorted(zip(a, b)):
        candidates.append(dp[-1] + v)
        if w > t:
            continue
        dp[w:] = np.maximum(dp[:-w] + v, dp[w:])
    return np.max(candidates)

def test_solve():
    assert (solve(2, 10, [1, 6], [10, 100]) == 110)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1, 2, 3], [10, 10, 100]) == 120)
    assert (solve(3, 10, [1