# File changed

import sys
from heapq import heapify, heappop, heappush

def solve():
    input = sys.stdin.readline
    (n, m) = map(int, input().split())
    edge = [[] for i in range(n)]
    for i in range(1, n):
        edge[i].append((0, (i - 1)))
    for _ in range(m):
        (l, r, c) = map(int, input().split())
        edge[(l - 1)].append((c, (r - 1)))
    dist = ([(- 1)] * n)
    q = []
    heapify(q)
    heappush(q, (0, 0))
    while q:
        (nowcost, nownode) = heappop(q)
        if (dist[nownode] == (- 1)):
            dist[nownode] = nowcost
            for (addcost, nextnode) in edge[nownode]:
                if (dist[nextnode] == (- 1)):
                    heappush(q, (nowcost + addcost, nextnode))
    print(dist[(n - 1)])
    return 0
if (__name__ == '__main__'):
    solve()



