' Finds the number of pairs of integers in a list that add up to a third integer

Args:
    N (int): The number of integers in the list
    L (list): The list of integers

Returns:
    int: The number of pairs of integers in the list that add up to a third integer
'
import bisect
N = int(input())
L = list(map(int, input().split()))
L.sort()
ans = 0
for i in range((N - 2)):
    for j in range((i + 1), (N - 1)):
        res = (L[i] + L[j])
        num = (bisect.bisect_left(L, res) - (j + 1))
        ans += num
print(ans)


