# File changed


def make_prime_checker(n):
    is_prime = ([False, True, False, False, False, True] * ((n // 6) + 1))
    del is_prime[(n + 1):]
    is_prime[1:4] = (False, True, True)
    for i in range(5, (int((n ** 0.5)) + 1)):
        if is_prime[i]:
            is_prime[(i * i)::i] = ([False] * (((n // i) - i) + 1))
    return is_prime

def make_modinv_list(n, mod=((10 ** 9) + 7)):
    modinv = [0, 1]
    for i in range(2, (n + 1)):
        modinv.append((mod - (((mod // i) * modinv[(mod % i)]) % mod)))
    return modinv

def main():
    mod = 998244353
    max_A = (10 ** 6)
    N = int(input())
    A = list(map(int, input().split()))
    primes = []
    for (p, is_prime) in enumerate(make_prime_checker(max_A)):
        if is_prime:
            primes.append(p)
    g = ([0] * (max_A + 1))
    for a in A:
        g[a] += a
    for p in primes:
        for k in range((max_A // p), 0, (- 1)):
            g[k] += g[(k * p)]
    lst_b03b646b = []
    for v in g:
        lst_b03b646b.append(((v * v) % mod))
    g = lst_b03b646b
    for p in primes:
        for (k, g_kp) in enumerate(g[p::p], 1):
            g[k] -= g_kp
    modinv_list = make_modinv_list(max_A, mod)
    ans = sum((((gg * minv) % mod) for (gg, minv) in zip(g, modinv_list)))
    ans %= mod
    ans -= sum(A)
    ans *= modinv_list[2]
    ans %= mod
    print(ans)
main()
