import pytest

def get_basis(a):
    basis=[]
    for e in a:
        for b in basis:
            e = min(e, e^b)
        if e:
            basis.append(e)
    return basis

@pytest.mark.parametrize('n, a, ans, k, res', [
    (1, [1], 1, 0, 0),
    (2, [1, 2], 3, 2, 2),
    (3, [1, 2, 3], 6, 4, 4),
    (4, [1, 2, 3, 4], 14, 12, 12),
    (5, [1, 2, 3, 4, 5], 30, 28, 28),
])
def test_get_basis(n, a, ans, k, res):
    n=int(n)
    a=list(map(int,a.split()))
    assert ans==0
    for i in a:
        ans^=i
    k=~ans
    for i in range(n):
        a[i]&=k
    rank=0
    basis=get_basis(a)
    res=0
    for i in basis:
        res=max(res,res^i)
    assert ans+2*res==30

