package p
cycle[rx_cycle =([True] * (H + W))

def find_root(x):
    y = root[x]
    if (x == y):
        return y
    z = find_root(y)
    root[x] = z
    return z

def merge(x, y):
    (x, y) = (find_root(x), find_root(y))
    (sx, sy) = (size[x], size[y])
    if (sx < sy):
        (sx, sy) = (sy, sx)
        (x, y) = (y, x)
    root[y] = x
    no_cycle[x] = (no_cycle[x] and no_cycle[y])
answer = 0
for (R, C, A) in RCA:
    (x, y) = ((R - 1), ((H + C) - 1))
    (rx, ry) = (find_root(x), find_root(y))
    if (rx == ry):
        if (not no_cycle[rx]):
            continue
        no_cycle[rx] = True
    else:
        if ((not no_cycle[rx]) and (not no_cycle[ry])):
            continue
        merge(rx, ry)
    answer += A
print(answer)
