import sys
input = sys.stdin.readline
sys.setrecursionlimit((10 ** 7))
'\n正則二部グラフの辺彩色\n'
import numpy as np
(N, M) = map(int, input().split())
grid = []
for _ in range(N):
    grid.append([int(x) for x in input().split()])
edge = []
for (i, row) in enumerate(grid):
    for (j, x) in enumerate(row):
        edge.append((((x - 1) // M), (N + i)))
graph = []
for _ in range((N + N)):
    graph.append(dict())
rest_color = []
for _ in range((N + N)):
    rest_color.append(set(range(M)))
for (u, v) in edge:
    common = (rest_color[u] & rest_color[v])
    if common:
        c = common.pop()
        graph[u][c] = v
        graph[v][c] = u
        rest_color[u].remove(c)
        rest_color[v].remove(c)
        continue
    c = rest_color[u].pop()
    d = rest_color[v].pop()
    cd = (c + d)
    V = [u, v]
    next_c = c
    while (next_c not in rest_color[v]):
        v = graph[v][next_c]
        V.append(v)
        next_c = (cd - next_c)
    rest_color[v].remove(next_c)
    rest_color[v].add((cd - next_c))
    for (i, (u, v)) in enumerate(zip(V, V[1:])):
        if ((i % 2) == 0):
            graph[u][c] = v
            graph[v][c] = u
        else:
            graph[u][d] = v
            graph[v][d] = u
after = []
for _ in range(N):
    after.append(([None] * M))
for (i, row) in enumerate(grid):
    mod_to_x = []
    for _ in range(N):
        mod_to_x.append([])
    for x in row:
        mod_to_x[((x - 1) // M)].append(x)
    for color in range(M):
        after[i][color] = mod_to_x[graph[(i + N)][color]].pop()
B = np.array(after)
C = B.copy()
C.sort(axis=0)
print('\n'.join((' '.join(row) for row in B.astype(str))))
print('\n'.join((' '.join(row) for row in C.astype(str))))

