import pytest

@pytest.mark.parametrize("k,x,expected", [
    (1, 1, "1"),
    (1, 2, "1 2"),
    (1, 3, "1 2 3"),
    (2, 1, "1"),
    (2, 2, "1 2"),
    (2, 3, "1 2 3"),
    (2, 4, "2 3 4"),
    (2, 5, "3 4 5"),
    (3, 1, "1"),
    (3, 2, "1 2"),
    (3, 3, "1 2 3"),
    (3, 4, "2 3 4"),
    (3, 5, "3 4 5"),
    (3, 6, "4 5 6"),
    (3, 7, "5 6 7"),
    (3, 8, "6 7 8"),
])
def test_print_range(k, x, expected):
    assert expected == pytest.helpers.utils.run_with_stdin(
        f"{k} {x}",
        "python3 range_print.py",
    )

