' File changed

import collections

def counter_(s):
    ' Counts the number of occurences of each element in a list

    Args:
        s (list): The list to count the occurences of.

    Returns:
        list: A list of tuples containing the element and the number of occurences.
    '
    counter = collections.Counter(s)
    counter = [list(e) for e in counter.items()]
    counter.sort()
    return counter

def cmb(n, r):
    ' Calculates the number of combinations of n items taken r at a time

    Args:
        n (int): The number of items.
        r (int): The number of items taken at a time.

    Returns:
        int: The number of combinations.
    '
    r = min((n - r), r)
    if (r == 0):
        return 1
    over = reduce(mul, range(n, (n - r), (- 1)))
    under = reduce(mul, range(1, (r + 1)))
    return (over // under)

N = int(input())
S = []
for i in range(N):
    s = list(input())
    s.sort()
    str_ = ''.join(s)
    S.append(str_)
ans = 0
S_ = counter_(S)
for i in range(len(S_)):
    if (S_[i][1] != 1):
        a = cmb(S_[i][1], 2)
        ans += a
print(ans)


