# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
MOD = 998244353
N = int(readline())
m = map(int, read().split())
Y = [y for (x, y) in sorted(zip(m, m))]
yrank = {y: i for (i, y) in enumerate(sorted(Y), 1)}
Y = [yrank[y] for y in Y]

class BIT():

    def __init__(self, max_n):
        self.size = (max_n + 1)
        self.tree = ([0] * self.size)

    def get_sum(self, i):
        s = 0
        while i:
            s += self.tree[i]
            i -= (i & (- i))
        return s

    def add(self, i, x):
        while (i < self.size):
            self.tree[i] += x
            i += (i & (- i))
ld = ([0] * N)
bit = BIT(N)
for (i, y) in enumerate(Y):
    ld[i] = bit.get_sum(y)
    bit.add(y, 1)

def cumprod(arr, MOD):
    l = len(arr)
    lsq = int(((l ** 0.5) + 1))
    arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
    for n in range(1, lsq):
        arr[(:, n)] *= arr[(:, (n - 1))]
        arr[(:, n)] %= MOD
    for n in range(1, lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:l]
x = np.full((N + 10), 2, np.int64)
x[0] = 1
pow2 = cumprod(x, MOD)
ld = np.array(ld, dtype=np.int32)
d = (np.array(Y) - 1)
l = np.arange(N)
r = ((N - 1) - l)
u = ((N - 1) - d)
lu = (l - ld)
ru = (u - lu)
rd = (d - ld)
x = (((((pow2[N] - 1) + pow2[ld]) + pow2[rd]) + pow2[ru]) + pow2[lu])
x -= (((pow2[u] + pow2[d]) + pow2[r]) + pow2[l])
answer = (x.sum() % MOD)
print(answer)

