# -*- coding: utf-8 -*-

import pytest


@pytest.mark.parametrize('a, b, expected', [
    (1, 2, 1),
    (2, 3, 2),
    (3, 4, 3),
    (4, 5, 4),
    (5, 6, 5),
    (6, 7, 6),
    (7, 8, 7),
    (8, 9, 8),
    (9, 10, 9),
])
def test_even_sum(a, b, expected):
    assert (a + b) % 2 == 0
    assert int((a + b) / 2) == expected


@pytest.mark.parametrize('a, b', [
    (1, 3),
    (2, 4),
    (3, 5),
    (4, 6),
    (5, 7),
    (6, 8),
    (7, 9),
    (8, 10),
    (9, 11),
])
def test_odd_sum(a, b):
    assert (a + b) % 2 == 1
    assert (a + b) / 2 == 'IMPOSSIBLE'

