import pytest

@pytest.mark.parametrize('mod, r, dp, c, expected', [
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '1', 1),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '2', 2),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '3', 3),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '4', 4),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '5', 5),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '6', 6),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '7', 7),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '8', 8),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '9', 9),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '10', 10),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '11', 11),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '12', 12),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '13', 13),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '14', 14),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '15', 15),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '16', 16),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '17', 17),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '18', 18),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '19', 19),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '20', 20),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '21', 21),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '22', 22),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '23', 23),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '24', 24),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '25', 25),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '26', 26),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '27', 27),
    (10**9+7, [[(j-k)*9%13 for j in range(10)] for k in range(13)], [1]+[0]*12, '28', 28),
    (10**9+7, [[(j-