import pytest

@pytest.mark.parametrize("N, alist, ans", [
    (1, [1], 1),
    (2, [1, 2], 3),
    (3, [1, 2, 3], 0),
    (4, [1, 2, 3, 4], 7),
    (5, [1, 2, 3, 4, 5], 3),
    (6, [1, 2, 3, 4, 5, 6], 7),
    (7, [1, 2, 3, 4, 5, 6, 7], 0),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 15),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 8),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 5),
])
def test_xor_sum(N, alist, ans):
    assert ans == alist[0] ^ alist[1]
    for a in alist[2:]:
        ans ^= a
    if ans == 0:
        print("Yes")
    else:
        print("No")

