import sys
def p(*a):
  s=" ".join(map(str,a))
  #print(s)
  sys.stderr.write(s+"\n")
#-------------------------------------------------------------------
N, M = map(int, input().split())

G=[[] for _ in range(N+1) ]			#=> [[], [], [], [], [], [], [], []]
for _ in range(M):
	u,v = map(int, input().split())
	G[u].append(v)

S, T = map(int, input().split())

#p("N,M",N,M)
#p("G",G)
#p("S,T",S,T)


# 訪問済み＆移動数の記録用マップ、Visitedを作る。未訪問は-1
# 3倍になる頂点を抽出するために、3ヵ所の記録が出来るよう「-1」を3つ準備する
V=[ [-1,-1,-1] for _ in range(N+1) ]			#=> [ [-1,-1,-1], [-1,-1,-1], ... [-1,-1,-1] ]
V[S][0]=0

# キューに行き先候補を入れて、
from collections import deque
Q = deque()
Q.append([S,0])

while Q:
	sv = Q[0][0]
	sl = Q[0][1]
	Q.popleft()
	
	for tv in G[sv]:
		tl = (sl+1)%3
		b = (V[tv][tl]==-1)									# 未訪問である
		#b = b or (V[tv][tl]>V[sv][sl]+1)		# より短いステップ数である(＝既存の方が大きい)
		if b:
			V[tv][tl] = V[sv][sl]+1		# 訪問ステップ数の記録
			Q.append([tv,tl])					# 次の訪問先として、キューに追加

ans = V[T][0]
if ans > -1: ans //= 3
print(ans)
