# File changed

from scipy.optimize import fmin

n = int(input())
inf = 10**18
fixed_x = [inf, (-inf)]
r = [inf, (-inf)]
l = [inf, (-inf)]
fixed_y = [inf, (-inf)]
u = [inf, (-inf)]
d = [inf, (-inf)]

def update(fixed, li, x, y):
  (li[0], li[1]) = (min(li[0], x), max(li[1], x))
  (fixed[0], fixed[1]) = (min(fixed[0], y), max(fixed[1], y))

for _ in range(n):
  (x, y, d) = input().split()
  (x, y) = (int(x), int(y))
  if d == 'L':
    update(fixed_y, l, x, y)
  elif d == 'R':
    update(fixed_y, r, x, y)
  elif d == 'U':
    update(fixed_x, u, y, x)
  else:
    update(fixed_x, d, y, x)

def calc_x(t, fixed, dec, inc):
  left = inf
  right = (-inf)
  for (li, speed) in [(fixed, 0), (dec, (-1)), (inc, 1)]:
    left = min(left, (li[0] + (speed * t)))
    right = max(right, (li[1] + (speed * t)))
  return (right - left)

def area(t):
  if t < 0:
    return inf
  return (calc_x(t, fixed_x, l, r) * calc_x(t, fixed_y, d, u))

x_opt = fmin(area, x0=(10**8), ftol=(10**(-9)), disp=False)
answer = area(x_opt[0])
print(answer)



