import pytest

@pytest.mark.parametrize('n, k, expected', [
    (1, 1, 0),
    (1, 2, 0),
    (2, 1, 1),
    (2, 2, 0),
    (3, 1, 2),
    (3, 2, 1),
    (3, 3, 0),
    (4, 1, 3),
    (4, 2, 2),
    (4, 3, 1),
    (4, 4, 0),
    (5, 1, 4),
    (5, 2, 3),
    (5, 3, 2),
    (5, 4, 1),
    (5, 5, 0),
])
def test_that_the_number_of_ways_to_climb_n_stairs_is_n_k(n, k, expected):
    assert (expected == n - k)

