import numpy as np
import sys

def main():
    input = sys.stdin.readline
    (h, w) = map(int, input().split())
    a = []
    for _ in range(h):
        s = [(0 if (c == '#') else 1) for c in input().strip()]
        a.append(s)
    a = np.array(a)
    up = np.zeros(((h + 1), w), dtype=np.int)
    down = np.zeros(((h + 1), w), dtype=np.int)
    right = np.zeros((h, (w + 1)), dtype=np.int)
    left = np.zeros((h, (w + 1)), dtype=np.int)
    for i in range(1, (h + 1)):
        up[i] = ((up[(i - 1)] + 1) * a[(i - 1)])
        down[(h - i)] = ((down[((h - i) + 1)] + 1) * a[(h - i)])
    for i in range(1, (w + 1)):
        right[(:, i)] = ((right[(:, (i - 1))] + 1) * a[(:, (i - 1))])
        left[(:, (w - i))] = ((left[(:, ((w - i) + 1))] + 1) * a[(:, (w - i))])
    r = (((up[1:] + down[:h]) - 1) * a)
    c = (((right[(:, 1:)] + left[(:, :w)]) - 1) * a)
    w = (((r + c) - 1) * a)
    return w.max()
if (__name__ == '__main__'):
    print(main())



