# File changed

(L, A, B, mod) = map(int, input().split())

def keta(k):
    'Calculates the keta value

    Args:
        k (int): The keta value to calculate.

    Returns:
        tuple: A tuple containing the keta values.
    '
    if (A >= (10 ** k)):
        return (0, 0, 0)
    begin = (10 ** (k - 1))
    end = (10 ** k)
    if (begin > (A + (B * (L - 1)))):
        return (0, 0, 0)
    sh = ((A + (max((- 1), (((begin - 1) - A) // B)) * B)) + B)
    ma = min((A + (max(0, (((end - 1) - A) // B)) * B)), (A + (B * (L - 1))))
    kou = (((ma - sh) // B) + 1)
    return (sh, ma, kou)
from functools import lru_cache

@lru_cache(maxsize=None)
def f(n, r):
    'Calculates the f value

    Args:
        n (int): The n value to calculate.
        r (int): The r value to calculate.

    Returns:
        int: The calculated f value.
    '
    if (n == 1):
        return 1
    if ((n % 2) == 0):
        return ((f((n // 2), r) + (pow(r, (n // 2), mod) * f((n // 2), r))) % mod)
    return (((r * f((n - 1), r)) + 1) % mod)

@lru_cache(maxsize=None)
def g(n, r):
    'Calculates the g value

    Args:
        n (int): The n value to calculate.
        r (int): The r value to calculate.

    Returns:
        int: The calculated g value.
    '
    if (n == 1):
        return 0
    if ((n % 2) == 0):
        return (g((n // 2), r) + (pow(r, (n // 2), mod) * (g((n // 2), r) + ((n // 2) * f((n // 2), r)))))
    return ((r * g((n - 1), r)) + (r * f((n - 1), r)))
keta_count = 1
ANS = 0
for i in range(18, 0, (- 1)):
    (sh, ma, kou) = keta(i)
    if (kou <= 0):
        continue
    ANS = (((keta_count * ((ma * f(kou, (10 ** i))) - (B * g(