# File changed

import sys
input = sys.stdin.readline
import numpy as np
(N, X) = map(int, input().split())
(B, L, U) = np.array([input().split() for _ in range(N)], dtype=np.int64).T
target = (B * L).sum()
full_score = ((B * L) + (U * (X - B)))
i = full_score.argsort()[::(- 1)]
B = B[i]
L = L[i]
U = U[i]
full_score = full_score[i]
full_score_cum = full_score.cumsum()

def test(x):
    (q, r) = divmod(x, X)
    q_part = np.zeros_like(B)
    if (q >= 1):
        q_part[q:] = full_score_cum[(q - 1)]
        q_part[:q] = (full_score_cum[q] - full_score[:q])
    r_part = np.where((r <= B), (L * r), ((B * L) + ((r - B) * U)))
    return ((q_part + r_part).max() >= target)
left = (- 1)
right = (X * N)
while ((left + 1) < right):
    mid = ((left + right) // 2)
    if test(mid):
        right = mid
    else:
        left = mid
answer = right
print(answer)


