import pytest

@pytest.mark.parametrize('N, expected', [
    (3, 180),
    (4, 360),
    (5, 540),
    (6, 720),
    (7, 900),
    (8, 1080),
    (9, 1260),
    (10, 1440),
])
def test_angle_sum(N, expected):
    assert (180 * (N - 2)) == expected

