import pytest

@pytest.mark.parametrize('n, s, b, expected', [
    (1, '#', [0], 0),
    (2, '##', [0, 1], 1),
    (3, '###', [0, 1, 2], 2),
    (4, '####', [0, 1, 2, 3], 3),
    (5, '#####', [0, 1, 2, 3, 4], 4),
    (6, '######', [0, 1, 2, 3, 4, 5], 5),
    (7, '#######', [0, 1, 2, 3, 4, 5, 6], 6),
    (8, '########', [0, 1, 2, 3, 4, 5, 6, 7], 7),
    (9, '#########', [0, 1, 2, 3, 4, 5, 6, 7, 8], 8),
    (10, '##########', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 9),
    (11, '###########', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 10),
    (12, '############', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11], 11),
    (13, '#############', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12], 12),
    (14, '##############', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13], 13),
    (15, '###############', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 