import pytest

@pytest.mark.parametrize('k, expected', [
    ('1 2', 3),
    ('2 1', 3),
    ('1 1', 2),
    ('2 2', 4),
])
def test_max_of_two_expressions(k, expected):
    a = int(k[0])
    b = int(k[1])
    assert max(2*a-1,2*b-1,a+b) == expected

