import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

import numpy as np

N,M = map(int,readline().split())
A = np.array(read().split(),np.int64)

A.sort()

def test(n):
    if n >= N:
        return True
    # 左から 2n 個をペア、右から 2N - 2n 個をペア。
    # 右側がすべて M 以上ならTrue
    R = A[n+n:]
    return np.min(R + R[::-1]) >= M

right = N # True
left = -1
while left + 1 < right:
    x = (left + right) // 2
    if test(x):
        right = x
    else:
        left = x

n = right
L = A[:n+n]
R = A[n+n:]
x = np.concatenate([L + L[::-1], R + R[::-1]])

answer = np.max(x % M)
print(answer)

