' Find the greatest common divisor of a list of numbers
'
# File changed

N = int(input())
tmplist = list(map(int, input().split(' ')))
tmplist.sort()
tmplist.reverse()

def gcd(a, b):
    'Find the greatest common divisor of two numbers

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The greatest common divisor of the two numbers.
    '
    while (b != 0):
        (a, b) = (b, (a % b))
    return a
res = tmplist[0]
for a in range(1, N):
    res = gcd(tmplist[a], res)
print(res)


