
import pytest

@pytest.mark.parametrize('N,A,B,expected', [
    (1, 2, 3, '1 0'),
    (1, 3, 2, '1 0'),
    (2, 1, 3, '1 1'),
    (2, 3, 1, '1 1'),
    (3, 1, 2, '1 2'),
    (3, 2, 1, '1 2'),
])
def test_that_min_and_max_are_correct(N, A, B, expected):
    assert (str(min(A, B)) + " " + str(max(0, A + B - N)) == expected)

