# File changed

k = 72
kk = (k // 4)
KK = (1 << k)
nu = (lambda L: int(''.join([hex((KK + a))[3:] for a in L[::(- 1)]]), 16))
st = (lambda n: hex(n)[2:])
li = (lambda s, l, r: [((int(a, 16) % P) if len(a) else 0) for a in [s[((- (i + 1)) * kk):((- i) * kk)] for i in range(l, r)]])

def grow(d, v, h):
    'Grows the table

    Args:
        d (int): The number of digits to grow by.
        v (int): The number of digits in the table.
        h (list): The table to grow.

    Returns:
        list: The grown table.
    '
    h += ([0] * d)
    f = [(((((((- 1) if ((i + d) % 2) else 1) * fainv[i]) * fainv[(d - i)]) % P) * h[i]) % P) for i in range(d + 1)]
    nuf = nu(f)
    a = ((d * inv[v]) % P)
    t = ([1] * ((3 * d) + 3))
    for i in range(1, ((3 * d) + 3)):
        t[i] = ((t[(i - 1)] * (((a - d) + i) - 1)) % P)
    ti = ([1] * ((3 * d) + 3))
    ti[(- 1)] = pow(t[(- 1)], (P - 2), P)
    for i in range(1, ((3 * d) + 3))[::(- 1)]:
        ti[(i - 1)] = ((ti[i] * (((a - d) + i) - 1)) % P)
    iv = ([1] * ((3 * d) + 3))
    for i in range(1, ((3 * d) + 3)):
        iv[i] = ((ti[i] * t[(i - 1)]) % P)
    g = [inv[i] for i in range(1, ((2 * d) + 2))]
    fg = li(st((nuf * nu(g))), d, ((d * 2) + 1))
    for i in range(d):
        h[((i + d) + 1)] = ((((fg[i] * fa[((d + i) + 1)]) % P) * fainv[i]) % P)
    g = [iv[i] for i in range(1, ((2 * d) + 2))]
    fg = li(st((nuf * nu(g))), d, ((d * 2) + 1))
    for i in range((d + 1)):
        h[i] = ((h[i] * ((((fg[i] * t[((d + i) + 1)]) % P) * ti[i]) % P)) % P)
    g = [iv[i] for i in range((d + 2), ((3 * d) + 3))]
    fg = li(st((nuf * nu(g))), d, ((d * 2) + 1))
    for i in range(d):
        h[((i + d) + 1)] = ((h[((i + d) + 1)] * ((((fg[i] * t[(((2 * d) + i) + 2)]) % P) * ti[((d + i) + 1)]) % P)) % P)
    return h

def create_table(v):
    'Creates the table

    Args:
        v (int): The number of digits in the table.

    Returns:
        list: The table.
    '
    s = 1
    X = [1, (v + 1)]
    while (s < v):
        X = grow(s, v, X)
        s *= 2
    table = [1]
    for x in X:
        table.append(((table[(- 1)] * x) % P))
    return table

def fact(i, table):
    'Calculates the factorial of i

    Args:
        i (int): The number to calculate the factorial of.
        table (list): The table to use.

    Returns:
        int: The factorial of i.
    '
    a = table[(i // v)]
    for j in range((((i // v) * v) + 1), (i + 1)):
        a = ((a * j) % P)
    return a
(H, W