# File changed


def main():
    from itertools import accumulate as ac
    from bisect import bisect_left as bl
    from bisect import bisect_right as br
    from sys import stdin
    input = stdin.readline

    def check(k):
        'Checks if the current value of k is valid

        Args:
            k (int): The current value of k.

        Returns:
            bool: True if the current value of k is valid, False otherwise.
        '
        dist = (a[((- k) - 1)] - ini)
        if (dist < 0):
            dist = abs(dist)
            return (k >= ((br(a, (ini + dist)) - bl(a, (ini - dist))) - 1))
        else:
            return (k >= (br(a, (ini + dist)) - bl(a, (ini - dist))))
    'Reads in the number of elements and the number of queries

    Args:
        n (int): The number of elements.
        q (int): The number of queries.
    '
    (n, q) = map(int, input().split())
    'Calculates the number of elements to consider

    Args:
        nn (int): The number of elements to consider.
    '
    nn = ((n // 2) + 1)
    'Reads in the elements

    Args:
        a (list): The list of elements.
    '
    a = list(map(int, input().split()))
    'Reads in the queries

    Args:
        x (list): The list of queries.
    '
    x = [int(input()) for _ in ([0] * q)]
    'Sorts the queries

    Args:
        ix (list): The sorted list of queries.
    '
    ix = sorted([[i, j] for (i, j) in enumerate(x)], key=(lambda x: x[1]))
    'Initializes the answers

    Args:
        ans (list): The list of answers.
    '
    ans = ([0] * q)
    'Calculates the accumulated sum

    Args:
        aac (list): The list of accumulated sums.
    '
    aac = ([0] + list(ac(a)))
    'Calculates the accumulated sum for the even elements

    Args:
        aac2 (list): The list of accumulated sums for the even elements.
    '
    aac2 = ([0] + list(ac(a[((n + 1) % 2)::2])))
    'Initializes the current value of k

    Args:
        k (int): The current value of k.
    '
