# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
N = int(readline())
A = ([0] + list(map(int, readline().split())))
m = map(int, read().split())
uv = zip(m, m)
graph = [[] for _ in range((N + 1))]
for (u, v) in uv:
    graph[u].append(v)
    graph[v].append(u)
root = 1
parent = ([0] * (N + 1))
ts = []
stack = [root]
while stack:
    x = stack.pop()
    ts.append(x)
    for y in graph[x]:
        if (y == parent[x]):
            continue
        parent[y] = x
        stack.append(y)
inf = (10 ** 18)
'\n各頂点において、\n・「根側を全て正にするための切断回数」\n・「各切断回数ごとの、根側に残る数の和の最小値」（array）\nを持つ\n'

def merge(dp1, dp2):
    (l1, l2) = (len(dp1), len(dp2))
    if (l1 > l2):
        (l1, l2) = (l2, l1)
        (dp1, dp2) = (dp2, dp1)
    dp = np.full(((l1 + l2) - 1), inf)
    for (i, x) in enumerate(dp1):
        np.minimum(dp[i:(l2 + i)], (x + dp2), out=dp[i:(l2 + i)])
    return dp

def v_to_e(cut, arr):
    arr = np.append(arr, 0)
    negative = np.where((arr < 0))[0]
    if (cut != inf):
        if (arr[(cut + 1)] > 0):
            arr[(cut + 1)] = 0
    if (len(negative) > 0):
        n = negative[0]
        if (cut > (n + 1)):
            cut = (n + 1)
    np.minimum(arr[(negative + 1)], 0, out=arr[(negative + 1)])
    return (cut, arr)
positivecutcnt = ([None] * (N + 1))
restsumarray = ([None] * (N + 1))
for x in ts[::(- 1)]:
    a = A[x]
    arr = np.array([a], np.int64)
    cut = 0
    for c in graph[x]:
        if (c == parent[x]):
            continue
        ccut = positivecutcnt[c]
        carr = restsumarray[c]
        (ccut, carr) = v_to_e(ccut, carr)
        cut += ccut
        arr = merge(arr, carr)
    if (a < 0):
        cut = inf
    positivecutcnt[x] = cut
    restsumarray[x] = arr
answer = positivecutcnt[1]
negative = np.where((restsumarray[1] < 0))[0]
if len(negative):
    n = negative[0]
    if (answer > n):
        answer = n
print(answer)



