h, w = map(int, input().split())

maze = []
for i in range(h):
    maze.append(input().rstrip())

dp = [[0] * w for _ in range(h)]
dp[0][0] = 1

mod = 10**9 + 7

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i][j] = (dp[i][j] + dp[i-1][j]) % mod
        if j > 0:
            dp[i][j] = (dp[i][j] + dp[i][j-1]) % mod

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp_2(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i][j] = (dp[i][j] + dp[i-1][j]) % mod
        if j > 0:
            dp[i][j] = (dp[i][j] + dp[i][j-1]) % mod

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp_3(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i][j] = (dp[i][j] + dp[i-1][j]) % mod
        if j > 0:
            dp[i][j] = (dp[i][j] + dp[i][j-1]) % mod

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp_4(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i][j] = (dp[i][j] + dp[i-1][j]) % mod
        if j > 0:
            dp[i][j] = (dp[i][j] + dp[i][j-1]) % mod

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp_5(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i][j] = (dp[i][j] + dp[i-1][j]) % mod
        if j > 0:
            dp[i][j] = (dp[i][j] + dp[i][j-1]) % mod

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp_6(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i][j] = (dp[i][j] + dp[i-1][j]) % mod
        if j > 0:
            dp[i][j] = (dp[i][j] + dp[i][j-1]) % mod

@pytest.mark.parametrize('i, j', [(i, j) for i in range(h) for j in range(w)])
def test_maze_dp_7(i, j):
    if maze[i][j] == '.':
        if i > 0:
            dp[i