import sys
sys.setrecursionlimit((1 << 25))
readline = sys.stdin.buffer.readline
read = sys.stdin.readline
import numpy as np
from functools import partial
array = partial(np.array, dtype=np.int64)
zeros = partial(np.zeros, dtype=np.int64)
full = partial(np.full, dtype=np.int64)
ra = range
enu = enumerate

def exit(*argv, **kwarg):
    print(*argv, **kwarg)
    sys.exit()

def mina(*argv, sub=1):
    return list(map((lambda x: (x - sub)), argv))

def a_int():
    return int(readline())

def read_matrix(H, W):
    'return np.ndarray shape=(H,W) matrix'
    lines = []
    for _ in range(H):
        lines.append(read())
    lines = ' '.join(lines)
    return np.fromstring(lines, sep=' ', dtype=np.int64).reshape(H, W)
mod = ((10 ** 9) + 7)
inf = (2 ** 31)
from collections import defaultdict, Counter, deque
from operator import itemgetter, xor, add
from itertools import product, permutations, combinations
from bisect import bisect_left, bisect_right
from functools import reduce
N = a_int()
A = read_matrix(N, N)

from numba import njit

@njit('(i8,i8[:,:])', cache=True)
def solve(N, A):
    dp = np.zeros(((N + 1), (1 << N)), dtype=np.int64)
    dp[(0, 0)] = 1
    for i in range(N):
        for s in range((1 << N)):
            if (popcount(s) != i):
                continue
            for j in range(N):
                if ((((s >> j) & 1) == 0) and (A[(i, j)] == 1)):
                    dp[((i + 1), (s + (1 << j)))] += dp[(i, s)]
                    dp[((i + 1), (s + (1 << j)))] %= mod
    print((dp[(N, ((1 << N) - 1))] % mod))

@njit('(i8,i8[:,:])', cache=True)
def solve2(N, A):
    dp = np.zeros((1 << N), dtype=np.int64)
    dp[0] = 1
    for s in range((1 << N)):
        for j in range(N):
            if ((((s >> j) & 1) == 0) and (A[(popcount(s), j)] == 1)):
                dp[(s + (1 << j))] += dp[s]
                dp[(s + (1 << j))] %= mod
    print((dp[((1 << N) - 1)] % mod))
solve(N, A)

