# File changed

import sys
import numpy as np
import numba
from numba import njit
i4 = numba.int32
i8 = numba.int64
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit((i8[(:, :)],), cache=True)
def main(A):
    n = A.shape[0]
    inf = (1 << 60)
    dp = np.full((1 << n), (- inf), np.int64)
    dp[0] = 0
    for s in range((1 << n)):
        x = 0
        for j in range(n):
            for i in range(j):
                if ((s & (1 << j)) and (s & (1 << i))):
                    x += A[(i, j)]
        t = s
        while t:
            x = max(x, (dp[t] + dp[(s ^ t)]))
            t = ((t - 1) & s)
        dp[s] = x
    return dp[(- 1)]
n = int(readline())
A = np.array(read().split(), np.int64).reshape(n, n)
print(main(A))

