def factorize(n):
  fct = []
  b, e = 2, 0
  while b*b <= n:
    while n % b == 0:
      n //= b
      e += 1
    if e > 0:
      fct.append((b, e))
    b, e = b+1, 0
  if n > 1:
    fct.append((n, 1))
  return fct

N, p = map(int, input().split())
fac = factorize(p)
ans = 1
for i in fac:
  ans *= (i[0] ** (i[1] // N))
print(ans)

