def factorize(n):
    fct = []
    b, e = 2, 0
    while b * b <= n:
        while n % b == 0:
            n = n // b
            e = e + 1
        if e > 0:
            fct.append((b, e))
        b, e = b + 1, 0
    if n > 1:
        fct.append((n, 1))
    return fct


N, P = map(int, input().split())
fac = factorize(P)
ans = 1
for i in fac:
    ans *= i[0] ** (i[1] // N)
print(ans)