import pytest

@pytest.fixture
def n():
    return

@pytest.fixture
def k():
    return

@pytest.fixture
def hei_list():
    return

def test_hei_list_is_sorted(hei_list):
    assert (hei_list == sorted(hei_list))

def test_min_dist_is_correct(n, k, hei_list):
    min_dist = 1000000000
    for i in range(n - k + 1):
        tmp_dist = hei_list[i + k - 1] - hei_list[i]
        if i == 0:
            min_dist = tmp_dist
        elif tmp_dist < min_dist:
            min_dist = tmp_dist
    assert (min_dist == 1000000000)

