N = int(input())
seed_primes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97]
prime_map = {}
for prime in seed_primes:
    prime_map[prime] = 0


for i in range(2, N+1):
    _i = i
    for prime in seed_primes:
        while _i % prime == 0:
            prime_map[prime] += 1
            _i = _i // prime

reduced_prime_map = {}
for k, v in prime_map.items():
    if v > 0:
        reduced_prime_map[k] = v

prime_list = list(reduced_prime_map.values())

@pytest.mark.parametrize('n, res', [
    (0, 1),
    (1, 2),
    (2, 4),
    (3, 14),
    (4, 24),
    (5, 74),
])
def test_dfs(n, res):
    global count
    if res == 75:
        count += 1
        return
    if res > 75:
        return
    if n == len(prime_list):
        return

    for thres in [0, 2, 4, 14, 24, 74]:
        if prime_list[n] >= thres:
            dfs(n + 1, res*(thres+1))

count = 0
dfs(0, 1)
print(count)

