' Finds the LCM of two numbers
'
# File changed


def gcd(a, b):
    'Finds the GCD of two numbers

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The GCD of the two numbers.
    '
    while b:
        (a, b) = (b, (a % b))
    return a

def lcm(a, b):
    'Finds the LCM of two numbers

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The LCM of the two numbers.
    '
    return ((a * b) // gcd(a, b))
(n, m) = map(int, input().split())
s = input()
t = input()
lc = lcm(n, m)
dic = {}
for i in range(len(s)):
    dic[((lc // n) * i)] = s[i]
for i in range(len(t)):
    if (((lc // m) * i) in dic):
        if (dic[((lc // m) * i)] != t[i]):
            print((- 1))
            exit()
print(lc)


