' Checks if two strings are anagrams
'
from collections import Counter

def is_anagram(s, t):
    'Checks if two strings are anagrams

    Args:
        s (str): The first string.
        t (str): The second string.

    Returns:
        bool: True if the strings are anagrams, False otherwise.
    '
    s = list(Counter(s).values())
    t = list(Counter(t).values())
    s.sort()
    t.sort()
    if (s == t):
        return True
    else:
        return False


