import math

# import time


def get_primes(n):
    primes = []
    checks = [True for _ in range(int(math.sqrt(n)) + 1)]
    checks[0] = checks[1] = False
    for i in range(2, len(checks)):
        if checks[i]:
            primes.append(i)
            tmp = 0
            while i + tmp * i < len(checks):
                checks[i + tmp * i] = False
                tmp += 1
    return primes


def combination(a, b):
    i = 1
    for _i in range(a - b + 1, a + 1):
        i *= _i
    return i // math.factorial(b)


@pytest.mark.parametrize('n, m, expected', [
    (1, 1, 1),
    (1, 2, 1),
    (1, 3, 1),
    (1, 4, 1),
    (1, 5, 1),
    (1, 6, 1),
    (1, 7, 1),
    (1, 8, 1),
    (1, 9, 1),
    (1, 10, 1),
    (1, 11, 1),
    (1, 12, 1),
    (1, 13, 1),
    (1, 14, 1),
    (1, 15, 1),
    (1, 16, 1),
    (1, 17, 1),
    (1, 18, 1),
    (1, 19, 1),
    (1, 20, 1),
    (1, 21, 1),
    (1, 22, 1),
    (1, 23, 1),
    (1, 24, 1),
    (1, 25, 1),
    (1, 26, 1),
    (1, 27, 1),
    (1, 28, 1),
    (1, 29, 1),
    (1, 30, 1),
    (1, 31, 1),
    (1, 32, 1),
    (1, 33, 1),
    (1, 34, 1),
    (1, 35, 1),
    (1, 36, 1),
    (1, 37, 1),
    (1, 38, 1),
    (1, 39, 1),
    (1, 40, 1),
    (1, 41, 1),
    (1, 42, 1),
    (1, 43, 1),
    (1, 44, 1),
    (1, 45, 1