@pytest.mark.parametrize('N,K,x,expected', [
    (5, 3, [1, 2, 3, 4, 5], 2),
    (5, 3, [1, 2, 3, 4, -5], 3),
    (5, 3, [1, 2, 3, -4, -5], 4),
    (5, 3, [1, 2, -3, -4, -5], 5),
    (5, 3, [1, -2, -3, -4, -5], 6),
    (5, 3, [-1, -2, -3, -4, -5], 7),
])
def test_case(N, K, x, expected):
    assert expected == solution(N, K, x)

def solution(N, K, x):
    index = 0
    ans = 10**9
    while index + K - 1 < N:
        start = x[index]
        end = x[index + K - 1]
        if start < 0:
            ans = min(ans,abs(end-start)+abs(start))
            ans = min(ans,abs(end-start)+abs(end))
        else:
            ans = min(ans,end)
        index += 1
    return ans

