from itertools import accumulate


def main():
    n = int(input())
    A = list(map(int, input().split()))
    S = list(accumulate(A))
    left = 0
    right = 2
    ans = float('inf')
    for i in range(1, n - 2):
        while abs(S[left] - (S[i] - S[left])) > abs(S[left + 1] - (S[i] - S[left + 1])):
            left += 1
        while abs(S[right] - S[i] - (S[n - 1] - S[right])) > abs(S[right + 1] - S[i] - (S[n - 1] - S[right + 1])):
            right += 1
        minL, maxL = min(S[left], S[i] - S[left]), max(S[left], S[i] - S[left])
        minR, maxR = min(S[right] - S[i], S[n - 1] - S[right]), max(S[right] - S[i], S[n - 1] - S[right])
        ans = min(ans, max(maxL, maxR) - min(minL, minR))
    print(ans)


if __name__ == '__main__':
    main()

