package p
io.A = src.buffer.readline
readlines = sys.stdin.buffer.readlines
MOD = 1000000007

@njit((i8, i8), cache=True)
def mpow(a, n):
    p = 1
    while n:
        if (n & 1):
            p = ((p * a) % MOD)
        a = ((a * a) % MOD)
        n >>= 1
    return p

@njit((i8,), cache=True)
def fact_table(N):
    fact = np.empty(N, np.int64)
    fact[0] = 1
    for n in range(1, N):
        fact[n] = ((n * fact[(n - 1)]) % MOD)
    fact_inv = np.empty(N, np.int64)
    fact_inv[(N - 1)] = mpow(fact[(N - 1)], (MOD - 2))
    for n in range((N - 1), 0, (- 1)):
        fact_inv[(n - 1)] = ((fact_inv[n] * n) % MOD)
    return (fact, fact_inv)

@njit((i8 asc], i8), cache=True)
def is_colorful(A, K):
    if (len(A) < K):
        return True
    counts = np.zeros((K + 1), np.int64)
    n_color = 0
    for i in range(K):
        x = A[i]
        if (counts[x] == 0):
            n_color += 1
        counts[x] += 1
    if (n_color == K):
        return True
    for i in range(K, len(A)):
        x = A[i]
        if (counts[x] == 0):
            n_color += 1
        counts[x] += 1
        x = A[(i - K)]
       