# File changed

import sys
sys.setrecursionlimit((2 * (10 ** 5)))
(N, M) = map(int, input().split())
p = ([0] + list(map(int, input().split())))
(x, y) = zip(*(map(int, input().split()) for _ in range(M)))
E = [[] for _ in range((N + 1))]
for (a, b) in zip(x, y):
    E[a].append(b)
    E[b].append(a)
v = [True for _ in range((N + 1))]

def f(i, P, Q):
    'Recursive function to find the number of connected components

    Args:
        i (int): The current index to consider.
        P (set): The set of nodes that are connected to the current node.
        Q (set): The set of nodes that are connected to the current node and have a value
            equal to the current node.
    '
    v[i] = False
    P.add(i)
    Q.add(p[i])
    for a in E[i]:
        if v[a]:
            f(a, P, Q)
ans = 0
for i in range(1, (N + 1)):
    if v[i]:
        P = set()
        Q = set()
        f(i, P, Q)
        ans += len((P & Q))
print(ans)


