import pytest

@pytest.mark.parametrize('N, D, X, A, expected', [
    (1, 1, 1, [1], 2),
    (2, 2, 2, [1, 2], 4),
    (3, 3, 3, [1, 2, 3], 6),
    (4, 4, 4, [1, 2, 3, 4], 8),
    (5, 5, 5, [1, 2, 3, 4, 5], 10),
])
def test_eat_all_the_candies(N, D, X, A, expected):
    d = D - 1
    eat = 0
    for a in A:
        eat += d // a + 1
    assert eat + X == expected

