'
# File changed

from collections import Counter

def max_subarray(n, s, m, t):
    'Finds the maximum subarray of s that is not a subarray of t

    Args:
        n (int): The number of elements in s.
        s (list): The list of elements to find the maximum subarray of.
        m (int): The number of elements in t.
        t (list): The list of elements to find the maximum subarray of s that is not a subarray of.

    Returns:
        int: The maximum subarray of s that is not a subarray of t.
    '
    s = Counter([input() for _ in range(n)])
    t = Counter([input() for _ in range(m)])
    s.subtract(t)
    return max(0, max(s.values()))


