' File changed


def can_match(x1, y1, x2, y2):
    'Determines if two points can be matched

    Args:
        x1 (int): The x coordinate of the first point.
        y1 (int): The y coordinate of the first point.
        x2 (int): The x coordinate of the second point.
        y2 (int): The y coordinate of the second point.

    Returns:
        bool: True if the points can be matched, False otherwise.
    '
    return ((x1 < x2) and (y1 < y2))
N = int(input())
red = []
blue = []
for i in range(N):
    (x, y) = map(int, input().split())
    red.append((x, y))
for i in range(N):
    (x, y) = map(int, input().split())
    blue.append((x, y))
red.sort()
ans = 0
for i in range((N - 1), (- 1), (- 1)):
    (xr, yr) = red[i]
    yb_min = (2 * N)
    arg_yb_min = 0
    matched = False
    for (xb, yb) in blue:
        if (can_match(xr, yr, xb, yb) and (yb < yb_min)):
            matched = True
            arg_yb_min = xb
            yb_min = yb
    if matched:
        ans += 1
        blue.remove((arg_yb_min, yb_min))
print(ans)


