# File changed

mis = (lambda : map(int, input().split()))
from math import acos

def ccw(p1, p2, p3):
    return (((p2[0] - p1[0]) * (p3[1] - p1[1])) - ((p2[1] - p1[1]) * (p3[0] - p1[0])))

def ConvexHull(p):
    u = []
    l = []
    p.sort()
    for q in p:
        while ((len(u) > 1) and (ccw(u[(- 2)], u[(- 1)], q) >= 0)):
            u.pop()
        while ((len(l) > 1) and (ccw(l[(- 2)], l[(- 1)], q) <= 0)):
            l.pop()
        u.append(q)
        l.append(q)
    return (u + l[(- 2):0:(- 1)])

def angle(v1, v2):
    inner = ((v1[0] * v2[0]) + (v1[1] * v2[1]))
    v1s = (((v1[0] ** 2) + (v1[1] ** 2)) ** 0.5)
    v2s = (((v2[0] ** 2) + (v2[1] ** 2)) ** 0.5)
    return acos(((inner / v1s) / v2s))
n = int(input())
if (n == 1):
    print(1)
    exit()
if (n == 2):
    print(0.5)
    print(0.5)
    exit()
p = [(tuple(mis()) + (i,)) for i in range(n)]
ch = ConvexHull(p)
bsc = []
for i in range(len(ch)):
    (x1, y1, i1) = ch[i]
    (x2, y2, i2) = ch[(i - 1)]
    bsc.append(((y1 - y2), (x2 - x1)))
if (len(ch) == 2):
    angles = [1, 1]
else:
    angles = [angle(bsc[i], bsc[(i - 1)]) for i in range(len(ch))]
s = sum(angles)
ans = ([0] * n)
for i in range(len(ch)):
    (x, y, ind) = ch[(i - 1)]
    ans[ind] = (angles[i] / s)
for x in ans:
    print(x)

