import pytest

@pytest.mark.parametrize('n,m,a,b', [
    (1, 1, 0, 0),
    (1, 1, 1, 1),
    (1, 2, 0, 0),
    (1, 2, 1, 0),
    (1, 2, 0, 1),
    (1, 2, 1, 1),
    (2, 1, 0, 0),
    (2, 1, 0, 1),
    (2, 1, 1, 0),
    (2, 1, 1, 1),
    (2, 2, 0, 0),
    (2, 2, 0, 1),
    (2, 2, 1, 0),
    (2, 2, 1, 1),
    (2, 3, 0, 0),
    (2, 3, 0, 1),
    (2, 3, 1, 0),
    (2, 3, 1, 1),
    (2, 3, 0, 2),
    (2, 3, 1, 2),
    (2, 3, 2, 0),
    (2, 3, 2, 1),
    (2, 3, 2, 2),
    (3, 2, 0, 0),
    (3, 2, 0, 1),
    (3, 2, 1, 0),
    (3, 2, 1, 1),
    (3, 2, 0, 2),
    (3, 2, 1, 2),
    (3, 2, 2, 0),
    (3, 2, 2, 1),
    (3, 2, 2, 2),
    (3, 3, 0, 0),
    (3, 3, 0, 1),
    (3, 3, 1, 0),
    (3, 3, 1, 1),
    (3, 3, 0, 2),
    (3, 3, 1, 2),
    (3, 3, 2, 0),
    (3, 3, 2, 1),
    (3, 3, 2, 2),
    (3, 4, 0, 0),
    (3, 4, 0, 1),
    (3, 4, 1, 0),
    (3, 4, 1, 1),
    (3, 4, 0, 2),
    (3, 4, 1, 2),
    (3, 4, 2, 0),
    (3, 4, 2, 1),
    (3, 4, 2, 2),
    (3, 4, 0, 3),
    (3, 4, 1, 3),
    (3, 4, 2, 3),
    (3, 4, 3, 0),
    (3, 4, 3, 1),
    (3, 4, 3, 2),
    (3, 4, 3, 3),
    (4, 3, 0, 0),
    (4, 3, 0, 1),
    (4, 3, 1, 0),
    (4, 3, 1, 1),
    (4, 3, 0, 2),
    (4, 3, 1, 2),
    (4, 3, 2, 0),
    (4, 3, 2, 1),
    (4, 3, 2, 2),
    (4, 3, 0, 3),
    (4, 3, 1, 3),
    (4, 3, 2, 3),
    (4, 3, 3, 0),
    (4, 3, 3, 1),
    (4, 3, 3, 2),
    (4, 3, 3, 3),
    (4, 4, 0, 0),
    (4, 4, 0, 1),
    (4, 4, 1, 0),
    (4, 4, 1, 1),
    (4, 4, 0, 2),
    (4, 4, 1, 2),
    (4, 4, 2, 0),
    (4, 4, 2, 1),
    (4, 4, 2, 2),
    (4, 4, 0, 3),
    (4, 4, 1, 3),
    (4, 4, 2, 3),
    (4, 4, 3, 0),
    (4, 4, 3, 1),
    (4, 4, 3, 2),
    (4, 4, 3, 3),
    (4, 5, 0, 0),
    (4, 5, 0, 1),
    (4, 5, 1, 0),
    (4, 5, 1, 1),
    (4, 5, 0, 2),
    (4, 5, 1, 2),
    (4, 5, 2, 0),
    (4, 5, 2, 1),
    (4, 5, 2, 2),
    (4, 5, 0, 3),
    (4, 5, 1, 3),
    (4, 5, 2, 3),
    (4, 5, 3, 0),
    (4, 5, 3, 1),
    (4, 5, 3, 2),
    (4, 5, 3, 3),
    (4, 5, 0, 4),
    (4, 5, 1, 4),
    (4, 5, 2, 4