# File changed

import itertools
import os
import sys
import numpy as np
from scipy.sparse.csgraph._shortest_path import floyd_warshall
if os.getenv('LOCAL'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit((10 ** 9))
INF = float('inf')
IINF = (10 ** 18)
MOD = ((10 ** 9) + 7)
N = int(sys.stdin.buffer.readline())
AB = []
for _ in range((N - 1)):
    AB.append(list(map(int, sys.stdin.buffer.readline().split())))
graph = []
for _ in range(N):
    graph.append([])
for (a, b) in AB:
    graph[a].append(b)
    graph[b].append(a)

def test():
    G = []
    for _ in range(N):
        G.append(([0] * N))
    for (a, b) in AB:
        G[a][b] = 1
        G[b][a] = 1
    dist = floyd_warshall(G)
    ret = N
    for choice in itertools.product([True, False], repeat=N):
        k = sum(choice)
        if (k == 0):
            continue
        if (k >= ret):
            continue
        D = dist[np.array(choice, dtype=bool)]
        s = set()
        for d in D.T:
            s.add(str(d))
        if (len(s) == D.shape[1]):
            ret = min(ret, k)
    return ret

def dfs(v, p, forked):
    '\n    :param v:\n    :param p:\n    :param bool forked: 枝分かれしてる頂点が先祖にあるか\n    '
    counts = []
    for u in graph[v]:
        if (u == p):
            continue
        cnt = dfs(u, v, (forked or (len(graph[v]) >= 3)))
        counts.append(cnt)
    zeros = (counts.count(0) + (not forked))
    return (sum(counts) + max(0, (zeros - 1)))
leaf = 0
for v in range(N):
    if (len(graph[v]) == 1):
        leaf = v
        break
ans = dfs(leaf, None, False)
print(ans)

# File changed

import itertools
import os
import sys
import numpy as np
from scipy.sparse.csgraph._shortest_path import floyd_warshall
if os.getenv('LOCAL'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit((10 ** 9))
INF = float('inf')
IINF = (10 ** 18)
MOD = ((10 ** 9) + 7)
N = int(sys.stdin.buffer.readline())
AB = []
for _ in range((N - 1)):
    AB.append(list(map(int, sys.stdin.buffer.readline().split())))
graph = []
for _ in range(N):
    graph.append([])
for (a, b) in AB:
    graph[a].append(b)
    graph[b].append(a)

def test():
    G = []
    for _ in range(N):
        G.append(([0] * N))
    for (a, b) in AB:
        G[a][b] =