# File changed

import numpy as np

def imos2d(x1, y1, x2, y2, board):
  board[y1][x1] += 1
  board[y2][x2] += 1
  board[y2][x1] -= 1
  board[y1][x2] -= 1

if (__name__ == '__main__'):
  (n, k) = map(int, input().split())
  lines = [input() for _ in range(n)]
  k2 = 2 * k
  add_dict = {'W': 0, 'B': k}
  board = [[0 for _ in range(k2+1)] for _ in range(k2+1)]
  for line in lines:
    ls = line.split()
    x = int(ls[0]) % k2
    y = (int(ls[1]) + add_dict[ls[2]]) % k2
    x_ = x % k
    y_ = y % k
    if (((x < k) and (y < k)) or ((k <= x) and (k <= y))):
      imos2d(0, 0, x_+1, y_+1, board)
      imos2d((x_+k+1), 0, k2, y_+1, board)
      imos2d(0, (y_+k+1), x_+1, k2, board)
      imos2d((x_+k+1), (y_+k+1), k2, k2, board)
      imos2d((x_+1), (y_+1), (x_+k+1), (y_+k+1), board)
    else:
      imos2d((x_+1), 0, (x_+k+1), y_+1, board)
      imos2d((x_+1), (y_+k+1), (x_+k+1), k2, board)
      imos2d(0, (y_+1), (x_+1), (y_+k+1), board)
      imos2d((x_+k+1), (y_+1), k2, (y_+k+1), board)
  board = np.array(board)
  for x in range(k2):
    board[:, (x+1)] += board[:, x]
  for y in range(k2):
    board[(y+1), :] += board[(y, :)]
  print(board.max())



