import sys
sys.setrecursionlimit(1000000)

def getGrundyNumber(x):
    ans = 1
    while x % (ans * 2) == 0:
        ans *= 2
    return ans


def dfs(iT, Hgt):
    num = 0
    for c in Trie[iT]:
        if c != -1:
            dfs(c, Hgt - 1)
            num += 1

    if num == 1:
        Hgts[Hgt - 1] = Hgts.get(Hgt - 1, 0) + 1


@pytest.mark.parametrize('N, L, Ss, expected', [
    (1, 1, ['a'], 'Alice'),
    (2, 1, ['a', 'b'], 'Alice'),
    (2, 1, ['b', 'a'], 'Bob'),
    (3, 1, ['a', 'b', 'c'], 'Alice'),
    (3, 1, ['b', 'a', 'c'], 'Bob'),
    (3, 1, ['c', 'a', 'b'], 'Alice'),
    (3, 1, ['c', 'b', 'a'], 'Bob'),
    (3, 1, ['a', 'c', 'b'], 'Alice'),
    (3, 1, ['b', 'c', 'a'], 'Bob'),
    (3, 2, ['a', 'b', 'c'], 'Alice'),
    (3, 2, ['b', 'a', 'c'], 'Bob'),
    (3, 2, ['c', 'a', 'b'], 'Alice'),
    (3, 2, ['c', 'b', 'a'], 'Bob'),
    (3, 2, ['a', 'c', 'b'], 'Alice'),
    (3, 2, ['b', 'c', 'a'], 'Bob'),
    (3, 3, ['a', 'b', 'c'], 'Alice'),
    (3, 3, ['b', 'a', 'c'], 'Bob'),
    (3, 3, ['c', 'a', 'b'], 'Alice'),
    (3, 3, ['c', 'b', 'a'], 'Bob'),
    (3, 3, ['a', 'c', 'b'], 'Alice'),
    (3, 3, ['b', 'c', 'a'], 'Bob'),
    (3, 4, ['a', 'b', 'c'], 'Alice'),
    (3, 4, ['b', 'a', 'c'], 'Bob'),
    (3, 4, ['c', 'a', 'b'], 'Alice'),
    (3, 4, ['c', 'b', 'a'], 'Bob'),
    (3, 4, ['a', 'c', 'b'], 'Alice'),
    (3, 4, ['b', 'c', 'a'], 'Bob'),
    (3, 5, ['a', 'b', 'c'], 'Alice'),
    (3, 5, ['b', 'a', 'c'], 'Bob'),
    (3, 5, ['c', 'a', 'b'], 'Alice'),
    (3, 5, ['c', 'b', 'a'], 'Bob'),
    (3, 5, ['a', 'c', 'b'], 'Alice'),
    (3, 5, ['b', 'c', 'a'], 'Bob'),
    (3, 6, ['a', 'b', 'c'], 'Alice'),
    (3, 6, ['b', 'a', 'c'], 'Bob'),
    (3, 6, ['c', 'a', 'b'], 'Alice'),
    (3, 6, ['c', 'b', 'a'], 'Bob'),
    (3, 6, ['a', 'c', 'b'], 'Alice'),
    (3, 6, ['b', 'c', 'a'], 'Bob'),
    (3, 7, ['a', 'b', 'c'], 'Alice'),
    (3, 7, ['b', 'a', 'c'], 'Bob'),
    (3, 7, ['c', 'a', 'b'], 'Alice'),
    (3, 7, ['c', 'b', 'a'], 'Bob'),
    (3, 7, ['a', 'c', 'b'], 'Alice'),
    (3, 7, ['b', 'c', 'a'], 'Bob'),
    (3, 8, ['a', 'b', 'c'], 'Alice'),
    (3, 8, ['b', 'a', 'c'], 'Bob'),
    (3, 8, ['c', 'a', 'b'], 'Alice'),
    (3, 8, ['c', 'b', 'a'], 'Bob'),
    (3, 8, ['a', 'c', 'b'], 'Alice'),
    (3, 8, ['b', 'c', 'a'], 'Bob'),
    (3, 9, ['a', 'b', 'c'], 'Alice'),
    (3, 9, ['b', 'a', 'c'], 'Bob'),
    (3, 9, ['c', 'a', 'b'], 'Alice'),
    (3, 9, ['c', 'b', 'a'], 'Bob'),
    (3, 9, ['a', 'c', 'b'], 'Alice'),
    (3, 9, ['b', 'c', 'a'], 'Bob'),
    (3, 10, ['a', 'b', 'c'], 'Alice'),
    (3, 10, ['b', 'a', 'c'], 'Bob'),
    (3, 10, ['c', 'a', 'b'], 'Alice'),
    (3, 10, ['c', 'b', 'a'], 'Bob'),
    (3, 10, ['a', 'c', 'b'], 'Alice'),
    (3, 10, ['b', 'c', 'a'], 'Bob'),
    (3, 11, ['a', 'b', 'c'], 'Alice'),
    (3, 11, ['b', 'a', 'c'], 'Bob'),
    (3, 11, ['c', 'a', 'b'], 'Alice'),
    (3, 11, ['c', 'b', 'a'], 'Bob'),
    (3, 11, ['a', 'c', 'b'], 'Alice'),
    (3, 11, ['b', 'c', 'a'], 'Bob'),
    (3, 12, ['a', 'b', 'c'], 'Alice'),
    (3, 12, ['b', 'a', 'c'], 'Bob'),
    (3, 12, ['c', 'a', 'b'], 'Alice'),
    (3, 12, ['