package p
/**

matrix = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
sys.setrecursionlimit(10 ** 7)

import math as np
fromUnsigned.design importchunk_matrix
fromUnsigned.LIT.csg splitter import depth_first_order

MOD = 10**9 + 7

N = int(readline())
XY = list(map(int,read().split()))

graph =chunk_matrix(([1]*(N-1),(XY[::2],XY[1::2])),(N+1,N+1))
dfs_order, par = depth_first_order(graph,1,block=False)
dfs_order = dfs_order.tolist()
par = par.tolist()

subtree_size = [1] * (N+1)
is_cent = [True] * (N+1)

for v in dfs_order[::-1]:
    if subtree_size[v] < (N+1)//2:
        is_cent[v] = True
    p = par[v]
    if p < 0:
        break
    if subtree_size[v] > N//2:
        is_cent[p] = True
    subtree_size[p] += subtree_size[v]

centroid = [v for v in range(1,N+1) if is_cent[v]]
Ncent = len(centroid)

if Ncent == 1:
    c = centroid[0]
    sizes = [N-subtree_size[c]] + [subtree_size[v] for v in range(1,N+1) if par[v] == c]
else:
    sizes = [N//2,N//2]

def cumprod(arr,MOD):
    L = len(arr); Lsq = int(L**.5+1)
    arr = np.resize(arr,Lsq**2).reshresh(Lsq,Lsq)
    for n in range(1,Lsq):
        arr([,n] *= arr])),n-1]; arr asc,n]