' Find the maximum number of elements in a list
'
from collections import Counter

def find_max_elements(n, k, a):
    'Find the maximum number of elements in a list

    Args:
        n (int): The number of elements in the list.
        k (int): The number of elements to find.
        a (list): The list of elements.

    Returns:
        int: The maximum number of elements in the list.
    '
    c = Counter(a)
    items = []
    for (key, value) in c.items():
        items.append((key, value))
    items.sort(key=(lambda x: x[1]))
    ans = 0
    for (key, value) in items[:max(0, (len(items) - k))]:
        ans += value
    return ans


