import pytest

@pytest.fixture
def N():
    return int(input())

@pytest.fixture
def src(N):
    return [tuple(map(int,input().split())) for i in range(N)]

@pytest.fixture
def cum_r(src):
    cum_r = [src[0][1]]
    for (x1,s1),(x2,s2) in zip(src,src[1:]):
        gain = s2 - (x2 - x1)
        cum_r.append(cum_r[-1] + gain)
    return cum_r

@pytest.fixture
def best_l(src, cum_r):
    best_l = [0]
    for (x,s),c in list(zip(src, cum_r))[1::]:
        best_l.append(max(best_l[-1], s - c))
    return best_l

@pytest.fixture
def ans(best_l, cum_r):
    ans = 0
    for l,r in zip(best_l, cum_r):
        ans = max(ans, l+r)
    return ans

def test_ans(ans):
    print(ans)

