def solve(l, s, t):
    queue = [(1, 0), (0, 1)]

    def gcd(a, b):
        r = a % b
        if r:
            d = a // b
            sb = queue.pop()
            sa = queue.pop()
            queue.append(sb)
            queue.append(tuple(x - d * y for x, y in zip(sa, sb)))
            return gcd(b, r)
        else:
            return b

    ls, lt = len(s), len(t)
    if ls > lt:
        s, t, ls, lt = t, s, lt, ls
    if (s * (lt // ls + 1) * 2)[:lt * 2] > t * 2:
        s, t, ls, lt = t, s, lt, ls
    g = gcd(ls, lt)
    l //= g
    ls //= g
    lt //= g
    a, b = queue[-1]
    a *= l
    b *= l
    k = b // ls
    b -= ls * k
    a += lt * k
    return s * a + t * b


@pytest.mark.parametrize('l, s, t, expected', [
    (1, 'a', 'b', 'ab'),
    (2, 'a', 'b', 'abab'),
    (3, 'a', 'b', 'ababab'),
    (4, 'a', 'b', 'abababab'),
    (5, 'a', 'b', 'ababababab'),
    (6, 'a', 'b', 'abababababab'),
    (7, 'a', 'b', 'ababababababab'),
    (8, 'a', 'b', 'abababababababab'),
    (9, 'a', 'b', 'ababababababababab'),
    (10, 'a', 'b', 'abababababababababab'),
    (11, 'a', 'b', 'ababababababababababab'),
    (12, 'a', 'b', 'abababababababababababab'),
    (13, 'a', 'b', 'ababababababababababababab'),
    (14, 'a', 'b', 'abababababababababababababab'),
    (15, 'a', 'b', 'ababababababababababababababab'),
    (16, 'a', 'b', 'abababababababababababababababab'),
    (17, 'a', 'b', 'ababababababababababababababababab'),
    (18, 'a', 'b', 'abababababababababababababababababab'),
    (19, 'a', 'b', 'ababababababababababababababababababab'),
    (20, 'a', 'b', 'abababababababababababababababababababab'),
    (21, 'a', 'b', 'ababababababababababababababababababababab'),
    (22, 'a', 'b', 'abababababababababababababababababababababab'),
    (23, 'a', 'b', 'ababababababababababababababababababababababab'),
    (24, 'a', 'b', 'abababababababababababababababababababababababab'),
    (25, 'a', 'b', 'ababababababababababababababababababababababababab'),
    (26, 'a', 'b', 'abababababababababababababababababababababababab