# File changed

import sys
from heapq import heappop, heappush, heapify

def main():
    input = sys.stdin.readline
    (n, q) = map(int, input().split())
    A = list(map(int, input().split()))
    B = list(map(int, input().split()))
    ls = [(b - a) for (a, b) in zip(A, B)]
    qm = [(- v) for v in ls[1:(- 1)] if (v < 0)]
    qp = [v for v in ls[1:(- 1)] if (v >= 0)]
    heapify(qm)
    heapify(qp)
    sum_a = sum(A)
    sum_qp = sum(qp)
    to_remove = set()
    odd = (len(qp) % 2)
    ans = []
    answer = ((sum_a + sum_qp) - (min(qp[0], qm[0]) if odd else 0))
    for _ in range(q):
        (p, x, y) = map(int, input().split())
        p -= 1
        v = (y - x)
        sum_a += (x - A[p])
        if ((p == 0) or (p == ((2 * n) - 1))):
            answer += (x - A[p])
            ans.append(answer)
            A[p] = x
            continue
        A[p] = x
        odd ^= ((ls[p] >= 0) ^ (v >= 0))
        if (v >= 0):
            sum_qp += v
        if (ls[p] >= 0):
            sum_qp -= ls[p]
        to_remove.add(ls[p])
        ls[p] = v
        if (v >= 0):
            heappush(qp, v)
        else:
            heappush(qm, (- v))
        answer = (sum_qp + sum_a)
        if odd:
            while (qp[0] in to_remove):
                to_remove.remove(heappop(qp))
            while ((- qm[0]) in to_remove):
                to_remove.remove((- heappop(qm)))
            answer -= min(qp[0], qm[0])
        ans.append(answer)
    print('\n'.join(map(str, ans)))
main()



