' File changed

from collections import defaultdict
from collections import deque
(N, M) = map(int, input().split())
D = defaultdict(list)
Edge = []
for i in range(M):
    (A, B) = map(int, input().split())
    D[(A - 1)].append((B - 1))
    D[(B - 1)].append((A - 1))
    Edge.append(((A - 1), (B - 1)))

def dfs(n, vstd, i):
    'Performs a depth-first search on the graph

    Args:
        n (int): The node to start the search from.
        vstd (set): The set of visited nodes.
        i (tuple): The edge to ignore.

    Returns:
        int: The number of nodes visited.
    '
    vstd.add(n)
    for a in D[n]:
        if ((a not in vstd) and ((a, n) != i) and ((n, a) != i)):
            dfs(a, vstd, i)
    return len(vstd)
cnt = 0
for i in Edge:
    if (dfs(0, set(), i) < N):
        cnt += 1
print(cnt)


