# File changed


def extgcd(a, b):
    if b == 0:
        return 1
    else:
        x, y, u, v, k, l = 1, 0, 0, 1, a, b
        while l != 0:
            x, y, u, v = u, v, x - u * (k // l), y - v * (k // l)
            k, l = l, k % l
        return x

def inved(x, m):
    return x % m

def gcd(x, y):
    while y != 0:
        x, y = y, x % y
    return x

def doubling(n, m, mod):
    y = 1
    base = n
    while m != 0:
        if m % 2 == 1:
            y *= base
            y %= mod
        base *= base
        base %= mod
        m //= 2
    return y

def factorization(n):
    if n == 1:
        return {1: 1}
    else:
        d = {}
        base = n
        p = 2
        while n != 1:
            i = 0
            while n % p == 0:
                i += 1
                n //= p
            if i != 0:
                d[p] = i
            p += 1
            if (p * p > base) and (n != 1):
                d[n] = 1
                break
        return d

def Torshent(n):
    dic = factorization(n)
    s = n
    for i in dic:
        s //= i
        s *= i - 1
    return s

def bin_digits(n):
    cnt = 0
    while n != 0:
        cnt += 1
        n //= 2
    return cnt

def Resque(a, mod):
    if mod == 1:
        return 1
    M = Torshent(mod)
    mm = gcd(M, mod)
    r = Resque(a, mm)
    k = doubling(a, r, mod)
    m, modmod = M // mm, mod // mm
    tm = Torshent(modmod)
    invm = doubling(m, tm - 1, modmod)
    t = (k - r) // mm * invm
    r += t * M
    r %= (mod * M) // mm
    r += (mod * M) // mm
    return r

q = int(input())
for i in range(q):
    A, M = map(int, input().split())
    if M == 1:
        print(1)
    else:
        r = Resque(A, M)
        print(r)



