# File changed

import sys
from typing import Any, Callable, Deque, Dict, List, Mapping, Optional, Sequence, Set, Tuple, TypeVar, Union

def main():
    'Solves the problem
    '
    Num = Union[(int, float)]
    mod = 1000000007
    inf = float('inf')
    sys.setrecursionlimit((10 ** 6))

    def input():
        return sys.stdin.readline().rstrip()

    def ii():
        return int(input())

    def isp():
        return input().split()

    def mi():
        return map(int, input().split())

    def mi_0():
        return map((lambda x: (int(x) - 1)), input().split())

    def lmi():
        return list(map(int, input().split()))

    def lmi_0():
        return list(map((lambda x: (int(x) - 1)), input().split()))

    def li():
        return list(input())

    def debug(x):
        print(x, file=sys.stderr)

    def pattern_to_int(pattern):
        'Converts a pattern to an integer

        Args:
            pattern (list): The pattern to convert.

        Returns:
            int: The integer representation of the pattern.
        '
        size = len(pattern)
        num = 0
        for i in range(size):
            if pattern[i]:
                num += (1 << i)
        return num

    def calc_max_value(pattern_int):
        'Calculates the maximum value of a pattern

        Args:
            pattern_int (int): The integer representation of the pattern.

        Returns:
            int: The maximum value of the pattern.
        '
        total = 0
        for (num, value) in L:
            if ((pattern_int | num) == pattern_int):
                total += value
        return total

    def solve(pattern):
        'Solves the problem

        Args:
            pattern (list): The pattern to solve.

        Returns:
            int: The solution.
        '
        pattern_int = pattern_to_int(pattern)
        return calc_max_value(pattern_int)
    (n, k) = mi()
    L = [lmi() for _ in range(n)]
    ans = (- 1)
    d = k.bit_length()
    b = ([0] * 30)
    flag = []
    for i in range(d):
        if (k & (1 << i)):
            b[i] = 1
            flag.append(i)
    for i in flag:
        pattern = b[:]
        pattern[i] = 0
        for low in range(i):
            pattern[low] = 1
        ans = max(ans, solve(pattern))
    ans = max(ans, solve(b))
    print(ans)
if (__name__ == '__main__'):
    main()


