import pytest

@pytest.mark.parametrize('N, A, expected', [
    (1, 1, 0),
    (2, 3, 1),
    (3, 6, 3),
    (4, 10, 4),
    (5, 15, 9),
    (6, 21, 15),
    (7, 28, 21),
    (8, 36, 27),
    (9, 45, 36),
    (10, 55, 45),
    (11, 66, 56),
    (12, 78, 69),
    (13, 91, 84),
    (14, 105, 95),
    (15, 120, 111),
    (16, 136, 128),
    (17, 153, 145),
    (18, 171, 162),
    (19, 190, 181),
    (20, 210, 200),
])
def test_power_of_two(N, A, expected):
    assert (N**2-A) == expected

