# File changed

import itertools
import numpy as np
from scipy.sparse import csr_matrix
from scipy.sparse.csgraph import floyd_warshall
(n, *Z) = [int(_) for _ in open(0).read().split()]
a = []
b = []
c = []
for z in range((n * n)):
    (x, y) = divmod(z, n)
    a += [x]
    b += [y]
    c += [Z[z]]
g = csr_matrix((c, (a, b)), (n, n))
f = np.array(floyd_warshall(g, directed=1), dtype=np.int64)
Z = np.array(Z).reshape(n, n)
if np.all((f == Z)):
    ans = np.sum(Z)
    for (i, j) in itertools.product(range(n), repeat=2):
        ans -= (Z[(i, j)] * (np.sum(((Z[i] + Z[j]) == Z[(i, j)])) > 2))
    ans //= 2
    print(ans)
else:
    print((- 1))

