import pytest

@pytest.mark.parametrize('n, p, ans', [
    (1, [1], 0),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 2),
    (4, [1, 2, 3, 4], 3),
    (5, [1, 2, 3, 4, 5], 4),
    (6, [1, 2, 3, 4, 5, 6], 5),
    (7, [1, 2, 3, 4, 5, 6, 7], 6),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 7),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 8),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 9),
])
def test_that_swaps_are_correct(n, p, ans):
    assert (ans == 0)

