import pytest


@pytest.fixture
def N_M():
    return [int(x) for x in input().split()]


@pytest.fixture
def L():
    return [None] * M


@pytest.fixture
def set1():
    return set()


@pytest.fixture
def set2():
    return set()


def test_that_set1_and_set2_are_not_disjoint(set1, set2):
    assert not set1.isdisjoint(set2)


def test_that_set1_and_set2_are_disjoint(set1, set2):
    assert set1.isdisjoint(set2)


def test_that_set1_and_set2_are_disjoint_and_print_impossible(set1, set2):
    assert set1.isdisjoint(set2)
    print("IMPOSSIBLE")


def test_that_set1_and_set2_are_not_disjoint_and_print_possible(set1, set2):
    assert not set1.isdisjoint(set2)
    print("POSSIBLE")


def test_that_set1_and_set2_are_disjoint_and_print_impossible_and_set1_is_not_empty(set1, set2):
    assert set1.isdisjoint(set2)
    print("IMPOSSIBLE")
    assert set1


def test_that_set1_and_set2_are_disjoint_and_print_impossible_and_set2_is_not_empty(set1, set2):
    assert set1.isdisjoint(set2)
    print("IMPOSSIBLE")
    assert set2


def test_that_set1_and_set2_are_not_disjoint_and_print_possible_and_set1_is_not_empty(set1, set2):
    assert not set1.isdisjoint(set2)
    print("POSSIBLE")
    assert set1


def test_that_set1_and_set2_are_not_disjoint_and_print_possible_and_set2_is_not_empty(set1, set2):
    assert not set1.isdisjoint(set2)
    print("POSSIBLE")
    assert set2


def test_that_set1_and_set2_are_disjoint_and_print_impossible_and_set1_is_not_empty_and_set2_is_not_empty(set1, set2):
    assert set1.isdisjoint(set2)
    print("IMPOSSIBLE")
    assert set1
    assert set2


def test_that_set1_and_set2_are_not_disjoint_and_print_possible_and_set1_is_not_empty_and_set2_is_not_empty(set1, set2):
    assert not set1.isdisjoint(set2)
    print("POSSIBLE")
    assert set1
    assert set2


def test_that_set1_and_set2_are_disjoint_and_print_impossible_and_set1_is_empty(set1, set2):
    assert set1.isdisjoint(set