import pytest


@pytest.fixture
def n_k():
    return map(int, input().split())


@pytest.fixture
def A():
    return sorted(map(int, input().split()))


def gcd(a, b):
    if b == 0:
        return a
    return gcd(b, a % b)


def test_smallest_ball(A):
    smallest_ball = A[0]
    for a in A[1:]:
        smallest_ball = gcd(smallest_ball, a)
    return smallest_ball


def test_POSSIBLE_IMPOSSIBLE(n_k, A, smallest_ball):
    n, k = n_k
    print("POSSIBLE" if (A[-1]-k) %
          smallest_ball == 0 and k <= A[-1] else "IMPOSSIBLE")

