import pytest

@pytest.mark.parametrize('n, a, expected', [
    (1, '1 2 3 4 5', '5 3 1 2 4'),
    (2, '1 2 3 4 5', '4 2 1 3 5'),
    (3, '1 2 3 4 5', '5 3 1 2 4'),
    (4, '1 2 3 4 5', '4 2 1 3 5'),
    (5, '1 2 3 4 5', '5 3 1 2 4'),
])
def test_that_api_returns_some_results(n, a, expected):
    if n%2:
      assert (" ".join(a[::-2]+a[1::2]) == expected)
    else:
      assert (" ".join(a[-1:0:-2]+a[::2]) == expected)

