'
# File changed

import math


def factorial(n):
    'Calculates the factorial of a number

    Args:
        n (int): The number to calculate the factorial of.

    Returns:
        int: The factorial of the number.
    '
    return math.factorial(n) % ((10 ** 9) + 7)


(N, M) = map(int, input().split())
if (abs((N - M)) > 1):
    print(0)
elif (abs((N - M)) == 1):
    n = factorial(N)
    m = factorial(M)
    print(((n * m) % ((10 ** 9) + 7)))
else:
    n = factorial(N)
    m = factorial(M)
    print((((2 * n) * m) % ((10 ** 9) + 7)))


