import math
import pytest

@pytest.fixture
def n():
    return

@pytest.fixture
def a():
    return

@pytest.fixture
def b():
    return

@pytest.fixture
def H():
    return

def f(k):
    count = 0
    for i in range(n):
        count += math.ceil(max(0, H[i] - k * b) / (a - b))
    if count <= k:
        return True
    else:
        return False

@pytest.mark.parametrize('left,right', [(1, 10 ** 9)])
def test_that_left_and_right_are_correct(left, right):
    assert left < right

@pytest.mark.parametrize('k', [(left + right) // 2])
def test_that_k_is_correct(k):
    assert k > 0

@pytest.mark.parametrize('count', [f(k)])
def test_that_count_is_correct(count):
    assert count > 0

@pytest.mark.parametrize('left,right', [(left, k), (k + 1, right)])
def test_that_left_and_right_are_correct(left, right):
    assert left < right

@pytest.mark.parametrize('k', [(left + right) // 2])
def test_that_k_is_correct(k):
    assert k > 0

@pytest.mark.parametrize('count', [f(k)])
def test_that_count_is_correct(count):
    assert count > 0

@pytest.mark.parametrize('left,right', [(left, k), (k + 1, right)])
def test_that_left_and_right_are_correct(left, right):
    assert left < right

@pytest.mark.parametrize('k', [(left + right) // 2])
def test_that_k_is_correct(k):
    assert k > 0

@pytest.mark.parametrize('count', [f(k)])
def test_that_count_is_correct(count):
    assert count > 0

@pytest.mark.parametrize('left,right', [(left, k), (k + 1, right)])
def test_that_left_and_right_are_correct(left, right):
    assert left < right

@pytest.mark.parametrize('k', [(left + right) // 2])
def test_that_k_is_correct(k):
    assert k > 0

@pytest.mark.parametrize('count', [f(k)])
def test_that_count_is_correct(count):
    assert count > 0

@pytest.mark.parametrize('left,right', [(left, k), (k + 1, right)])
def test_that_left_and_right_are_correct(left, right):
    assert left < right

@pytest.mark.parametrize('k', [(left + right) // 2])
def test_that_k_is_correct(k):
    assert k > 0

@pytest.mark.parametrize('count', [f(k)])
def test_that_count_is_correct(count):
    assert count > 0

@pytest.mark.parametrize('left,right', [(left, k), (k + 1, right)])
def test_that_left_and_right_are