import numpy as np

N, m, Q = map(int, input().split())
s = np.zeros(((N + 1), (m + 1)), dtype='float32')
for n in range(1, (N + 1)):
  s[(n, 1:)] = list(map(int, list(input())))
ncum = np.cumsum(np.cumsum(s, axis=0), axis=1)
ercum = np.cumsum(np.cumsum((s[(:N, :)] * s[(1:, :)]), axis=0), axis=1)
eccum = np.cumsum(np.cumsum((s[(:, :m)] * s[(:, 1:)]), axis=0), axis=1)
sollist = []
for _ in range(Q):
  x1, y1, x2, y2 = map(int, input().split())
  nnodes = (((ncum[(x2, y2)] - ncum[((x1 - 1), y2)]) - ncum[(x2, (y1 - 1))]) + ncum[((x1 - 1), (y1 - 1))])
  nedges1 = (((ercum[((x2 - 1), y2)] - ercum[((x1 - 1), y2)]) - ercum[((x2 - 1), (y1 - 1))]) + ercum[((x1 - 1), (y1 - 1))])
  nedges2 = (((eccum[(x2, (y2 - 1))] - eccum[((x1 - 1), (y2 - 1))]) - eccum[(x2, (y1 - 1))]) + eccum[((x1 - 1), (y1 - 1))])
  sollist.append(((nnodes - nedges1) - nedges2))
for q in range(Q):
  print(int(sollist[q]))

