import pytest

@pytest.mark.parametrize('a, b, c, expected', [
    (1, 2, 3, 'Yes'),
    (1, 2, 4, 'No'),
    (1, 2, 1, 'Yes'),
    (1, 2, 2, 'Yes'),
    (1, 2, 0, 'No'),
    (1, 2, -1, 'No'),
])
def test_range_check(a, b, c, expected):
    if a <= c and c <= b:
        assert expected == 'Yes'
    else:
        assert expected == 'No'

