import pytest

@pytest.mark.parametrize('N, T, t, expected', [
    (1, 1, [1], 1),
    (2, 1, [1, 2], 2),
    (2, 2, [1, 2], 3),
    (3, 1, [1, 2, 3], 4),
    (3, 2, [1, 2, 3], 5),
    (3, 3, [1, 2, 3], 6),
    (3, 4, [1, 2, 3], 7),
    (4, 1, [1, 2, 3, 4], 5),
    (4, 2, [1, 2, 3, 4], 6),
    (4, 3, [1, 2, 3, 4], 7),
    (4, 4, [1, 2, 3, 4], 8),
    (4, 5, [1, 2, 3, 4], 9),
    (5, 1, [1, 2, 3, 4, 5], 6),
    (5, 2, [1, 2, 3, 4, 5], 7),
    (5, 3, [1, 2, 3, 4, 5], 8),
    (5, 4, [1, 2, 3, 4, 5], 9),
    (5, 5, [1, 2, 3, 4, 5], 10),
    (5, 6, [1, 2, 3, 4, 5], 11),
])
def test_that_the_answer_is_correct(N, T, t, expected):
    assert (solve(N, T, t) == expected)

