import pytest

@pytest.mark.parametrize('N,T,ts,expected', [
    (1, 1, [1], 2),
    (2, 1, [1, 2], 3),
    (2, 2, [1, 2], 4),
    (3, 1, [1, 2, 3], 5),
    (3, 2, [1, 2, 3], 6),
    (3, 3, [1, 2, 3], 7),
    (4, 1, [1, 2, 3, 4], 8),
    (4, 2, [1, 2, 3, 4], 9),
    (4, 3, [1, 2, 3, 4], 10),
    (4, 4, [1, 2, 3, 4], 11),
    (5, 1, [1, 2, 3, 4, 5], 12),
    (5, 2, [1, 2, 3, 4, 5], 13),
    (5, 3, [1, 2, 3, 4, 5], 14),
    (5, 4, [1, 2, 3, 4, 5], 15),
    (5, 5, [1, 2, 3, 4, 5], 16),
])
def test_that_the_correct_result_is_returned(N, T, ts, expected):
    ret = 0
    for ind in range(1, N):
        ret += min(T, ts[ind] - ts[ind - 1])
    assert ret + T == expected

