# File changed

import bisect
import heapq
import math
import random
import sys
from collections import Counter, defaultdict, deque
from decimal import ROUND_CEILING, ROUND_HALF_UP, Decimal
from functools import lru_cache, reduce
from itertools import combinations, combinations_with_replacement, product, permutations
from operator import add, mul, sub
sys.setrecursionlimit(10000)

def read_int():
    return int(input())

def read_int_n():
    return list(map(int, input().split()))

def read_float():
    return float(input())

def read_float_n():
    return list(map(float, input().split()))

def read_str():
    return input().strip()

def read_str_n():
    return list(map(str, input().split()))

def error_print(*args):
    print(*args, file=sys.stderr)

def mt(f):
    import time

    def wrap(*args, **kwargs):
        s = time.time()
        ret = f(*args, **kwargs)
        e = time.time()
        error_print((e - s), 'sec')
        return ret
    return wrap

@mt
def slv(N, M, AB):
    g = defaultdict(set)
    for (a, b) in AB:
        g[a].add(b)
        g[b].add(a)
    path = deque([1])
    path.append(list(g[1])[0])
    path_s = set(path)
    while (not (g[path[0]] | g[path[(- 1)]]).issubset(path_s)):
        l = (g[path[0]] - path_s)
        if l:
            for v in l:
                path.appendleft(v)
                path_s.add(v)
                break
            continue
        r = (g[path[(- 1)]] - path_s)
        if r:
            for v in r:
                path.append(v)
                path_s.add(v)
                break
            continue
    print(len(path))
    print(' '.join(map((lambda x: str(x)), path)))

def main():
    (N, M) = read_int_n()
    AB = []
    for _ in range(M):
        AB.append(read_int_n())
    slv(N, M, AB)
if (__name__ == '__main__'):
    main()


