import pytest


@pytest.fixture
def n_m():
    return map(int, input().split())


@pytest.fixture
def node():
    return [[] for _ in range(n + 1)]


@pytest.fixture
def a_b():
    return map(int, input().split())


@pytest.fixture
def q():
    return int(input())


@pytest.fixture
def node_color():
    return [0 for _ in range(n + 1)]


@pytest.fixture
def vdc():
    return [list(map(int, input().split())) for _ in range(q)]


@pytest.fixture
def painted():
    return set()


@pytest.fixture
def visited():
    return [[0] * 11 for _ in range(n + 1)]


def dfs(now, dist, color):
    if dist < 0:
        return
    if visited[now][dist]:
        return

    visited[now][dist] += 1
    if not node_color[now]:
        node_color[now] = color

    for x in node[now]:
        dfs(x, dist - 1, color)


def test_dfs(node, a_b, q, node_color, vdc, painted, visited):
    for i in vdc:
        v, d, c = i
        dfs(v, d, c)

    for m in range(n):
        print(node_color[m + 1])


