'
# File changed

from bisect import bisect_left, bisect_right

def solve():
    'Solves the problem

    Args:
        None

    Returns:
        None
    '
    (N, K) = map(int, input().split())
    As = list(map(int, input().split()))
    As.sort()
    i = bisect_left(As, K)
    Bs = As[:i]
    M = len(Bs)

    def isOK(x):
        'Checks if the value is OK

        Args:
            x (int): The value to check

        Returns:
            bool: True if the value is OK, False otherwise
        '
        bitset = (1 << (K - 1))
        for (i, B) in enumerate(Bs):
            if (i == x):
                continue
            bitset |= (bitset >> B)
        return (bitset & ((1 << Bs[x]) - 1))
    (ng, ok) = ((- 1), M)
    while (abs((ok - ng)) > 1):
        mid = ((ng + ok) // 2)
        if isOK(mid):
            ok = mid
        else:
            ng = mid
    print(ok)
solve()


