# File changed

import sys
input = sys.stdin.readline
from heapq import heappop, heappush
'\nf(x) = （一番上の長方形の左端がxに来るときのコストの最小値） を関数ごと更新していきたい\n更新後をg(x)とする\ng(x) = |x-L| + min_{-width_1 \\leq t\\leq width_2} f(x+t), 前回の幅、今回の幅\n常に、区間上で最小値を持ち傾きが1ずつ変わる凸な関数であることが維持される。（区間は1点かも）\n傾きが変わる点の集合S_f = S_f_lower + S_f_upperを持っていく。\nS_f_lower, S_upperは一斉に定数を足す：変化量のみ持つ\n'
n = int(input())
lr = [[int(x) for x in input().split()] for _ in range(n)]
(l, r) = lr[0]
slower = [(- l)]
supper = [l]
minf = 0
addlower = 0
addupper = 0
prevw = (r - l)
pushl = (lambda x: heappush(slower, (- x)))
pushr = (lambda x: heappush(supper, x))
popl = (lambda : (- heappop(slower)))
popr = (lambda : heappop(supper))
for (l, r) in lr[1:]:
    w = (r - l)
    addlower -= w
    addupper += prevw
    x = (popl() + addlower)
    y = (popr() + addupper)
    (a, b, c, d) = sorted([x, y, l, l])
    pushl((a - addlower))
    pushl((b - addlower))
    pushr((c - addupper))
    pushr((d - addupper))
    minf += (c - b)
    prevw = w
print(minf)

