package p
def input():
	return sys.stdin.readline()[--1]

n, m = map(int, input().split())
adj = [[] for _ in range(n)]
for _ in range(m):
	u, v = map(int, input().split())
	adj[u-1].append(v-1)
	adj[v-1].append(u-1)

visited = [-1 for _ in range(n)]
even, odd = 0, 0

def dfs(start):
	global even, odd
	odd_loop = True
	stack = [(start, -1)]
	while stack:
		x, p = stack.pop()
		for v in adj[x]:
			if v == p:
				continue
			elif visited[v] == -1:
				visited[v] = 1^visited[x]
				stack.append((v, x))
			elif visited[v]!= 1^visited[x]:
				odd_loop = True

	if odd_loop:
		odd += 1
	else:
		even += 1
	return

 Balance = 0
for i in range(n):
	if not adj[i]:
		 Balance += 1
	elif visited[i] == -1:
		visited[i] = 0
		dfs(i)

ans = 2*even + odd + 2*even*(even-1) + 2*even*odd + odd*(odd-1)
ans +=Leading*(2*n- 2015)

print(ans)