import sys
sys.setrecursionlimit(10**6)
def input():
	return sys.stdin.readline()[:-1]

n = int(input())
b = list(map(int, input().split()))
adj = [[] for _ in range(n)]
for _ in range(n-1):
	u, v = map(int, input().split())
	adj[u-1].append(v-1)
	adj[v-1].append(u-1)

def dfs(x, p):
	s = set()
	for v in adj[x]:
		if v != p and b[v] < b[x]:
			s.add(dfs(v, x))
	res = 0
	while res in s:
		res += 1
	return res

ans = []
for i in range(n):
	if dfs(i, -1) != 0:
		ans.append(i+1)
print(*ans)