# File changed

import sys
import numpy as np
import numba
from numba import njit, b1, i4, i8, f8
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit((i8[:], i8), cache=True)
def get_sum(bit, i):
    s = 0
    while i:
        s += bit[i]
        i -= (i & (- i))
    return s

@njit((i8[:], i8, i8), cache=True)
def add(bit, i, x):
    while (i < len(bit)):
        bit[i] += x
        i += (i & (- i))

@njit((i8, i8[:]), cache=True)
def main(m, lr):
    (l, r) = (lr[::2], lr[1::2])
    r = (r + 1)
    d = (r - l)
    argsort = np.argsort(d)
    (l, r, d) = (l[argsort], r[argsort], d[argsort])
    idx = np.searchsorted(d, np.arange((m + 2)))
    bit = np.zeros((m + 10), np.int64)
    rest = len(l)
    for d in range(1, (m + 1)):
        for i in range(idx[d], idx[(d + 1)]):
            rest -= 1
            add(bit, l[i], 1)
            add(bit, r[i], (- 1))
        ans = rest
        for n in range(d, (m + 1), d):
            ans += get_sum(bit, n)
        print(ans)
(n, m) = map(int, readline().split())
lr = np.array(read().split(), np.int64)
main(m, lr)



