# File changed

import sys
import numpy as np
import numba
from numba import njit, b1, i4, i8
from numba.types import Omitted
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
mod = 1000000007

@njit((i8, i8), cache=True)
def main(N, K):
    K -= 1
    u = 2010
    c = np.zeros((u, u), np.int64)
    c[(0, 0)] = 1
    for n in range(1, u):
        c[n] += c[(n - 1)]
        c[(n, 1:)] += c[((n - 1), :(- 1))]
        c[n] %= mod
    dp = np.zeros(((N + 10), (N + 10)), np.int64)
    dp[(0, 0)] = 1
    for n in range(1, (N + 10)):
        dp[(n, n)] = ((dp[((n - 1), (n - 1))] + dp[((n - 1), n)]) % mod)
        for m in range((n + 1), (N + 10)):
            dp[(n, m)] = ((dp[((n - 1), m)] + dp[(n, (m - 1))]) % mod)
    for n in range((N + 9), 0, (- 1)):
        dp[n] -= dp[(n - 1)]
        dp[n] %= mod
    ans = 0
    if (K == (N - 1)):
        return (dp[(:N, (N - 1))].sum() % mod)
    for r in range((N - K), (N + 1)):
        x = c[((r - 2), ((N - K) - 2))]
        a = (N - r)
        b = (K - a)
        if (b == 0):
            x = ((x * (dp[(:(a + 1), a)].sum() % mod)) % mod)
        else:
            x *= (((dp[(1:(a + 2), (a + 1))] * c[((b - 1):(a + b), (b - 1))][::(- 1)]) % mod).sum() % mod)
            x %= mod
        ans += x
    ans %= mod
    for i in range(((N - K) - 2)):
        ans = ((ans * 2) % mod)
    return (ans % mod)
(N, K) = map(int, read().split())
print(main(N, K))

