import pytest

@pytest.mark.parametrize("N, S, expected", [
    (1, "I", 1),
    (2, "II", 2),
    (3, "III", 3),
    (4, "IIII", 4),
    (5, "IIIII", 5),
    (6, "IIIIII", 6),
    (7, "IIIIIII", 7),
    (8, "IIIIIIII", 8),
    (9, "IIIIIIIII", 9),
    (10, "IIIIIIIIII", 10),
    (11, "IIIIIIIIIII", 11),
    (12, "IIIIIIIIIIII", 12),
    (13, "IIIIIIIIIIIII", 13),
    (14, "IIIIIIIIIIIIII", 14),
    (15, "IIIIIIIIIIIIIII", 15),
    (16, "IIIIIIIIIIIIIIII", 16),
    (17, "IIIIIIIIIIIIIIIII", 17),
    (18, "IIIIIIIIIIIIIIIIII", 18),
    (19, "IIIIIIIIIIIIIIIIIII", 19),
    (20, "IIIIIIIIIIIIIIIIIIII", 20),
    (21, "IIIIIIIIIIIIIIIIIIIII", 21),
    (22, "IIIIIIIIIIIIIIIIIIIIII", 22),
    (23, "IIIIIIIIIIIIIIIIIIIIIII", 23),
    (24, "IIIIIIIIIIIIIIIIIIIIIIII", 24),
    (25, "IIIIIIIIIIIIIIIIIIIIIIIII", 25),
    (26, "IIIIIIIIIIIIIIIIIIIIIIIIII", 26),
    (27, "IIIIIIIIIIIIIIIIIIIIIIIIIII", 27),
    (28, "IIIIIIIIIIIIIIIIIIIIIIIIIIII", 28),
    (29, "IIIIIIIIIIIIIIIIIIIIIIIIIIIII", 29),
    (30, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 30),
    (31, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 31),
    (32, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 32),
    (33, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 33),
    (34, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 34),
    (35, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 35),
    (36, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 36),
    (37, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 37),
    (38, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 38),
    (39, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 39),
    (40, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 40),
    (41, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 41),
    (42, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 42),
    (43, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 43),
    (44, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 44),
    (45, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 45),
    (46, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 46),
    (47, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 47),
    (48, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 48),
    (49, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 49),
    (50, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 50),
    (51, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 51),
    (52, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 52),
    (53, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 53),
    (54, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 54),
    (55, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 55),
    (56, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 56),
    (57, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII", 57),
    (58, "IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII