' File changed

import math

def factorial(n):
    ' Calculates the factorial of a number

    Args:
        n (int): The number to calculate the factorial of.

    Returns:
        int: The factorial of the number.
    '
    if n == 0:
        return 1
    else:
        return n * factorial(n - 1)

N = int(input())
mod = ((10 ** 9) + 7)
nFact = factorial(N)
i = 2
ans = 1
while ((i * i) <= nFact):
    cnt = 1
    while ((nFact % i) == 0):
        cnt += 1
        nFact //= i
    ans *= cnt
    i += 1
if (nFact != 1):
    ans *= 2
print((ans % mod))


