from collections import Counter

def solver(N, A):
    cnt = Counter(A)
    x = 1
    if N%2 == 1:
        if cnt[0] != 1:
            return 0
        x = 2
    for i in range(x, N, 2):
        if cnt[i] != 2:
            return 0
    
    return pow(2, N//2, 10**9+7)

def test_solver():
    assert (solver(1, [0]) == 1)
    assert (solver(2, [0, 1]) == 2)
    assert (solver(2, [1, 0]) == 2)
    assert (solver(3, [0, 1, 2]) == 4)
    assert (solver(3, [0, 2, 1]) == 4)
    assert (solver(3, [1, 0, 2]) == 4)
    assert (solver(3, [1, 2, 0]) == 4)
    assert (solver(3, [2, 0, 1]) == 4)
    assert (solver(3, [2, 1, 0]) == 4)
    assert (solver(4, [0, 1, 2, 3]) == 8)
    assert (solver(4, [0, 1, 3, 2]) == 8)
    assert (solver(4, [0, 2, 1, 3]) == 8)
    assert (solver(4, [0, 2, 3, 1]) == 8)
    assert (solver(4, [0, 3, 1, 2]) == 8)
    assert (solver(4, [0, 3, 2, 1]) == 8)
    assert (solver(4, [1, 0, 2, 3]) == 8)
    assert (solver(4, [1, 0, 3, 2]) == 8)
    assert (solver(4, [1, 2, 0, 3]) == 8)
    assert (solver(4, [1, 2, 3, 0]) == 8)
    assert (solver(4, [1, 3, 0, 2]) == 8)
    assert (solver(4, [1, 3, 2, 0]) == 8)
    assert (solver(4, [2, 0, 1, 3]) == 8)
    assert (solver(4, [2, 0, 3, 1]) == 8)
    assert (solver(4, [2, 1, 0, 3]) == 8)
    assert (solver(4, [2, 1, 3, 0]) == 8)
    assert (solver(4, [2, 3, 0, 1]) == 8)
    assert (solver(4, [2, 3, 1, 0]) == 8)
    assert (solver(4, [3, 0, 1, 2]) == 8)
    assert (solver(4, [3, 0, 2, 1]) == 8)
    assert (solver(4, [3, 1, 0, 2]) == 8)
    assert (solver(4, [3, 1, 2, 0]) == 8)
