# File changed

from scipy.sparse.csgraph import csgraph_from_dense, dijkstra
import numpy as np
import sys
read = sys.stdin.read
readline = sys.stdin.readline
readlines = sys.stdin.readlines

def main():
    (xs, ys, xt, yt) = map(int, readline().split())
    a = np.array([[xs, ys, 0], [xt, yt, 0]], dtype=np.int)
    n = int(readline())
    b = np.array(read().split(), dtype=np.int).reshape((-1), 3)
    (xy, r) = np.hsplit(np.concatenate((a, b)), [2])
    d = (np.expand_dims(xy, axis=1) - np.expand_dims(xy, axis=0))
    d = np.sqrt(np.sum((d ** 2), axis=(-1)))
    d -= (r + r.reshape(1, (-1)))
    d = np.maximum(d, 0)
    np.fill_diagonal(d, (-1))
    d = csgraph_from_dense(d, null_value=(-1))
    ans = dijkstra(d, indices=0)[1]
    print(ans)
if __name__ == '__main__':
    main()

