# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
from operator import itemgetter
(N, q) = map(int, readline().split())
m = map(int, read().split())
abc = list(zip(m, m, m))
inf = (10 ** 18)
cycliccost = ([inf] * N)
for (a, b, c) in abc:
    if (cycliccost[a] > (c + 1)):
        cycliccost[a] = (c + 1)
    if (cycliccost[b] > (c + 2)):
        cycliccost[b] = (c + 2)
cycliccost += cycliccost
x = inf
for i in range((N + N)):
    x += 2
    if (x < cycliccost[i]):
        cycliccost[i] = x
    x = cycliccost[i]
cycliccost = [(x if (x < y) else y) for (x, y) in zip(cycliccost, cycliccost[N:])]
abc += [(i, (i + 1), c) for (i, c) in enumerate(cycliccost)]
abc[(- 1)] = ((N - 1), 0, cycliccost[(- 1)])

class UnionFind():

    def __init__(self, N):
        self.root = list(range(N))
        self.size = ([1] * N)

    def find_root(self, x):
        root = self.root
        while (root[x] != x):
            root[x] = root[root[x]]
            x = root[x]
        return x

    def merge(self, x, y):
        x = self.find_root(x)
        y = self.find_root(y)
        if (x == y):
            return False
        (sx, sy) = (self.size[x], self.size[y])
        if (sx < sy):
            self.root[x] = y
            self.size[y] += sx
        else:
            self.root[y] = x
            self.size[x] += sy
        return True
abc.sort(key=itemgetter(2))
uf = UnionFind(N)
merge = uf.merge
answer = 0
for (a, b, c) in abc:
    if merge(a, b):
        answer += c
print(answer)

