' Find the maximum profit
'
import numpy as np

def find_max_profit(A):
    'Find the maximum profit

    Args:
        A (list): A list of integers.

    Returns:
        int: The maximum profit.
    '
    (N, T) = map(int, input().split())
    A = np.array(list(map(int, input().split())))
    A_cummin = np.minimum.accumulate(A)
    profit = (A - A_cummin)
    ans = (profit == profit.max()).sum()
    return ans


