# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
sys.setrecursionlimit((10 ** 7))
import numpy as np
MOD = 924844033

def cumprod(arr, MOD):
    l = len(arr)
    lsq = int(((l ** 0.5) + 1))
    arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
    for n in range(1, lsq):
        arr[(:, n)] *= arr[(:, (n - 1))]
        arr[(:, n)] %= MOD
    for n in range(1, lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:l]

def make_fact(U, MOD):
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    factinv = cumprod(x, MOD)[::(- 1)]
    return (fact, factinv)
(N, K) = map(int, readline().split())
dp0 = np.zeros(((N + 1), (N + 1)), np.int64)
dp1 = np.zeros(((N + 1), (N + 1)), np.int64)
dp2 = np.zeros(((N + 1), (N + 1)), np.int64)
dp0[(0, 0)] = 1
dp1[(0, 0)] = 1
dp2[(0, 0)] = 1
for n in range(1, (N + 1)):
    dp1[(n, 1:)] += dp1[((n - 1), :(- 1))]
    dp2[(n, 1:)] += dp2[((n - 1), :(- 1))]
    if (n >= 2):
        dp0[(n, 1:)] += dp0[((n - 1), :(- 1))]
        dp1[(n, 1:)] += dp0[((n - 1), :(- 1))]
    dp2[(n, 1:)] += dp1[((n - 1), :(- 1))]
    dp0[n] += dp1[(n - 1)]
    dp1[n] += dp1[(n - 1)]
    dp2[n] += dp2[(n - 1)]
    dp0[n] %= MOD
    dp1[n] %= MOD
    dp2[n] %= MOD

def F(N, K, n):
    items = (((N - n) // (2 * K)) + 1)
    last = (n + ((items - 1) * (2 * K)))
    x = (((n - K) > 0) + ((last + K) <= N))
    arr = (dp0 if (x == 0) else (dp1 if (x == 1) else dp2))
    return arr[items][:(items + 1)]

def convolve(x, y):
    lx = len(x)
    ly = len(y)
    if (lx < ly):
        (x, y) = (y, x)
        (lx, ly) = (ly, lx)
    arr = np.zeros(((lx + ly) - 1), np.int64)
    for n in range(ly):
        arr[n:(n + lx)] += ((y[n] * x) % MOD)
    arr %= MOD
    return arr
x = np.array([1], np.int64)
for n in range(1, ((2 * K) + 1)):
    if (n > N):
        break
    x = convolve(x, F(N, K, n))
(fact, _) = make_fact((N + 100), MOD)
l = len(x)
x[1::2] *= (- 1)
answer = (((x[::(- 1)] * fact[((N - l) + 1):(N + 1)]) % MOD).sum() % MOD)
print(answer)

