# File changed

from collections import defaultdict
import sys
sys.setrecursionlimit((10 ** 6))

def ReadInput():
  return [int(i) for i in input().split(' ')]

(R, C) = ReadInput()
n = int(input())
vectorset = set()
grid = defaultdict(list)

for i in range(n):
  (r, c, a) = ReadInput()
  grid[('R', r)].append((('C', c), a))
  grid[('C', c)].append((('R', r), a))
  vectorset.add(('R', r))
  vectorset.add(('C', c))

def iteration(vector):
  vectorset.discard(vector)
  for (v, a) in grid[vector]:
    temp = (a - vectorcover[vector])
    if (v in vectorcover):
      if (temp != vectorcover[v]):
        print('No')
        exit()
    else:
      vectorcover[v] = temp
      iteration(v)

while (len(vectorset) != 0):
  vector = vectorset.pop()
  vectorcover = dict()
  vectorcover[vector] = 0
  iteration(vector)
  minr = min((a for (p, a) in vectorcover.items() if (p[0] == 'R')))
  minc = min((a for (p, a) in vectorcover.items() if (p[0] == 'C')))
  if ((minr + minc) < 0):
    print('No')
    exit()
print('Yes')

