# File changed

import sys
input = sys.stdin.readline
from collections import defaultdict
'\n(駅、会社)を頂点にグラフを持つ。頂点数O(M)。\nそのまま辺を貼ると辺が多くなりすぎる。\n(駅、会社) -> (駅、無属性) -> (駅、会社)\n'
l = 32
mask = ((1 << l) - 1)
(n, m) = map(int, input().split())
graph = defaultdict(list)
for _ in range(m):
    (p, q, c) = map(int, input().split())
    p <<= l
    q <<= l
    graph[p].append((p + c))
    graph[(p + c)].append(p)
    graph[q].append((q + c))
    graph[(q + c)].append(q)
    graph[(p + c)].append((q + c))
    graph[(q + c)].append((p + c))
inf = (10 ** 9)
dist = defaultdict((lambda : inf))
start = (1 << l)
goal = (n << l)
q = [start]
dist[start] = 0
d = 0
q0 = []
q1 = []
while q:
    for x in q:
        if ((x & mask) == 0):
            for y in graph[x]:
                if (dist[y] <= (d + 1)):
                    continue
                dist[y] = (d + 1)
                q1.append(y)
        else:
            for y in graph[x]:
                if (dist[y] <= d):
                    continue
                dist[y] = d
                q0.append(y)
    if q0:
        q = q0
        q0 = []
        continue
    q = q1
    q1 = []
    d += 1
answer = dist[goal]
if (answer == inf):
    answer = (- 1)
print(answer)



