' File changed

import sys
MAX = 1000000

def digit_sum(n, b):
    ' Calculates the sum of the digits of a number in a given base

    Args:
        n (int): The number to calculate the digit sum for.
        b (int): The base to calculate the digit sum in.

    Returns:
        int: The digit sum of n in base b.
    '
    if (n == 0):
        return 0
    else:
        return (digit_sum((n // b), b) + (n % b))

def main():
    ' Main function
    '
    n = int(input())
    s = int(input())
    if (n < s):
        print((- 1))
        sys.exit()
    ans = (- 1)
    for b in range(2, (min((n + 1), MAX) + 1)):
        sm = digit_sum(n, b)
        if (sm == s):
            ans = b
            break
    if (ans != (- 1)):
        print(ans)
        sys.exit()
    if ((n + 1) <= MAX):
        print((- 1))
        sys.exit()
    for p in reversed(range(1, MAX)):
        if (((n - s) % p) != 0):
            continue
        b = (((n - s) // p) + 1)
        if (b < 2):
            continue
        sm = digit_sum(n, b)
        if (sm == s):
            ans = b
            break
    if (ans != (- 1)):
        print(ans)
        sys.exit()
    if (n == s):
        print((n + 1))
        sys.exit()
    print((- 1))
if (__name__ == '__main__'):
    main()


