import pytest

@pytest.mark.parametrize('n, l, a, expected', [
    (1, 1, [1], 'Possible\n1\n'),
    (2, 1, [1, 1], 'Possible\n1\n2\n'),
    (2, 2, [1, 1], 'Possible\n1\n2\n'),
    (2, 3, [1, 1], 'Impossible\n'),
    (3, 1, [1, 1, 1], 'Possible\n1\n2\n3\n'),
    (3, 2, [1, 1, 1], 'Possible\n1\n2\n3\n'),
    (3, 3, [1, 1, 1], 'Possible\n1\n2\n3\n'),
    (3, 4, [1, 1, 1], 'Possible\n1\n2\n3\n'),
    (3, 5, [1, 1, 1], 'Impossible\n'),
    (4, 1, [1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n'),
    (4, 2, [1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n'),
    (4, 3, [1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n'),
    (4, 4, [1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n'),
    (4, 5, [1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n'),
    (4, 6, [1, 1, 1, 1], 'Impossible\n'),
    (5, 1, [1, 1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n5\n'),
    (5, 2, [1, 1, 1, 1, 1], 'Possible\n1\n2\n3\n4\n