import pytest

@pytest.mark.parametrize('n,l,a,expected', [
    (1, 1, ['a'], 'a'),
    (2, 2, ['a', 'b'], 'ab'),
    (3, 3, ['a', 'b', 'c'], 'abc'),
])
def test_sort_and_join(n, l, a, expected):
    a.sort()
    assert ''.join(a) == expected

